(function () {

    var app = angular.module('mPOWER');

    var LPGHomeController = function ($scope, userService, $ionicPopup, $http, $timeout, $ionicLoading, $state) {

        $scope.appList = [{
            appId: "My Profile",
            viewName: "LPGProfile",
            icon: "ion-person",
            show: "ALL"
        },
        {
            appId: "Distributor Profile",
            viewName: "LPGDist",
            icon: "ion-person-stalker",
            show: "FO"
        },
        {
            appId: "Consumer Info",
            viewName: "LPGProfileSumary",
            icon: "ion-ios-paper",
            show: "NFO"
        },
        {
            appId: "Distributor Dashboard",
            viewName: "LPGDistDB",
            icon: "ion-person-stalker",
            show: "NFO"
        },
        {
            appId: "Balance",
            viewName: "LPGBalance",
            icon: "ion-cash",
            show: "FO"
        },
        {
            appId: "Order Status",
            viewName: "LPGOrder",
            icon: "ion-android-cart",
            show: "FO"
        },
        {
            appId: "Sales",
            viewName: "LPGSales",
            icon: "ion-stats-bars",
            show: "ALL"
        },
        {
            appId: "RTD",
            viewName: "LPGRTD",
            icon: "ion-refresh",
            show: "FO"
        },
        {
            appId: "EOD Status",
            viewName: "LPGEodStatus",
            icon: "ion-clock",
            show: "FO"
        },
        {
            appId: "EOD Summary",
            viewName: "LPGEodSummary",
            icon: "ion-clock",
            show: "NFO"
        },
        {
            appId: "Stock Report",
            viewName: "LPGStock",
            icon: "ion-soup-can",
            show: "FO"
        },
        {
            appId: "NFR Report",
            viewName: "LPGNFRReport",
            icon: "ion-cube",
            show: "FO"
        },
        {
            appId: "Indane Online Reports",
            viewName: "LPGIndane",
            icon: "ion-flame",
            show: "FO"
        },
        {
            appId: "Social Media Complaints",
            viewName: "LPGSocial",
            icon: "ion-social-facebook",
            show: "FO"
        }];

        $scope.$on('$ionicView.enter', function () {
            $scope.employee = userService.getUser();
            console.log($scope.appList);


        });

        $scope.startApp = function (viewName) {
            console.log(viewName);
            userService.setpreviousView('LPGHome');
            $state.go(viewName);
        }

        $scope.logOut = function () {
            $ionicLoading.show({
                template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
            });
            window.localStorage.setItem('empCode', "");
            window.localStorage.setItem('empPassword', "");
            $state.go('login');
            $timeout(function () {
                $ionicLoading.hide();
            }, 2000);
        }
    }

    var LPGProfileController = function ($scope, userService, $ionicPopup, $http, $timeout, $ionicLoading, $state) {

        $scope.$on('$ionicView.enter', function () {
            $scope.employee = userService.getUser();
        });

        $scope.goHome = function () {
            $state.go("LPGHome");
        }
    }

    var LPGDistController = function ($scope, userService, $ionicPopup, $http, $timeout, $ionicLoading, $state) {


        $ionicLoading.show({
            template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
        });
        $scope.$on('$ionicView.enter', function () {
            $scope.error = false;
            $scope.employee = userService.getUser();
            $scope.profileList = [];
            $scope.profileView = false;
            $scope.currentDistProfile = {};

            $scope.totalInfo = {
                TOTAL_ACTIVE_CUST: 0,
                DBC: 0,
                CTC: 0,
                GIVE_IT_UP: 0
            };

            $scope.distSearch = {
                text: ""
            };

            try {
                $http.get("https://xsparsh.indianoil.in:8443/LPGMobile/DistProfile?sales_group=" + $scope.employee.salesGroup)
                    .success(function (data, status) {
                        try {
                            $scope.profileList = data;
                            for (var ii = 0; ii < $scope.profileList.length; ii++) {
                                if ($scope.profileList[ii].TOTAL_ACTIVE_CUST == null
                                    || $scope.profileList[ii].TOTAL_ACTIVE_CUST == "null") {
                                    $scope.profileList[ii].TOTAL_ACTIVE_CUST = 0;
                                }
                                if ($scope.profileList[ii].DBC == null
                                    || $scope.profileList[ii].DBC == "null") {
                                    $scope.profileList[ii].DBC = 0;
                                    $scope.profileList[ii].DBC_PERC = 0;
                                } else {
                                    $scope.profileList[ii].DBC_PERC = (($scope.profileList[ii].DBC / $scope.profileList[ii].TOTAL_ACTIVE_CUST) * 100).toFixed(2);
                                }
                                if ($scope.profileList[ii].CTC == null
                                    || $scope.profileList[ii].CTC == "null") {
                                    $scope.profileList[ii].CTC = 0;
                                    $scope.profileList[ii].CTC_PERC = 0;
                                } else {
                                    $scope.profileList[ii].CTC_PERC = (($scope.profileList[ii].CTC / $scope.profileList[ii].TOTAL_ACTIVE_CUST) * 100).toFixed(2);
                                }
                                if ($scope.profileList[ii].GIVE_IT_UP == null
                                    || $scope.profileList[ii].GIVE_IT_UP == "null") {
                                    $scope.profileList[ii].GIVE_IT_UP = 0;
                                    $scope.profileList[ii].GIVE_IT_UP_PERC = 0;
                                } else {
                                    $scope.profileList[ii].GIVE_IT_UP_PERC = (($scope.profileList[ii].GIVE_IT_UP / $scope.profileList[ii].TOTAL_ACTIVE_CUST) * 100).toFixed(2);
                                }

                                if ($scope.profileList[ii].YEAR_QTR == null
                                    || $scope.profileList[ii].YEAR_QTR == "null") {
                                    $scope.profileList[ii].YEAR_QTR = "NA";
                                    $scope.profileList[ii].STAR_RATING = 0;
                                }

                                $scope.totalInfo.TOTAL_ACTIVE_CUST += parseInt($scope.profileList[ii].TOTAL_ACTIVE_CUST);
                                $scope.totalInfo.DBC += parseInt($scope.profileList[ii].DBC);
                                $scope.totalInfo.CTC += parseInt($scope.profileList[ii].CTC);
                                $scope.totalInfo.GIVE_IT_UP += parseInt($scope.profileList[ii].GIVE_IT_UP);
                            }

                            $scope.totalInfo.DBC_PERC = (($scope.totalInfo.DBC / $scope.totalInfo.TOTAL_ACTIVE_CUST) * 100).toFixed(2);
                            $scope.totalInfo.CTC_PERC = (($scope.totalInfo.CTC / $scope.totalInfo.TOTAL_ACTIVE_CUST) * 100).toFixed(2);
                            $scope.totalInfo.GIVE_IT_UP_PERC = (($scope.totalInfo.GIVE_IT_UP / $scope.totalInfo.TOTAL_ACTIVE_CUST) * 100).toFixed(2);

                            $ionicLoading.hide();
                        } catch (e1) {
                            alert(e1);
                            $scope.error = true;
                            $ionicLoading.hide();
                        }

                    }).error(onError);
            } catch (e) {
                alert("Runtime Error occurred. Please try after sometime");
                $scope.error = true;
                $ionicLoading.hide();
            }
        });

        function onError(data) {
            $scope.error = true;
            $ionicLoading.hide();
        }


        $scope.startNavigation = function (dist_code) {
            $ionicLoading.show({
                template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
            });

            try {
                var inputData = {
                    "dist_sap_code": dist_code,
                    "secretKey": "f11583391f7b0ea047e5671770645d26"
                }

                var url = "https://indane.co.in/mpowerApiServices/distLatitude.php";

                $http.post(url, inputData)
                    .success(function (data, status) {
                        try {

                            var lat = data.showroom.latitude;
                            var lng = data.showroom.longitude;
                            var url = "http://maps.google.com/?q=" + lat + "," + lng;
                            window.open(url, '_system', 'location=no');
                            $ionicLoading.hide();
                        } catch (e1) {
                            //alert(e1);
                            alert("Runtime Error occurred. Please try after sometime");
                            $ionicLoading.hide();
                        }

                    }).error(onError);
            } catch (ee) {
                alert(ee);
                $scope.error = true;
                $ionicLoading.hide();
            }


        }

        $scope.getNumber = function (num) {
            var x = new Array();
            for (var i = 0; i < num; i++) {
                x.push(i + 1);
            }
            return x;
        }

        $scope.goHome = function () {
            $state.go("LPGHome");
        }

        $scope.selectDistributor = function (dist) {
            if (dist) {
                $scope.currentDistProfile = dist;
                $scope.profileView = true;
            } else {
                $scope.currentDistProfile = {};
                $scope.profileView = false;
            }
        }
    }

    var LPGProfileSumaryController = function ($scope, userService, $ionicPopup, $http, $timeout, $ionicLoading, $state) {


        $ionicLoading.show({
            template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
        });
        $scope.$on('$ionicView.enter', function () {
            $scope.error = false;
            $scope.employee = userService.getUser();
            $scope.profileList = [];
            $scope.profileView = false;
            $scope.currentDistProfile = {};

            $scope.totalInfo = {
                TOTAL_DIST: 0,
                TOTAL_ACTIVE_CUST: 0,
                DBC: 0,
                CTC: 0,
                GIVE_IT_UP: 0
            };

            $scope.distSearch = {
                text: ""
            };


            var uri = "";

            if ($scope.employee.empRole == "AO") {
                uri = "ao_code=" + $scope.employee.locCode;
            } else if ($scope.employee.empRole == "SO") {
                uri = "so_code=" + $scope.employee.locCode;
            } else if ($scope.employee.empRole == "HO") {
                uri = "ho=100";
            }



            try {
                $http.get("https://xsparsh.indianoil.in:8443/LPGMobile/DistProfile?" + uri)
                    .success(function (data, status) {
                        try {
                            $scope.profileList = data;
                            for (var ii = 0; ii < $scope.profileList.length; ii++) {
                                if ($scope.profileList[ii].TOTAL_ACTIVE_CUST == null
                                    || $scope.profileList[ii].TOTAL_ACTIVE_CUST == "null") {
                                    $scope.profileList[ii].TOTAL_ACTIVE_CUST = 0;
                                }
                                if ($scope.profileList[ii].DBC == null
                                    || $scope.profileList[ii].DBC == "null") {
                                    $scope.profileList[ii].DBC = 0;
                                    $scope.profileList[ii].DBC_PERC = 0;
                                } else {
                                    $scope.profileList[ii].DBC_PERC = (($scope.profileList[ii].DBC / $scope.profileList[ii].TOTAL_ACTIVE_CUST) * 100).toFixed(2);
                                }
                                if ($scope.profileList[ii].CTC == null
                                    || $scope.profileList[ii].CTC == "null") {
                                    $scope.profileList[ii].CTC = 0;
                                    $scope.profileList[ii].CTC_PERC = 0;
                                } else {
                                    $scope.profileList[ii].CTC_PERC = (($scope.profileList[ii].CTC / $scope.profileList[ii].TOTAL_ACTIVE_CUST) * 100).toFixed(2);
                                }
                                if ($scope.profileList[ii].GIVE_IT_UP == null
                                    || $scope.profileList[ii].GIVE_IT_UP == "null") {
                                    $scope.profileList[ii].GIVE_IT_UP = 0;
                                    $scope.profileList[ii].GIVE_IT_UP_PERC = 0;
                                } else {
                                    $scope.profileList[ii].GIVE_IT_UP_PERC = (($scope.profileList[ii].GIVE_IT_UP / $scope.profileList[ii].TOTAL_ACTIVE_CUST) * 100).toFixed(2);
                                }

                                if ($scope.profileList[ii].YEAR_QTR == null
                                    || $scope.profileList[ii].YEAR_QTR == "null") {
                                    $scope.profileList[ii].YEAR_QTR = "NA";
                                    $scope.profileList[ii].STAR_RATING = 0;
                                }

                                $scope.totalInfo.TOTAL_DIST += parseInt($scope.profileList[ii].TOTAL_DIST);
                                $scope.totalInfo.TOTAL_ACTIVE_CUST += parseInt($scope.profileList[ii].TOTAL_ACTIVE_CUST);
                                $scope.totalInfo.DBC += parseInt($scope.profileList[ii].DBC);
                                $scope.totalInfo.CTC += parseInt($scope.profileList[ii].CTC);
                                $scope.totalInfo.GIVE_IT_UP += parseInt($scope.profileList[ii].GIVE_IT_UP);
                            }

                            $scope.totalInfo.DBC_PERC = (($scope.totalInfo.DBC / $scope.totalInfo.TOTAL_ACTIVE_CUST) * 100).toFixed(2);
                            $scope.totalInfo.CTC_PERC = (($scope.totalInfo.CTC / $scope.totalInfo.TOTAL_ACTIVE_CUST) * 100).toFixed(2);
                            $scope.totalInfo.GIVE_IT_UP_PERC = (($scope.totalInfo.GIVE_IT_UP / $scope.totalInfo.TOTAL_ACTIVE_CUST) * 100).toFixed(2);

                            $ionicLoading.hide();
                        } catch (e1) {
                            alert(e1);
                            $scope.error = true;
                            $ionicLoading.hide();
                        }

                    }).error(onError);
            } catch (e) {
                alert("Runtime Error occurred. Please try after sometime");
                $scope.error = true;
                $ionicLoading.hide();
            }
        });

        function onError(data) {
            $scope.error = true;
            $ionicLoading.hide();
        }


        $scope.startNavigation = function (dist_code) {
            $ionicLoading.show({
                template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
            });

            try {
                var inputData = {
                    "dist_sap_code": dist_code,
                    "secretKey": "f11583391f7b0ea047e5671770645d26"
                }

                var url = "https://indane.co.in/mpowerApiServices/distLatitude.php";

                $http.post(url, inputData)
                    .success(function (data, status) {
                        try {

                            var lat = data.showroom.latitude;
                            var lng = data.showroom.longitude;
                            var url = "http://maps.google.com/?q=" + lat + "," + lng;
                            window.open(url, '_system', 'location=no');
                            $ionicLoading.hide();
                        } catch (e1) {
                            //alert(e1);
                            alert("Runtime Error occurred. Please try after sometime");
                            $ionicLoading.hide();
                        }

                    }).error(onError);
            } catch (ee) {
                alert(ee);
                $scope.error = true;
                $ionicLoading.hide();
            }


        }

        $scope.getNumber = function (num) {
            var x = new Array();
            for (var i = 0; i < num; i++) {
                x.push(i + 1);
            }
            return x;
        }

        $scope.goHome = function () {
            $state.go("LPGHome");
        }

        $scope.selectDistributor = function (dist) {
            if (dist) {
                $scope.currentDistProfile = dist;
                $scope.profileView = true;
            } else {
                $scope.currentDistProfile = {};
                $scope.profileView = false;
            }
        }
    }

    var LPGDistDBController = function ($scope, userService, $ionicPopup, $http, $timeout, $ionicLoading, $state) {


        $ionicLoading.show({
            template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
        });
        $scope.$on('$ionicView.enter', function () {
            $scope.error = false;
            $scope.employee = userService.getUser();
            $scope.profileList = [];
            $scope.distList = [];
            $scope.profileView = false;
            $scope.selectedDist = {};

            $scope.currentDistProfile = {};
            $ionicLoading.hide();


            $scope.distSearch = {
                text: "",
                freeze: false
            };


            $scope.distData = {
                summaryExists: false,
                balanceExists: false,
                eodExists: false
            };

            $scope.distBalance = [];

            $scope.eodStock = [];

            $scope.tabNumber = "";


        });

        function onError(data) {
            $scope.error = true;
            $ionicLoading.hide();
        }


        $scope.loadDistributors = function () {
            if ($scope.distSearch.text.length > 3) {

                $ionicLoading.show({
                    template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Loading Distributors'
                });
                $scope.distList = [];
                $scope.distSearch.freeze = true;

                console.log($scope.distSearch.text);

                try {
                    var tt = "https://xsparsh.indianoil.in:8443";
                    tt = "http://10.52.180.52:7003";
                    var qs = $scope.distSearch.text.toLowerCase();
                    $http.get("https://xsparsh.indianoil.in:8443/soa-infra/resources/default/MpowerLPGNFO/DistbSearch?query=" + qs)
                        .success(function (data, status) {
                            try {
                                if (data && data != "null") {
                                    $scope.distList = data.dbDistSearchOutput;
                                }
                                $scope.distSearch.freeze = false;
                                $ionicLoading.hide();
                            } catch (e1) {
                                alert(e1);
                                $scope.error = true;
                                $scope.distSearch.freeze = false;
                                $ionicLoading.hide();
                            }

                        }).error(onError);
                } catch (e) {
                    alert("Runtime Error occurred. Please try after sometime");
                    $scope.distSearch.freeze = false;
                    $ionicLoading.hide();
                }


            }
        }




        $scope.startNavigation = function (dist_code) {
            $ionicLoading.show({
                template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
            });

            try {
                var inputData = {
                    "dist_sap_code": dist_code,
                    "secretKey": "f11583391f7b0ea047e5671770645d26"
                }

                var url = "https://indane.co.in/mpowerApiServices/distLatitude.php";

                $http.post(url, inputData)
                    .success(function (data, status) {
                        try {

                            var lat = data.showroom.latitude;
                            var lng = data.showroom.longitude;
                            var url = "http://maps.google.com/?q=" + lat + "," + lng;
                            window.open(url, '_system', 'location=no');
                            $ionicLoading.hide();
                        } catch (e1) {
                            //alert(e1);
                            alert("Runtime Error occurred. Please try after sometime");
                            $ionicLoading.hide();
                        }

                    }).error(onError);
            } catch (ee) {
                alert(ee);
                $scope.error = true;
                $ionicLoading.hide();
            }


        }

        $scope.getNumber = function (num) {
            var x = new Array();
            for (var i = 0; i < num; i++) {
                x.push(i + 1);
            }
            return x;
        }

        $scope.goHome = function () {
            $state.go("LPGHome");
        }

        $scope.goBack = function () {
            $scope.profileView = false;
            $scope.selectedDist = {};
        }


        $scope.showData = function (type) {
            $scope.tabNumber = type;
            if (type == "P") {

            } else if (type == "B") {
                if (!$scope.distData.balanceExists) {
                    $ionicLoading.show({
                        template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Loading Distributors'
                    });
                    var dd = "0000" + $scope.selectedDist.DIST_CODE.toString();
                    $http.get("https://m.indianoil.in:8443/sap/opu/odata/sap/Z_XS_CUST_BAL_SRV/CcaBal1Set?$skip=0&$top=100&$inlinecount=allpages&$filter=Customer%20eq%20%27" + $scope.selectedDist.DIST_CODE + "%27&$format=json")
                        .success(function (data, status) {
                            $scope.distBalance = data.d.results;
                            $scope.distData.balanceExists = true;
                            $ionicLoading.hide();
                        }).error(onError);
                }
            } else if (type == "E") {
                if (!$scope.distData.eodExists) {
                    $ionicLoading.show({
                        template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Loading Distributors'
                    });
                    $http.get("https://xsparsh.indianoil.in:8443/soa-infra/resources/default/MpowerLPGNFO/DistEODStock?dist_code=" + $scope.selectedDist.DIST_CODE)
                        .success(function (data, status) {
                            $scope.eodStock = data.dbDistStockOutput;
                            $scope.distData.eodExists = true;
                            $ionicLoading.hide();
                        }).error(onError);
                }
            }
        }

        $scope.selectDistributor = function (dist) {
            if (dist) {
                $scope.selectedDist = dist;
                //alert($scope.currentDistProfile.DISTB_NAME);
                $scope.profileView = true;

                $scope.distData = {
                    summaryExists: false,
                    balanceExists: false,
                    eodExists: false
                };

                $scope.tabNumber = "P";

                $ionicLoading.show({
                    template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Loading Distributors'
                });

                if (!$scope.distData.summaryExists) {
                    $http.get("https://xsparsh.indianoil.in:8443/LPGMobile/DistProfile?dist_code=" + $scope.selectedDist.DIST_CODE)
                        .success(function (data, status) {
                            if (data.length > 0) {
                                $scope.currentDistProfile = data[0];
                            }
                            $scope.distData.summaryExists = true;
                            $ionicLoading.hide();
                        }).error(onError);
                } else {
                    $ionicLoading.hide();
                }


            } else {
                $scope.selectedDist = {};
                $scope.profileView = false;
            }
        }



    }


    var LPGBalanceController = function ($scope, userService, $ionicPopup, $http, $ionicLoading, $state) {

        $ionicLoading.show({
            template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
        });
        $scope.$on('$ionicView.enter', function () {
            $scope.sapBalance = [];
            $scope.employee = userService.getUser();
            $scope.error = false;
            $scope.balanceView = false;
            $scope.currentSAPBalance = {};

            $scope.distSearch = {
                text: ""
            };

            try {
                $http.get("https://m.indianoil.in:8443/sap/opu/odata/sap/Z_MP_LPG_SERVICES_SRV/CustBalSet?$filter=Vkgrp%20eq%20%27" + $scope.employee.salesGroup + "%27")
                    .success(function (data, status) {
                        try {
                            $scope.sapBalance = data.d.results;
                            if ($scope.sapBalance.length > 0) {
                                $scope.custList = _.groupBy($scope.sapBalance, "Customer");
                                $ionicLoading.hide();
                            } else {
                                $ionicLoading.hide();
                            }
                        } catch (e1) {
                            //alert(e1);
                            alert("Runtime Error occurred. Please try after sometime");
                            $scope.error = true;
                            $ionicLoading.hide();
                        }

                    }).error(onError);
            } catch (e) {
                alert(e);
                $scope.error = true;
                $ionicLoading.hide();
            }
        });

        function onError(data) {
            $scope.error = true;
            $ionicLoading.hide();
        }

        $scope.loadBacklog = function () {
            $ionicLoading.show({
                template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
            });
            try {
                var distcode = $scope.currentSAPBalance.sapBalance[0].Customer;

                $http.get("https://xsparsh.indianoil.in:8443/LPGMobile/Backlog?dist_code=" + distcode)
                    .success(function (data, status) {
                        try {
                            $scope.currentSAPBalance.backlog = data;
                            $scope.currentSAPBalance.showBackLog = true;
                            $ionicLoading.hide();
                        } catch (e1) {
                            alert(e1);
                            $ionicLoading.hide();
                        }

                    }).error(onError);
            } catch (e) {
                alert("Runtime Error occurred. Please try after sometime");
                $ionicLoading.hide();
            }
        }

        $scope.loadEODStock = function () {
            $ionicLoading.show({
                template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
            });
            try {
                var distcode = $scope.currentSAPBalance.sapBalance[0].Customer;

                $http.get("https://xsparsh.indianoil.in:8443/soa-infra/resources/default/MpowerLPG/EODStockBal?dist_code=" + distcode)
                    .success(function (data, status) {
                        try {
                            $scope.currentSAPBalance.eodStock = data.dbBalStockEODOutput;
                            $scope.currentSAPBalance.showEodStock = true;
                            $ionicLoading.hide();
                        } catch (e1) {
                            //alert(e1);
                            alert("Runtime Error occurred. Please try after sometime");
                            $ionicLoading.hide();
                        }

                    }).error(onError);
            } catch (e) {
                $ionicLoading.hide();
            }
        }

        $scope.loadSAPInfo = function () {
            $ionicLoading.show({
                template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
            });
            try {
                var distcode = $scope.currentSAPBalance.sapBalance[0].Customer;

                $http.get("https://m.indianoil.in:8443/sap/opu/odata/sap/Z_MP_LPG_SERVICES_SRV/CustOrderFlowSet?$filter=Pkunag%20eq%20%27" + distcode + "%27&$format=json")
                    .success(function (data, status) {
                        try {
                            $scope.currentSAPBalance.sapInfo = data.d.results;
                            $scope.currentSAPBalance.showSapInfo = true;
                            $ionicLoading.hide();
                        } catch (e1) {
                            //alert(e1);
                            alert("Runtime Error occurred. Please try after sometime");
                            $ionicLoading.hide();
                        }

                    }).error(onError);
            } catch (e) {
                $ionicLoading.hide();
            }
        }

        $scope.selectDistributor = function (dist) {
            if (dist) {
                $scope.currentSAPBalance.sapBalance = dist;
                $scope.currentSAPBalance.backlog = {};
                $scope.currentSAPBalance.showBackLog = false;

                $scope.currentSAPBalance.eodStock = {};
                $scope.currentSAPBalance.showEodStock = false;

                $scope.currentSAPBalance.sapInfo = {};
                $scope.currentSAPBalance.showSapInfo = false;

                $scope.balanceView = true;
            } else {
                $scope.currentSAPBalance = {};
                $scope.balanceView = false;
            }
        }

        $scope.goHome = function () {
            $state.go("LPGHome");
        }

    }

    var LPGSalesTrackerController = function ($scope, userService, $ionicPopup, $http, $ionicLoading, $state) {

        $ionicLoading.show({
            template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
        });
        $scope.$on('$ionicView.enter', function () {
            $scope.employee = userService.getUser();
            $scope.distWiseSales = [];
            $scope.prodWiseSales = [];
            $scope.cumSales = [];
            $scope.error = false;
            $scope.salesView = false;
            $scope.tabNumber = 'T';

            $scope.sales = {
                fromDate: "",
                toDate: "",
                finalFDate: "",
                finalTDate: "",
                sg: "",
                cumSalesExist: false,
                prodSalesExist: false,
                distSalesExist: false,
                selectedProduct: "",
                selectedDist: "",
                heirType: "",
                heirKey: "",
                heirValue: ""
            };
            $ionicLoading.hide();
        });

        function onError(data) {
            $scope.error = true;
            $ionicLoading.hide();
        }

        $scope.goBack = function () {
            $scope.salesView = false;
            $scope.distWiseSales = [];
            $scope.prodWiseSales = [];
            $scope.cumSales = [];
            $scope.sales = {
                fromDate: "",
                toDate: "",
                finalFDate: "",
                finalTDate: "",
                sg: "",
                cumSalesExist: false,
                prodSalesExist: false,
                distSalesExist: false,
                selectedProduct: "",
                selectedDist: ""
            };
            $scope.tabNumber = 'T';
        }

        $scope.showSales = function (type) {
            if (type == "T") {
                if (!$scope.sales.cumSalesExist) {
                    fetchSales("T", function () {
                        $scope.tabNumber = type;
                    })
                } else {
                    $scope.tabNumber = type;
                }
            } else if (type == "P") {
                if (!$scope.sales.prodSalesExist) {
                    fetchSales("P", function () {
                        $scope.tabNumber = type;
                    })
                } else {
                    $scope.tabNumber = type;
                }
            } else if (type == "D") {
                if (!$scope.sales.distSalesExist) {
                    fetchSales("D", function () {
                        $scope.tabNumber = type;
                    })
                } else {
                    $scope.tabNumber = type;
                }
            }
        }

        function fetchSales(type, cb) {
            $ionicLoading.show({
                template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
            });

            var entitySet = "";
            var compareKey = "";
            var compareValue = "";

            if ($scope.employee.empRole == "FO") {
                if (type == "T") {
                    entitySet = "CustDSSalesSet";
                } else if (type == "P") {
                    entitySet = "CustMSSalesSet";
                } else if (type == "D") {
                    entitySet = "CustCSSalesSet";
                }
                compareKey = "Vkgrp";
                compareValue = $scope.sales.sg;
                $scope.sales.heirType = "Distributor";
                $scope.sales.heirKey = "Pkunwe";
                $scope.sales.heirValue = "CustName";

                var url = "https://m.indianoil.in:8443/sap/opu/odata/sap/Z_MP_LPG_SERVICES_SRV/" + entitySet + "?$filter=" + compareKey + "%20eq%20%27" + compareValue + "%27%20and%20IDateFrom%20eq%20datetime%27" + $scope.sales.finalFDate + "T00:00:00%27%20and%20IDateTo%20eq%20datetime%27" + $scope.sales.finalTDate + "T00:00:00%27&$format=json"

                $http.get(url)
                    .success(function (data, status) {
                        try {
                            if ($scope.employee.empRole == "FO") {
                                if (type == "T") {
                                    $scope.cumSales = data.d.results;
                                    $scope.sales.cumSalesExist = true;
                                } else if (type == "P") {
                                    $scope.prodWiseSales = data.d.results;
                                    $scope.sales.prodSalesExist = true;
                                    $scope.prodList = _.groupBy($scope.prodWiseSales, "Matnr");
                                    $scope.sales.selectedProduct = $scope.prodList[Object.keys($scope.prodList)[0]][0].Matnr;
                                } else if (type == "D") {
                                    $scope.distWiseSales = data.d.results;
                                    $scope.sales.distSalesExist = true;
                                    $scope.distList = _.groupBy($scope.distWiseSales, $scope.sales.heirKey);
                                    $scope.sales.selectedDist = $scope.distList[Object.keys($scope.distList)[0]][0][$scope.sales.heirKey];
                                }
                            }
                            cb();
                            $scope.salesView = true;
                            $ionicLoading.hide();
                        } catch (e1) {
                            //alert(e1);
                            alert("Runtime Error occurred. Please try after sometime");
                            $scope.error = true;
                            $ionicLoading.hide();
                            cb();
                        }

                    }).error(function () {
                        $scope.error = true;
                        $ionicLoading.hide();
                        cb();
                    });



            }
        }

        $scope.getSales = function () {
            if (validateValues()) {
                $ionicLoading.show({
                    template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Loading!'
                });

                try {
                    if ($scope.sales.fromDate == null || $scope.sales.fromDate == "" ||
                        $scope.sales.toDate == null || $scope.sales.toDate == "") {
                        alert("Dates cannot be empty");
                        $ionicLoading.hide();
                    } else {
                        var fromDate = new Date($scope.sales.fromDate);
                        var toDate = new Date($scope.sales.toDate);
                        $scope.sales.finalFDate = fromDate.getFullYear() + "-" + (fromDate.getMonth() + 1) + "-" + fromDate.getDate();
                        $scope.sales.finalTDate = toDate.getFullYear() + "-" + (toDate.getMonth() + 1) + "-" + toDate.getDate();
                        $scope.sales.sg = $scope.employee.salesGroup;


                        var entitySet = "";
                        var compareKey = "";
                        var compareValue = "";
                        var compareString = "";
                        var url = "https://m.indianoil.in:8443/sap/opu/odata/sap/Z_MP_LPG_SERVICES_SRV/";

                        if ($scope.employee.empRole == "FO") {
                            entitySet = "CustDSSalesSet";
                            compareKey = "Vkgrp";
                            compareValue =$scope.employee.salesGroup;
                            $scope.sales.heirType = "Distributor";
                            $scope.sales.heirKey = "Pkunwe";
                            $scope.sales.heirValue = "CustName";
                            url =  url + entitySet + "?$filter=" + compareKey + "%20eq%20%27" + compareValue + "%27%20and%20IDateFrom%20eq%20datetime%27" + $scope.sales.finalFDate + "T00:00:00%27%20and%20IDateTo%20eq%20datetime%27" + $scope.sales.finalTDate + "T00:00:00%27&$format=json"
                        } else if ($scope.employee.empRole == "AO") {
                            entitySet = "AOSalesSet";
                            compareKey = "Vkbur";
                            compareValue = $scope.employee.locCode;
                            $scope.sales.heirType = "Sales Group";
                            $scope.sales.heirKey = "Vkgrp";
                            $scope.sales.heirValue = "VkgrpText";
                            url =  url + entitySet + "?$filter=" + compareKey + "%20eq%20%27" + compareValue + "%27%20and%20IDateFrom%20eq%20datetime%27" + $scope.sales.finalFDate + "T00:00:00%27%20and%20IDateTo%20eq%20datetime%27" + $scope.sales.finalTDate + "T00:00:00%27&$format=json"
                        } else if ($scope.employee.empRole == "SO") {
                            entitySet = "SOSalesSet";
                            compareKey = "Vkorg";
                            compareValue = $scope.employee.locCode;
                            $scope.sales.heirType = "Area Office";
                            $scope.sales.heirKey = "Vkbur";
                            $scope.sales.heirValue = "VkburText";
                            url =  url + entitySet + "?$filter=" + compareKey + "%20eq%20%27" + compareValue + "%27%20and%20IDateFrom%20eq%20datetime%27" + $scope.sales.finalFDate + "T00:00:00%27%20and%20IDateTo%20eq%20datetime%27" + $scope.sales.finalTDate + "T00:00:00%27&$format=json"
                        } else if ($scope.employee.empRole == "HO") {
                            entitySet = "HOSalesSet";
                            compareKey = "";
                            compareValue = "";
                            $scope.sales.heirType = "State Office";
                            $scope.sales.heirKey = "Vkorg";
                            $scope.sales.heirValue = "VkorgText";
                            url =  url + entitySet + "?$filter=IDateFrom%20eq%20datetime%27" + $scope.sales.finalFDate + "T00:00:00%27%20and%20IDateTo%20eq%20datetime%27" + $scope.sales.finalTDate + "T00:00:00%27&$format=json"
                        }

                        //alert(url);

                        

                        $http.get(url)
                            .success(function (data, status) {
                                try {
                                    if ($scope.employee.empRole == "FO") {
                                        $scope.cumSales = data.d.results;
                                        $scope.sales.heirType = "Distributor";
                                        $scope.sales.heirKey = "Pkunwe";
                                        $scope.sales.heirValue = "CustName";
                                    } else {
                                        $scope.cumSales = data.d.results;
                                        $scope.prodWiseSales = data.d.results;
                                        $scope.prodList = _.groupBy($scope.prodWiseSales, "Matnr");
                                        $scope.sales.selectedProduct = $scope.prodList[Object.keys($scope.prodList)[0]][0].Matnr;
                                        $scope.sales.prodSalesExist = true;

                                        $scope.distWiseSales = data.d.results;
                                        $scope.distList = _.groupBy($scope.distWiseSales, $scope.sales.heirKey);
                                        $scope.sales.selectedDist = $scope.distWiseSales[0][$scope.sales.heirValue];
                                        console.log($scope.distList);
                                        $scope.sales.distSalesExist = true;
                                        
                                    }

                                    $scope.sales.cumSalesExist = true;
                                    $scope.salesView = true;
                                    $ionicLoading.hide();
                                } catch (e1) {
                                    //alert(e1);
                                    alert("Runtime Error occurred. Please try after sometime");
                                    $scope.error = true;
                                    $ionicLoading.hide();
                                }

                            }).error(onError);
                    }


                } catch (ee) {
                    //alert(ee);
                    alert("Runtime Error occurred. Please try after sometime");
                    $scope.error = true;
                    $ionicLoading.hide();
                }



            }
        }


        $scope.getSalesSum = function(items, kk) {
            return items
                .map(function(x) { return parseFloat(x[kk]); })
                .reduce(function(a, b) { return a + b; });
        };

        $scope.goHome = function () {
            $state.go("LPGHome");
        }



        function validateValues() {
            try {
                var fromDate = new Date($scope.sales.fromDate);
                var toDate = new Date($scope.sales.toDate);

                var todayDate = new Date();

                fromDate = new Date(fromDate.getFullYear(), fromDate.getMonth(), fromDate.getDate()); //Year, Month, Date
                toDate = new Date(toDate.getFullYear(), toDate.getMonth(), toDate.getDate()); //Year, Month, Date
                todayDate = new Date(todayDate.getFullYear(), todayDate.getMonth(), todayDate.getDate());

                if (fromDate > toDate) {
                    alert("From date cannot more than To date");
                    return false;
                } else if (fromDate > todayDate) {
                    alert("From date cannot more than Today date");
                    return false;
                } else if (toDate > todayDate) {
                    alert("To date cannot more than Today date");
                    return false;
                } else {
                    var a = (todayDate - fromDate) / (1000 * 3600 * 24);
                    if (a > 90) {
                        alert("From Date cannot be less the 90 days.");
                        return false;
                    }
                }
                return true;
            } catch (e) {
                alert("Internal Error");
                return false;
            }
        }

    }


    var LPGOrderController = function ($scope, userService, $ionicPopup, $http, $ionicLoading, $state) {

        $ionicLoading.show({
            template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
        });
        $scope.$on('$ionicView.enter', function () {
            $scope.employee = userService.getUser();
            $scope.allOrders = [];
            $scope.custList = [];

            $scope.ordersDispatched = [];
            $scope.ordersLoading = [];
            $scope.ordersPending = [];
            $scope.error = false;
            $scope.inputView = true;
            $scope.orderView = false;
            $scope.tabNumber = "";
            $scope.currentOrder = {};


            $scope.order = {
                fromDate: "",
                toDate: "",
                finalFDate: "",
                finalTDate: "",
                sg: ""
            };
            $ionicLoading.hide();

        });


        function onError(data) {
            $scope.error = true;
            $ionicLoading.hide();
        }

        $scope.goBack = function () {
            $scope.inputView = true;
            $scope.allOrders = [];
            $scope.custList = [];
            $scope.tabNumber = "";

            $scope.ordersDispatched = [];
            $scope.ordersLoading = [];
            $scope.ordersPending = [];
        }

        $scope.selectDistributor = function (dist) {
            if (dist) {
                $scope.currentOrder = dist;
                $scope.orderView = true;
            } else {
                $scope.currentOrder = {};
                $scope.orderView = false;
            }
        }


        $scope.showOrderInfo = function (index) {
            for (var ii = 0; ii < $scope.currentOrder.length; ii++) {
                $scope.currentOrder[ii].show = false;
            }
            $scope.currentOrder[index].show = true;

        }

        $scope.getOrder = function () {
            if (validateValues()) {
                $ionicLoading.show({
                    template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Loading!'
                });

                try {
                    var fromDate = new Date($scope.order.fromDate);
                    var toDate = new Date($scope.order.toDate);
                    $scope.order.finalFDate = fromDate.getFullYear() + "-" + (fromDate.getMonth() + 1) + "-" + fromDate.getDate();
                    $scope.order.finalTDate = toDate.getFullYear() + "-" + (toDate.getMonth() + 1) + "-" + toDate.getDate();
                    $scope.order.sg = $scope.employee.salesGroup;

                    var url = "https://m.indianoil.in:8443/sap/opu/odata/sap/Z_MP_LPG_SERVICES_SRV/CustOrderStatusSet?$filter=Vkgrp%20eq%20%27" + $scope.order.sg + "%27%20and%20DateFrom%20eq%20datetime%27" + $scope.order.finalFDate + "T00:00:00%27%20and%20DateTo%20eq%20datetime%27" + $scope.order.finalTDate + "T00:00:00%27&$format=json"

                    $http.get(url)
                        .success(function (data, status) {
                            try {
                                $scope.allOrders = data.d.results;

                                for (var ii = 0; ii < $scope.allOrders.length; ii++) {
                                    $scope.allOrders[ii].show = false;
                                    if ($scope.allOrders[ii].Ordrdt) {
                                        var tt = $scope.allOrders[ii].Ordrdt.substring(6, $scope.allOrders[ii].Ordrdt.length - 2);
                                        console.log(tt);
                                        var dd = new Date(parseInt(tt));
                                        $scope.allOrders[ii].Ordrdt = dd.toString().substring(0, 15);
                                    }
                                    if ($scope.allOrders[ii].DelDate) {
                                        var tt = $scope.allOrders[ii].DelDate.substring(6, $scope.allOrders[ii].DelDate.length - 2);
                                        var dd = new Date(parseInt(tt));
                                        $scope.allOrders[ii].DelDate = dd.toString().substring(0, 15);
                                    }
                                    if ($scope.allOrders[ii].ShpmntDt) {
                                        var tt = $scope.allOrders[ii].ShpmntDt.substring(6, $scope.allOrders[ii].ShpmntDt.length - 2);
                                        var dd = new Date(parseInt(tt));
                                        $scope.allOrders[ii].ShpmntDt = dd.toString().substring(0, 15);
                                    }
                                    if ($scope.allOrders[ii].LoadDate) {
                                        var tt = $scope.allOrders[ii].LoadDate.substring(6, $scope.allOrders[ii].LoadDate.length - 2);
                                        var dd = new Date(parseInt(tt));
                                        $scope.allOrders[ii].LoadDate = dd.toString().substring(0, 15);
                                    }
                                    if ($scope.allOrders[ii].Reqdeldt) {
                                        var tt = $scope.allOrders[ii].Reqdeldt.substring(6, $scope.allOrders[ii].Reqdeldt.length - 2);
                                        var dd = new Date(parseInt(tt));
                                        $scope.allOrders[ii].Reqdeldt = dd.toString().substring(0, 15);
                                    }

                                    $scope.allOrders[ii].ShpmntTime = $scope.allOrders[ii].ShpmntTime.substring(2, 4) + ":" + $scope.allOrders[ii].ShpmntTime.substring(5, 7) + ":" + $scope.allOrders[ii].ShpmntTime.substring(8, 10);
                                    $scope.allOrders[ii].DelTime = $scope.allOrders[ii].DelTime.substring(2, 4) + ":" + $scope.allOrders[ii].DelTime.substring(5, 7) + ":" + $scope.allOrders[ii].DelTime.substring(8, 10);
                                    $scope.allOrders[ii].LoadTime = $scope.allOrders[ii].LoadTime.substring(2, 4) + ":" + $scope.allOrders[ii].LoadTime.substring(5, 7) + ":" + $scope.allOrders[ii].LoadTime.substring(8, 10);
                                    $scope.allOrders[ii].Erzet = $scope.allOrders[ii].Erzet.substring(2, 4) + ":" + $scope.allOrders[ii].Erzet.substring(5, 7) + ":" + $scope.allOrders[ii].Erzet.substring(8, 10);

                                    if (($scope.allOrders[ii].Comment).toLowerCase() == 'load dispatched') {
                                        $scope.ordersDispatched.push($scope.allOrders[ii]);
                                    } else if (($scope.allOrders[ii].Comment).toLowerCase() == 'delivery created' || ($scope.allOrders[ii].Comment).toLowerCase() == 'shipment created') {
                                        $scope.ordersLoading.push($scope.allOrders[ii]);
                                    } else {
                                        if (!(($scope.allOrders[ii].Comment).toLowerCase().indexOf('rejected') > -1)) {
                                            $scope.ordersPending.push($scope.allOrders[ii]);
                                        }
                                    }
                                }
                                if ($scope.allOrders.length > 0) {

                                    var prodOrderStatus = _.groupBy($scope.allOrders, "Matcode");

                                    $scope.prodOrderSummary = [];
                                    for (var pos in prodOrderStatus) {
                                        var tempArr = prodOrderStatus[pos];
                                        var tempObj = {
                                            product: "",
                                            productName: "",
                                            quantityDispatched: 0,
                                            quantityLoading: 0,
                                            quantityPending: 0
                                        }
                                        tempObj.product = prodOrderStatus[pos][0].Matcode;
                                        tempObj.productName = prodOrderStatus[pos][0].Matdesc;

                                        for (var jj = 0; jj < tempArr.length; jj++) {
                                            if (tempArr[jj].Comment == "Load Dispatched") {
                                                tempObj.quantityDispatched += parseFloat(tempArr[jj].Qunatity);
                                            } else if (tempArr[jj].Comment == "Delivery Created" || tempArr[jj].Comment == "Shipment Created") {
                                                tempObj.quantityLoading += parseFloat(tempArr[jj].Qunatity);
                                            } else {
                                                if (!((tempArr[jj].Comment).toLowerCase().indexOf('rejected') > -1)) {
                                                    tempObj.quantityPending += parseFloat(tempArr[jj].Qunatity);
                                                }
                                            }
                                        }
                                        tempObj.quantityDispatched = (tempObj.quantityDispatched);
                                        tempObj.quantityLoading = (tempObj.quantityLoading);
                                        tempObj.quantityPending = (tempObj.quantityPending);
                                        $scope.prodOrderSummary.push(tempObj);
                                    }


                                    //$scope.custList = _.groupBy($scope.allOrders, "Kunnr");
                                    $scope.inputView = false;
                                    $scope.tabNumber = "S";
                                    $ionicLoading.hide();
                                } else {
                                    alert("No orders to show");
                                    $ionicLoading.hide();
                                }
                            } catch (e1) {
                                console.log(e1);
                                //alert(e1);
                                alert("Runtime Error occurred. Please try after sometime");
                                $scope.error = true;
                                $ionicLoading.hide();
                            }

                        }).error(onError);


                } catch (ee) {
                    alert(ee);
                    $scope.error = true;
                    $ionicLoading.hide();
                }



            }
        }

        $scope.showOrder = function (val) {
            if (val == "P") {
                $scope.orders = $scope.ordersPending;
            } else if (val == "L") {
                $scope.orders = $scope.ordersLoading;
            } else if (val == "D") {
                $scope.orders = $scope.ordersDispatched;
            } else if (val == "S") {
                $scope.orders = [];
            }
            $scope.tabNumber = val;

        }

        $scope.goHome = function () {
            $state.go("LPGHome");
        }


        $scope.showOrderSummary = function (txt) {
            for (var ii = 0; ii < $scope.allOrders.length; ii++) {
                var tt = $scope.allOrders[ii].Ordrno.toString() + $scope.allOrders[ii].Matcode.toString();
                if (tt == txt) {
                    $scope.allOrders[ii].show = !$scope.allOrders[ii].show;
                } else {
                    $scope.allOrders[ii].show = false;
                }
            }
        }


        function validateValues() {
            try {
                if ($scope.order.fromDate == null || $scope.order.fromDate == "" ||
                    $scope.order.toDate == null || $scope.order.toDate == "") {
                    alert("Dates cannot be empty");
                    return false;
                } else {
                    var fromDate = new Date($scope.order.fromDate);
                    var toDate = new Date($scope.order.toDate);

                    var todayDate = new Date();

                    fromDate = new Date(fromDate.getFullYear(), fromDate.getMonth(), fromDate.getDate()); //Year, Month, Date
                    toDate = new Date(toDate.getFullYear(), toDate.getMonth(), toDate.getDate()); //Year, Month, Date
                    todayDate = new Date(todayDate.getFullYear(), todayDate.getMonth(), todayDate.getDate());

                    if (fromDate > toDate) {
                        alert("From date cannot more than To date");
                        return false;
                    } else if (fromDate > todayDate) {
                        alert("From date cannot more than Today date");
                        return false;
                    } else if (toDate > todayDate) {
                        alert("To date cannot more than Today date");
                        return false;
                    } else {
                        var a = (todayDate - fromDate) / (1000 * 3600 * 24);
                        if (a > 30) {
                            alert("From Date cannot be less the 30 days.");
                            return false;
                        }

                        var b = (toDate - fromDate) / (1000 * 3600 * 24);
                        if (b > 7) {
                            alert("Cannot fetch data for more than 7 days.");
                            return false;
                        }
                    }
                    return true;
                }
            } catch (e) {
                alert("Internal Error");
                return false;
            }
        }


    }

    var LPGRTDController = function ($scope, userService, $ionicPopup, $http, $ionicLoading, $state) {

        $ionicLoading.show({
            template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
        });
        $scope.$on('$ionicView.enter', function () {
            $scope.employee = userService.getUser();
            $scope.distWiseRTD = [];
            $scope.mktWiseRTD = [];
            $scope.plantList = [];
            $scope.error = false;
            $scope.tabNumber = 'M';

            $scope.rtd = {
                sg: $scope.employee.salesGroup,
                mktRTDExist: false,
                distRTDExist: false,
                selectedDist: "",
                selectedMkt: "",
                selectedPlant: ""
            };

            var url = "https://m.indianoil.in:8443/sap/opu/odata/sap/Z_MP_LPG_SERVICES_SRV/CustMKTDRCSet?$filter=Vkgrp%20eq%20%27" + $scope.rtd.sg + "%27&$format=json"

            $http.get(url)
                .success(function (data, status) {
                    try {
                        $scope.mktWiseRTD = data.d.results;
                        $scope.rtd.mktRTDExist = true;
                        if ($scope.mktWiseRTD.length > 0) {
                            for (var ii = 0; ii < $scope.mktWiseRTD.length; ii++) {
                                if ($scope.mktWiseRTD[ii].Validfrom) {
                                    var tt = $scope.mktWiseRTD[ii].Validfrom.substring(6, $scope.mktWiseRTD[ii].Validfrom.length - 2);
                                    var dd = new Date(parseInt(tt));
                                    //$scope.mktWiseRTD[ii].Validfrom = dd.toString().substring(0, 15);
                                    $scope.mktWiseRTD[ii].Validfrom = dd;
                                }
                                if ($scope.mktWiseRTD[ii].Validto) {
                                    var tt = $scope.mktWiseRTD[ii].Validto.substring(6, $scope.mktWiseRTD[ii].Validto.length - 2);
                                    var dd = new Date(parseInt(tt));
                                    //$scope.mktWiseRTD[ii].Validto = dd.toString().substring(0, 15);
                                    $scope.mktWiseRTD[ii].Validto = dd;
                                }
                            }

                            $scope.mktList = _.groupBy($scope.mktWiseRTD, "Oipsdrc");
                            $scope.rtd.selectedMkt = $scope.mktList[Object.keys($scope.mktList)[0]][0].Oipsdrc;
                            $ionicLoading.hide();
                        }
                    } catch (e1) {
                        //alert(e1);
                        alert("Runtime Error occurred. Please try after sometime");
                        $scope.error = true;
                        $ionicLoading.hide();
                    }

                }).error(function () {
                    $scope.error = true;
                    $ionicLoading.hide();
                });

        });

        function onError(data) {
            $scope.error = true;
            $ionicLoading.hide();
        }

        $scope.showRTD = function (type) {
            if (type == "M") {
                if (!$scope.rtd.mktRTDExist) {
                    fetchRTD("M", function () {
                        $scope.tabNumber = type;
                    })
                } else {
                    $scope.tabNumber = type;
                }
            } else if (type == "P") {

                $scope.plantList = _.groupBy($scope.mktWiseRTD, "Werks");
                $scope.rtd.selectedPlant = $scope.plantList[Object.keys($scope.plantList)[0]][0].Werks;
                $scope.tabNumber = type;
            } else if (type == "D") {
                if (!$scope.rtd.distRTDExist) {
                    fetchRTD("D", function () {
                        $scope.tabNumber = type;
                    })
                } else {
                    $scope.tabNumber = type;
                }
            }
        }

        function fetchRTD(type, cb) {
            $ionicLoading.show({
                template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
            });
            var entitySet = "";
            if (type == "M") {
                entitySet = "CustMKTDRCSet";
            } else if (type == "D") {
                entitySet = "CustRTDDRCSet";
            }
            var url = "https://m.indianoil.in:8443/sap/opu/odata/sap/Z_MP_LPG_SERVICES_SRV/" + entitySet + "?$filter=Vkgrp%20eq%20%27" + $scope.rtd.sg + "%27&$format=json"

            $http.get(url)
                .success(function (data, status) {
                    try {
                        if (type == "M") {
                            $scope.mktWiseRTD = data.d.results;
                            $scope.rtd.mktRTDExist = true;
                            if ($scope.mktWiseRTD.length > 0) {
                                for (var ii = 0; ii < $scope.mktWiseRTD.length; ii++) {
                                    if ($scope.mktWiseRTD[ii].Validfrom) {
                                        var tt = $scope.mktWiseRTD[ii].Validfrom.substring(6, $scope.mktWiseRTD[ii].Validfrom.length - 2);
                                        var dd = new Date(parseInt(tt));
                                        //$scope.mktWiseRTD[ii].Validfrom = dd.toString().substring(0, 15);
                                        $scope.mktWiseRTD[ii].Validfrom = dd;
                                    }
                                    if ($scope.mktWiseRTD[ii].Validto) {
                                        var tt = $scope.mktWiseRTD[ii].Validto.substring(6, $scope.mktWiseRTD[ii].Validto.length - 2);
                                        var dd = new Date(parseInt(tt));
                                        $scope.mktWiseRTD[ii].Validto = dd;
                                    }
                                }
                                $scope.mktList = _.groupBy($scope.mktWiseRTD, "Oipsdrc");
                                $scope.rtd.selectedMkt = $scope.mktList[Object.keys($scope.mktList)[0]][0].Oipsdrc;
                            }
                        } else if (type == "D") {
                            $scope.distWiseRTD = data.d.results;
                            $scope.rtd.distRTDExist = true;
                            if ($scope.distWiseRTD.length > 0) {
                                for (var ii = 0; ii < $scope.distWiseRTD.length; ii++) {
                                    if ($scope.distWiseRTD[ii].Validfrom) {
                                        var tt = $scope.distWiseRTD[ii].Validfrom.substring(6, $scope.distWiseRTD[ii].Validfrom.length - 2);
                                        var dd = new Date(parseInt(tt));
                                        $scope.distWiseRTD[ii].Validfrom = dd;
                                    }
                                    if ($scope.distWiseRTD[ii].Validto) {
                                        var tt = $scope.distWiseRTD[ii].Validto.substring(6, $scope.distWiseRTD[ii].Validto.length - 2);
                                        var dd = new Date(parseInt(tt));
                                        $scope.distWiseRTD[ii].Validto = dd;
                                    }
                                }
                                $scope.distList = _.groupBy($scope.distWiseRTD, "Kunnr");
                                $scope.rtd.selectedDist = $scope.distList[Object.keys($scope.distList)[0]][0].Kunnr;
                            }
                        }
                        cb();
                        $ionicLoading.hide();
                    } catch (e1) {
                        //alert(e1);
                        alert("Runtime Error occurred. Please try after sometime");
                        $scope.error = true;
                        $ionicLoading.hide();
                        cb();
                    }

                }).error(function () {
                    $scope.error = true;
                    $ionicLoading.hide();
                    cb();
                });

        }

        $scope.goHome = function () {
            $state.go("LPGHome");
        }

    }

    var LPGEodStatusController = function ($scope, userService, $ionicPopup, $http, $ionicLoading, $state) {

        $ionicLoading.show({
            template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
        });
        $scope.$on('$ionicView.enter', function () {
            $scope.employee = userService.getUser();
            $scope.eodStatus = [];
            $scope.dateList = [];
            $scope.distList = [];
            $scope.error = false;

            $scope.eod = {
                sg: $scope.employee.salesGroup,
                selectedDist: "",
                searchText: ""
            };

            var url = "https://xsparsh.indianoil.in:8443/soa-infra/resources/default/MpowerLPG/EODStatus?sales_group=" + $scope.eod.sg

            $http.get(url)
                .success(function (data, status) {
                    try {
                        $scope.eodStatus = data.dbEODStatusOutput;
                        if ($scope.eodStatus.length > 0) {
                            $scope.distList = _.groupBy($scope.eodStatus, "DIST_CODE");
                            $scope.dateList = _.groupBy($scope.eodStatus, "APP_DATE");
                            $scope.eod.selectedDist = $scope.distList[Object.keys($scope.distList)[0]][0].DIST_CODE;
                            $ionicLoading.hide();
                        }
                    } catch (e1) {
                        //alert(e1);
                        alert("Runtime Error occurred. Please try after sometime");
                        $scope.error = true;
                        $ionicLoading.hide();
                    }

                }).error(function () {
                    $scope.error = true;
                    $ionicLoading.hide();
                });

        });

        function onError(data) {
            $scope.error = true;
            $ionicLoading.hide();
        }

        $scope.goHome = function () {
            $state.go("LPGHome");
        }

    }

    var LPGEodSummaryController = function ($scope, userService, $ionicPopup, $http, $ionicLoading, $state) {

        $ionicLoading.show({
            template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
        });
        $scope.$on('$ionicView.enter', function () {
            $scope.employee = userService.getUser();
            $scope.eodStatus = [];
            $scope.error = false;

            var uri = "";
            var keyValue = "";
            if ($scope.employee.empRole == "AO") {
                uri = "AOEodStatus?ao_code=" + $scope.employee.locCode;
                keyValue = "dbEodStatusAOOutput";
            } else if ($scope.employee.empRole == "SO") {
                uri = "SOEodStatus?so_code=" + $scope.employee.locCode;
                keyValue = "dbEodStatusSOOutput";
            } else if ($scope.employee.empRole == "HO") {
                uri = "HOEodStatus";
                keyValue = "dbEodStatusHOOutput";
            }

            if (uri != "") {
                var url = "https://xsparsh.indianoil.in:8443/soa-infra/resources/default/MpowerLPGNFO/" + uri;

                $http.get(url)
                    .success(function (data, status) {
                        try {
                            $scope.eodStatus = data[keyValue];
                            $ionicLoading.hide();
                        } catch (e1) {
                            //alert(e1);
                            alert("Runtime Error occurred. Please try after sometime");
                            $scope.error = true;
                            $ionicLoading.hide();
                        }

                    }).error(function () {
                        $scope.error = true;
                        $ionicLoading.hide();
                    });
            } else {
                $scope.error = true;
                $ionicLoading.hide();
            }


        });

        $scope.sortComment = function (dl) {
            console.log(dl);
            var date = new Date(dl.APP_DATE);
            return date;
        };

        function onError(data) {
            $scope.error = true;
            $ionicLoading.hide();
        }

        $scope.goHome = function () {
            $state.go("LPGHome");
        }

    }

    var LPGStockController = function ($scope, userService, $ionicPopup, $http, $ionicLoading, $state) {

        $ionicLoading.show({
            template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
        });
        $scope.$on('$ionicView.enter', function () {
            $scope.employee = userService.getUser();
            $scope.stockData = [];
            $scope.error = false;
            $scope.stockView = false;

            $scope.stock = {
                selectedDate: "",
                sg: "",
                selectedDist: ""
            };
            $ionicLoading.hide();
        });

        function onError(data) {
            $scope.error = true;
            $ionicLoading.hide();
        }

        $scope.goBack = function () {
            $scope.stockView = false;
            $scope.stockData = [];
        }

        $scope.getStock = function () {
            if (validateValues()) {
                $ionicLoading.show({
                    template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Loading!'
                });

                try {
                    var selDate = new Date($scope.stock.selectedDate);

                    var yy = selDate.getFullYear().toString();
                    var mm = (selDate.getMonth() + 1).toString();
                    if (mm.length == 1) {
                        mm = "0" + mm;
                    }
                    var dd = selDate.getDate().toString();
                    if (dd.length == 1) {
                        dd = "0" + dd;
                    }

                    var finalSDate = dd.toString() + mm.toString() + yy.toString();

                    $scope.stock.sg = $scope.employee.salesGroup;

                    var url = "https://xsparsh.indianoil.in:8443/soa-infra/resources/default/MpowerLPG/StockReport?sales_group=" + $scope.stock.sg + "&stock_date=" + finalSDate;
                    console.log(url);
                    $http.get(url)
                        .success(function (data, status) {
                            try {
                                $scope.stockData = data.dbStockReportOutput;
                                $scope.distList = _.groupBy($scope.stockData, "DIST_CODE");
                                $scope.stock.selectedDist = $scope.distList[Object.keys($scope.distList)[0]][0].DIST_CODE;
                                $scope.stockView = true;
                                $ionicLoading.hide();
                            } catch (e1) {
                                //alert(e1);
                                alert("Runtime Error occurred. Please try after sometime");
                                $scope.error = true;
                                $ionicLoading.hide();
                            }

                        }).error(onError);
                } catch (ee) {
                    //alert(ee);
                    alert("Runtime Error occurred. Please try after sometime");
                    $scope.error = true;
                    $ionicLoading.hide();
                }



            }
        }

        $scope.goHome = function () {
            $state.go("LPGHome");
        }



        function validateValues() {
            try {

                if ($scope.stock.selectedDate == null || $scope.stock.selectedDate == "") {
                    alert("Date cannot be empty");
                    return false;
                } else {
                    var selDate = new Date($scope.stock.selectedDate);

                    var todayDate = new Date();

                    selDate = new Date(selDate.getFullYear(), selDate.getMonth(), selDate.getDate()); //Year, Month, Date

                    todayDate = new Date(todayDate.getFullYear(), todayDate.getMonth(), todayDate.getDate());

                    if (selDate > todayDate) {
                        alert("Selected date cannot more than Today date");
                        return false;
                    } else {
                        var a = (todayDate - selDate) / (1000 * 3600 * 24);
                        if (a > 30) {
                            alert("Date cannot be less the 30 days.");
                            return false;
                        }
                    }
                    return true;
                }


            } catch (e) {
                alert("Internal Error");
                return false;
            }
        }

    }

    var LPGNFRController = function ($scope, userService, $ionicPopup, $http, $timeout, $ionicLoading, $state) {


        $ionicLoading.show({
            template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
        });


        $scope.$on('$ionicView.enter', function () {
            $scope.error = false;
            $scope.employee = userService.getUser();
            $scope.nfrList = [];
            $scope.nfrView = false;
            $scope.currentDistNFR = {};

            $scope.totalInfo = {
                TOTAL_NCR: 0,
                PMUY_NCR: 0,
                TOTAL_STOVE: 0,
                PMUY_STOVE: 0,
                TOTAL_SH: 0,
                PMUY_SH: 0
            };

            $scope.distSearch = {
                text: ""
            };

            try {
                $http.get("https://xsparsh.indianoil.in:8443/soa-infra/resources/default/MpowerLPG/NFRReport?sales_group=" + $scope.employee.salesGroup)
                    .success(function (data, status) {
                        try {
                            $scope.nfrList = data.dbNFROutput;
                            for (var ii = 0; ii < $scope.nfrList.length; ii++) {
                                $scope.totalInfo.TOTAL_NCR += parseInt($scope.nfrList[ii].TOTAL_NCR);
                                $scope.totalInfo.PMUY_NCR += parseInt($scope.nfrList[ii].PMUY_NCR);
                                $scope.totalInfo.TOTAL_STOVE += parseInt($scope.nfrList[ii].TOTAL_STOVE);
                                $scope.totalInfo.PMUY_STOVE += parseInt($scope.nfrList[ii].PMUY_STOVE);
                                $scope.totalInfo.TOTAL_SH += parseInt($scope.nfrList[ii].TOTAL_SH);
                                $scope.totalInfo.PMUY_SH += parseInt($scope.nfrList[ii].PMUY_SH);
                            }

                            $scope.totalInfo.TOTAL_STOVE_PERC = (($scope.totalInfo.TOTAL_STOVE / $scope.totalInfo.TOTAL_NCR) * 100).toFixed(2);
                            $scope.totalInfo.PMUY_STOVE_PERC = (($scope.totalInfo.PMUY_STOVE / $scope.totalInfo.PMUY_NCR) * 100).toFixed(2);

                            $scope.totalInfo.TOTAL_SH_PERC = (($scope.totalInfo.TOTAL_SH / $scope.totalInfo.TOTAL_NCR) * 100).toFixed(2);
                            $scope.totalInfo.PMUY_SH_PERC = (($scope.totalInfo.PMUY_SH / $scope.totalInfo.PMUY_NCR) * 100).toFixed(2);


                            $ionicLoading.hide();
                        } catch (e1) {
                            //alert(e1);
                            alert("Runtime Error occurred. Please try after sometime");
                            $scope.error = true;
                            $ionicLoading.hide();
                        }

                    }).error(onError);
            } catch (e) {
                //alert(e);
                alert("Runtime Error occurred. Please try after sometime");
                $scope.error = true;
                $ionicLoading.hide();
            }
        });


        $scope.selectDistributor = function (dist) {
            if (dist) {
                $scope.currentDistNFR = dist;

                if ($scope.currentDistNFR.TOTAL_STOVE > 0) {
                    $scope.currentDistNFR.TOTAL_STOVE_PERC = (($scope.currentDistNFR.TOTAL_STOVE / $scope.currentDistNFR.TOTAL_NCR) * 100).toFixed(2);
                } else {
                    $scope.currentDistNFR.TOTAL_STOVE_PERC = 0;
                }

                if ($scope.currentDistNFR.PMUY_STOVE > 0) {
                    $scope.currentDistNFR.PMUY_STOVE_PERC = (($scope.currentDistNFR.PMUY_STOVE / $scope.currentDistNFR.PMUY_NCR) * 100).toFixed(2);
                } else {
                    $scope.currentDistNFR.PMUY_STOVE_PERC = 0;
                }

                if ($scope.currentDistNFR.TOTAL_SH > 0) {
                    $scope.currentDistNFR.TOTAL_SH_PERC = (($scope.currentDistNFR.TOTAL_SH / $scope.currentDistNFR.TOTAL_NCR) * 100).toFixed(2);
                } else {
                    $scope.currentDistNFR.TOTAL_SH_PERC = 0;
                }

                if ($scope.currentDistNFR.PMUY_SH > 0) {
                    $scope.currentDistNFR.PMUY_SH_PERC = (($scope.currentDistNFR.PMUY_SH / $scope.currentDistNFR.PMUY_NCR) * 100).toFixed(2);
                } else {
                    $scope.currentDistNFR.PMUY_SH_PERC = 0;
                }





                $scope.nfrView = true;
            } else {
                $scope.currentDistNFR = {};
                $scope.nfrView = false;
            }
        }

        function onError(data) {
            $scope.error = true;
            $ionicLoading.hide();
        }

        $scope.goHome = function () {
            $state.go("LPGHome");
        }
    }

    var LPGIndaneController = function ($scope, userService, $ionicPopup, $http, $timeout, $ionicLoading, $state) {


        $ionicLoading.show({
            template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
        });
        $scope.$on('$ionicView.enter', function () {
            $scope.employee = userService.getUser();
            $scope.tabNumber = 1;
            $scope.error = false;
            $scope.indaneReport = {
                report1: [],
                report1Loaded: false,
                report2: [],
                report2Loaded: false
            }


            try {
                var inputData = {
                    "sales_area": $scope.employee.salesGroup,
                    "secretKey": "f11583391f7b0ea047e5671770645d26"
                }

                var url = "https://indane.co.in/mpowerApiServices/ncPendencyRpt.php";

                $http.post(url, inputData)
                    .success(function (data, status) {
                        try {

                            if (Array.isArray(data)) {
                                $scope.indaneReport.report1 = data;
                            } else {
                                $scope.indaneReport.report1 = [];
                            }
                            $scope.indaneReport.report1Loaded = true;
                            $ionicLoading.hide();
                        } catch (e1) {
                            alert(e1);
                            $scope.error = true;
                            $ionicLoading.hide();
                        }

                    }).error(onError);
            } catch (ee) {
                //alert(ee);
                alert("Runtime Error occurred. Please try after sometime");
                $scope.error = true;
                $ionicLoading.hide();
            }

        });

        function onError(data) {
            $scope.error = true;
            $ionicLoading.hide();
        }

        $scope.showReport = function (id) {
            $scope.tabNumber = id;

            if (id == 2) {
                if (!$scope.indaneReport.report2Loaded) {
                    $ionicLoading.show({
                        template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
                    });
                    try {
                        var inputData = {
                            "sales_area": $scope.employee.salesGroup,
                            "secretKey": "f11583391f7b0ea047e5671770645d26"
                        }

                        var url = "https://indane.co.in/mpowerApiServices/portPendencyRpt.php";

                        $http.post(url, inputData)
                            .success(function (data, status) {
                                try {

                                    if (Array.isArray(data)) {
                                        $scope.indaneReport.report2 = data;
                                    } else {
                                        $scope.indaneReport.report2 = [];
                                    }
                                    $scope.indaneReport.report2Loaded = true;
                                    $ionicLoading.hide();
                                } catch (e1) {
                                    alert(e1);
                                    $scope.error = true;
                                    $ionicLoading.hide();
                                }

                            }).error(onError);
                    } catch (ee) {
                        //alert(ee);
                        alert("Runtime Error occurred. Please try after sometime");
                        $scope.error = true;
                        $ionicLoading.hide();
                    }
                }
            }
        }

        $scope.goHome = function () {
            $state.go("LPGHome");
        }
    }

    var LPGSocialController = function ($scope, userService, $ionicPopup, $http, $timeout, $ionicLoading, $state) {
        $ionicLoading.show({
            template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
        });
        $scope.$on('$ionicView.enter', function () {
            $scope.error = false;
            $scope.employee = userService.getUser();

            try {
                /*
                var url = "https://xsparsh.indianoil.in:8443/soa-infra/resources/default/MpowerLPG/SocialComplaint?sales_group=" + $scope.employee.salesGroup;

                $http.get(url)
                    .success(function (data, status) {
                        try {
                            if (data != null) {
                                $scope.socialData = data.dbSocialOutput;

                            } else {
                                $scope.socialData = [];
                            }
                            $ionicLoading.hide();
                        } catch (e1) {
                            //alert(e1);
                            alert("Runtime Error occurred. Please try after sometime");
                            $scope.error = true;
                            $ionicLoading.hide();
                        }

                    }).error(onError);
                    */
                var payLoad = {
                    "Status": "In Progress",
                    "SRCount": "1",
                    "SubStatus": "In Progress",
                    "SalesGroup":  $scope.employee.salesGroup //"B59"
                }
                var request = $http({
                    method: "post",
                    url: "https://api.indianoil.in/CRMNexPRDExt/ServiceRequestMgmt/GetSocialSR",
                    headers: {
                        'Content-Type': 'application/json',
                        'Authorization': 'Basic bW9iaWxpdHlfdXNlcjptb2IhbCF0eUAxMjM='//  Basic bW9iaWxpdHlfdXNlcjptb2IhbCF0eUAx
                    },
                    data: payLoad
                });
                request.success(
                    function (data) {
                        $ionicLoading.hide();
                        if (data.ErrorMessage.toUpperCase() == "SUCCESS") {
                            if (data != null) {
                                $scope.socialData = data.ServiceRequest;

                            } else {
                                $scope.socialData = [];
                                var alertPopup = $ionicPopup.alert({
                                    title: '<span style="color:#10224d">Status</span>',
                                    template: "No Data Found."
                                });
                            }
                        }
                        else {
                            var alertPopup = $ionicPopup.alert({
                                title: '<span style="color:#10224d">Status</span>',
                                template: data.ErrorMessage
                            });
                        }
                        $scope.goBack();
                    }
                ).error(function () {
                    $ionicLoading.hide();
                    var alertPopup = $ionicPopup.alert({
                                title: '<span style="color:#10224d">Status</span>',
                                template: "Problem occured while retrieving data. Please try after some time."
                    });
                    //TODO error 
                });
            } catch (ee) {
                //alert(ee);
                alert("Runtime Error occurred. Please try after sometime");
                $scope.error = true;
                $ionicLoading.hide();
            }
        });

        function onError(data) {
            $scope.error = true;
            $ionicLoading.hide();
        }

        $scope.goHome = function () {
            $state.go("LPGHome");
        }
    }

    var PRMSController = function ($scope, userService, $ionicPopup, $http, $timeout, $ionicLoading, $state) {
        $ionicLoading.show({
            template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
        });
        $scope.$on('$ionicView.enter', function () {
            $scope.error = false;
            $scope.employee = userService.getUser();
            $ionicLoading.hide();
        });

    }

    app.controller("LPGHomeController", LPGHomeController);
    app.controller("LPGProfileController", LPGProfileController);
    app.controller("LPGDistController", LPGDistController);
    app.controller("LPGProfileSumaryController", LPGProfileSumaryController);
    app.controller("LPGDistDBController", LPGDistDBController);
    app.controller("LPGBalanceController", LPGBalanceController);
    app.controller("LPGSalesTrackerController", LPGSalesTrackerController);
    app.controller("LPGOrderController", LPGOrderController);
    app.controller("LPGRTDController", LPGRTDController);
    app.controller("LPGEodStatusController", LPGEodStatusController);
    app.controller("LPGEodSummaryController", LPGEodSummaryController);
    app.controller("LPGStockController", LPGStockController);
    app.controller("LPGNFRController", LPGNFRController);
    app.controller("LPGIndaneController", LPGIndaneController);
    app.controller("LPGSocialController", LPGSocialController);

}());

