(function () {
    /** 
     * Code created by Awanish Singh
     * date : 28 Aug 2018
    */
    var app = angular.module('mPOWER');

    var inrFilter = function () {
        return function (input) {
            if (!isNaN(input)) {
                //var output = Number(input).toLocaleString('en-IN');   <-- This method is not working fine in all browsers!           
                var result = input.toString().split('.');

                var lastThree = result[0].substring(result[0].length - 3);
                var otherNumbers = result[0].substring(0, result[0].length - 3);
                if (otherNumbers != '')
                    lastThree = ',' + lastThree;
                var output = otherNumbers.replace(/\B(?=(\d{2})+(?!\d))/g, ",") + lastThree;

                /*
                 if (result.length > 1) {
                 output += "." + result[1];
                 }
                 */

                return output;
            }
        }
    }

    var PTcontrollers = function ($scope, userService, $ionicPopup, $http, $timeout, $ionicLoading, $state) {

        $scope.appList = [
            {
                appId: "My Profile",
                viewName: "PTProfile",
                icon: "ion-person",
                showAll: true
            },
            {
                appId: "Price",
                viewName: "PTPrice",
                icon: "ion-pricetags",
                showAll: true
            },
            {
                appId: "Stock Info",
                viewName: "PTStockData",
                icon: "ion-soup-can",
                showAll: true
            },
            {
                appId: "Balance",
                viewName: "PTBalance",
                icon: "ion-cash",
                showAll: true
            },
            {
                appId: "Payments",
                viewName: "PTPayments",
                icon: "ion-card",
                showAll: true
            },
            {
                appId: "Indent Tracker",
                viewName: "PTOrder",
                icon: "ion-android-cart",
                showAll: true
            },
            {
                appId: "Sales Tracker",
                viewName: "PTSales",
                icon: "ion-stats-bars",
                showAll: true
            },
            {
                appId: "DCA Credit Limit",
                viewName: "PTdca",
                icon: "ion-levels",
                showAll: true
            },
            {
                appId: "DCA Sales",
                viewName: "PTdcaSales",
                icon: "ion-stats-bars",
                showAll: true
            },
            {
                appId: "DOPW Sales",
                viewName: "PTdopw",
                icon: "ion-podium",
                showAll: true
            },
            {
                appId: "Equivalent Grade",
                viewName: "PTEqvt",
                icon: "ion-arrow-swap",
                showAll: true
            },
            {
                appId: "Co-Producers",
                viewName: "PTCoP",
                icon: "ion-android-people",
                showAll: true
            }];

        $scope.$on('$ionicView.enter', function () {
            $scope.employee = userService.getUser();
            console.log($scope.appList);
            console.log($scope.employee.salesGroup);
            if ($scope.employee.salesGroup != "") {
                userService.setSalesGroupRO($scope.employee.salesGroup, function () {
                    console.log("do nothing");
                });
            } else {
                userService.setSalesGroupList(function () {
                    console.log("do nothing");
                });
            }
        });

        $scope.startApp = function (viewName) {
            console.log(viewName);
            userService.setpreviousView('RSHome');
            $state.go(viewName);
        }

        $scope.logOut = function () {
            $ionicLoading.show({
                template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
            });
            window.localStorage.setItem('empCode', "");
            window.localStorage.setItem('empPassword', "");
            $state.go('login');
            $timeout(function () {
                $ionicLoading.hide();
            }, 2000);
        }
    }

    var PTProfileController = function ($scope, userService, $ionicPopup, $http, $timeout, $ionicLoading, $state) {

        $scope.$on('$ionicView.enter', function () {
            $scope.employee = userService.getUser();
        });

        $scope.goHome = function () {
            $state.go("PTHome");
        }
    }


    var PTPriceController = function ($scope, userService, $ionicPopup, $http, $timeout, $ionicLoading, $state) {

        $ionicLoading.show({
            template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
        });
        $scope.$on('$ionicView.enter', function () {
            $scope.sapGrades = [];
            $scope.priceList = [];
            $scope.employee = userService.getUser();
            $scope.userInputs = {
                gradeType: "",
                plant: "",
                grade: "",
                priceLocation: "",
                supplyLocation: "",
                priceView: false
            };



            loadEqvtGrades();

            $scope.error = false;
        });

        function loadEqvtGrades() {
            $http.get("https://xsparsh.indianoil.in:8443/soa-infra/resources/default/PCM/SAPGrades/")
                .success(function (data) {
                    $scope.sapGrades = data.PcmSapGrades;
                    $ionicLoading.hide();
                }).error(function () {
                    alert("Error in fetching data");
                    $ionicLoading.hide();
                });

        }

        $scope.showPrice = function (sg) {

            console.log(JSON.stringify(sg));

            if ($scope.userInputs.plant == "") {
                alert("Enter Plant code");
                return;
            } else {
                $ionicLoading.show({
                    template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
                });
                $http.get("https://m.indianoil.in:8443/sap/opu/odata/sap/Z_BD_MPOWER_SRV/ProdPriceSet?$filter=Plant%20eq%20%27" + $scope.userInputs.plant + "%27%20and%20Grade%20eq%20%27" + sg.sapCode + "%27%20and%20PriceDomFlag%20eq%20%27X%27%20and%20GradeFlag%20eq%20%27" + sg.gradeType + "%27")
                    .success(function (data) {
                        $scope.priceList = data.d.results;
                        $scope.userInputs.supplyLocation = $scope.userInputs.priceLocation;
                        $scope.userInputs.priceLocation = "";
                        $scope.userInputs.priceView = true;
                        $ionicLoading.hide();
                    }).error(function () {
                        alert("Error in fetching data");
                        $ionicLoading.hide();
                    });
            }


        }

        $scope.goHome = function () {
            $state.go("PTHome");
        }

        $scope.goBack = function () {
            $scope.userInputs.grade = "";
            $scope.userInputs.plant = "";
            $scope.userInputs.priceLocation = "";
            $scope.userInputs.priceView = false;
        }

        $scope.gradeFilter = function (val) {

            var codeStr = val.gradeCode.concat(" ", val.sapCode);

            if ($scope.userInputs.grade != "") {
                if (codeStr.toLowerCase().indexOf($scope.userInputs.grade.toLowerCase()) > -1) {
                    return true;
                } else {
                    return false;
                }

            } else {
                return false;
            }
        }
    }


    var PTBalanceController = function ($scope, userService, $ionicPopup, $http, $timeout, $ionicLoading, $state) {

        $ionicLoading.show({
            template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
        });
        $scope.$on('$ionicView.enter', function () {
            $scope.custBalance = [];
            $scope.Code = {
                custCode: ''
            };
            $scope.employee = userService.getUser();

            $scope.error = false;
            $scope.balanceView = false;
            $ionicLoading.hide();

        });
        //298535 -- sample customer payer code
        $scope.get_balance = function () {

            if ($scope.Code.custCode.length != 10) {
                if ($scope.check($scope.Code.custCode) == 'null' || $scope.check($scope.Code.custCode) == '0') {
                    var myPopup = $ionicPopup.alert({
                        title: 'Alert',
                        template: "Enter a valid customer code !"
                    });
                    return;
                }
            }
            try {
                $ionicLoading.show({
                    template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Loading!'
                });
                var ccInt = parseInt($scope.Code.custCode);
                $http.get("https://m.indianoil.in:8443/sap/opu/odata/sap/Z_BD_MPOWER_SRV/CustBalanceSet?$filter=Kunnr%20eq%20%270000" + ccInt + "%27&$format=json")
                    .success(function (data, status) {
                        $scope.custBalance = data.d.results;
                        $scope.balanceView = true;
                        $scope.Code.custCode = "";
                        $ionicLoading.hide();
                    }).error(userService.serviceCallError);
            } catch (e) {
                alert("Server Error");
                $ionicLoading.hide();
            }

        }

        $scope.check = function (custCode) {
            var temp1 = "0";
            try {
                var cc = parseInt(custCode);
                temp1 = custCode.toString();
                if ((temp1.length > 10) || (temp1.length < 4)) {

                    return 'null';

                }
                var i;
                var str = '0';
                var count = 10 - temp1.length;
                while (count) {
                    temp1 = str + temp1;
                    count = count - 1;
                }

            } catch (e) {
                return 'null';
            }


            return temp1;
        }


        $scope.goHome = function () {
            $state.go("PTHome");
        }
    }

    var PTStockController = function ($scope, userService, $ionicPopup, $http, $timeout, $ionicLoading, $state) {

        $ionicLoading.show({
            template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
        });
        $scope.$on('$ionicView.enter', function () {
            $scope.plantStock = [];
            $scope.userInputs = {
                plantCode: "",
                productType: "POL"
            };

            $scope.products = [{
                text: "Polymers",
                value: "POL"
            }, {
                text: "Aromatics",
                value: "A&C"
            }];
            $scope.employee = userService.getUser();

            $scope.error = false;
            $scope.stockView = false;
            $ionicLoading.hide();

        });
        //298535 -- sample customer payer code
        $scope.get_stock = function () {

            if ($scope.userInputs.plantCode.trim().length == 0) {
                var myPopup = $ionicPopup.alert({
                    title: 'Alert',
                    template: "Enter a valid plant code !"
                });
                return;
            }

            if ($scope.userInputs.plantCode.trim() == "0033") {
                var myPopup = $ionicPopup.alert({
                    title: 'Alert',
                    template: "Cannot show stock of location 0033"
                });
                return;
            }

            try {
                $ionicLoading.show({
                    template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Loading!'
                });
                $http.get("https://m.indianoil.in:8443/sap/opu/odata/sap/Z_BD_MPOWER_SRV/StockInfoSet?$filter=Werks%20eq%20%27" + $scope.userInputs.plantCode + "%27&$format=json")
                    .success(function (data, status) {
                        $scope.plantStock = data.d.results;
                        $scope.stockView = true;
                        $scope.userInputs.plantCode = "";
                        $ionicLoading.hide();
                    }).error(userService.serviceCallError);
            } catch (e) {
                alert("Server Error");
                $ionicLoading.hide();
            }

        }


        $scope.goHome = function () {
            $state.go("PTHome");
        }
    }

    var PTDCAController = function ($scope, userService, $ionicPopup, $http, $timeout, $ionicLoading, $state) {

        $ionicLoading.show({
            template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
        });
        $scope.$on('$ionicView.enter', function () {
            $scope.custBalance = [];
            $scope.Code = {
                custCode: "",
                dcaFilter: ""
            };
            $scope.dcaList = [];
            $scope.employee = userService.getUser();

            $scope.error = false;
            $scope.balanceView = false;
            loadDCA();
            //$ionicLoading.hide();

        });

        function loadDCA() {
            $http.get("https://xsparsh.indianoil.in:8443/soa-infra/resources/default/PCM/Customers/?ctype=DCA")
                .success(function (data) {
                    $scope.dcaList = data.PcmCustomers;
                    $ionicLoading.hide();
                }).error(function () {
                    alert("Error in fetching data");
                    $ionicLoading.hide();
                });

        }

        $scope.showBalance = function (dca) {
            $scope.Code.custCode = dca.sapCode;
            $scope.get_balance();
        }

        //298535 -- sample customer payer code
        $scope.get_balance = function () {

            if ($scope.Code.custCode.length != 10) {
                if ($scope.check($scope.Code.custCode) == 'null' || $scope.check($scope.Code.custCode) == '0') {
                    var myPopup = $ionicPopup.alert({
                        title: 'Alert',
                        template: "Enter a valid customer code !"
                    });
                    return;
                }
            }
            try {
                $ionicLoading.show({
                    template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Loading!'
                });
                var ccInt = parseInt($scope.Code.custCode);
                $http.get("https://m.indianoil.in:8443/sap/opu/odata/sap/Z_BD_MPOWER_SRV/DCACreditSet?$filter=Customer%20eq%20%270000" + ccInt + "%27&$format=json")
                    .success(function (data, status) {
                        $scope.custBalance = data.d.results;
                        for (var i = 0; i < $scope.custBalance.length; i++) {
                            if ($scope.custBalance[i].Balance > 0) {
                                $scope.custBalance[i].Balance = "(D) ₹ " + (Math.abs($scope.custBalance[i].Balance)).toString();
                            } else if ($scope.custBalance[i].Balance < 0) {
                                $scope.custBalance[i].Balance = "(C) ₹ " + (Math.abs($scope.custBalance[i].Balance)).toString();
                            } else {
                                $scope.custBalance[i].Balance = "(D) ₹ " + $scope.custBalance[i].Balance;
                            }

                            if ($scope.custBalance[i].Nxtrv) {
                                var tt = $scope.custBalance[i].Nxtrv.substring(6, $scope.custBalance[i].Nxtrv.length - 2);
                                var dd = new Date(parseInt(tt));
                                $scope.custBalance[i].Nxtrv = dd.toString().substring(0, 15);
                            }
                        }

                        $scope.balanceView = true;
                        $scope.Code.custCode = "";
                        $ionicLoading.hide();
                    }).error(userService.serviceCallError);
            } catch (e) {
                alert("Server Error");
                $ionicLoading.hide();
            }

        }

        $scope.check = function (custCode) {
            var temp1 = "0";
            try {
                var cc = parseInt(custCode);
                temp1 = custCode.toString();
                if ((temp1.length > 10) || (temp1.length < 4)) {

                    return 'null';

                }
                var i;
                var str = '0';
                var count = 10 - temp1.length;
                while (count) {
                    temp1 = str + temp1;
                    count = count - 1;
                }

            } catch (e) {
                return 'null';
            }


            return temp1;
        }

        $scope.goBack = function () {
            $scope.Code.dcaFilter = "";
            $scope.balanceView = false;
        }

        $scope.dcaFilter = function (val) {

            var codeStr = val.custName.toLowerCase().concat(" ", val.sapCode);

            if ($scope.Code.dcaFilter != "") {
                if (codeStr.toLowerCase().indexOf($scope.Code.dcaFilter.toLowerCase()) > -1) {
                    return true;
                } else {
                    return false;
                }

            } else {
                return false;
            }
        }


        $scope.goHome = function () {
            $state.go("PTHome");
        }
    }

    var PTDCASalesController = function ($scope, userService, $ionicPopup, $http, $timeout, $ionicLoading, $state) {

        $ionicLoading.show({
            template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
        });
        $scope.$on('$ionicView.enter', function () {
            $scope.custBalance = [];
            $scope.dcaSales = [];
            $scope.dataToShow = [];
            $scope.Code = {
                custCode: "",
                showCode: "",
                dcaFilter: "",
                selectedProduct: ""
            };

            $scope.products = ["POL-PP", "POL-HDPE", "POL-LLDPE"];
            $scope.dcaList = [];
            $scope.employee = userService.getUser();

            $scope.error = false;
            $scope.salesView = false;
            loadDCA();
            //$ionicLoading.hide();

        });

        function loadDCA() {
            $http.get("https://xsparsh.indianoil.in:8443/soa-infra/resources/default/PCM/Customers/?ctype=DCA")
                .success(function (data) {
                    $scope.dcaList = data.PcmCustomers;
                    $ionicLoading.hide();
                }).error(function () {
                    alert("Error in fetching data");
                    $ionicLoading.hide();
                });

        }

        $scope.showSales = function (dca) {
            $scope.Code.custCode = dca.sapCode;
            $scope.get_sales();
        }

        //298535 -- sample customer payer code
        $scope.get_sales = function () {

            if ($scope.Code.custCode.length != 10) {
                if ($scope.check($scope.Code.custCode) == 'null' || $scope.check($scope.Code.custCode) == '0') {
                    var myPopup = $ionicPopup.alert({
                        title: 'Alert',
                        template: "Enter a valid customer code !"
                    });
                    return;
                }
            }
            try {
                $ionicLoading.show({
                    template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Loading!'
                });
                var ccInt = parseInt($scope.Code.custCode);
                $http.get("https://m.indianoil.in:8443/sap/opu/odata/sap/Z_BD_DCA_STK_SALE_SRV/ZBDDCASTKSet?$filter=Kunnr%20eq%20%270000" + ccInt + "%27&$format=json")
                    .success(function (data, status) {
                        $scope.dcaSales = data.d.results;

                        for (var ii = 0; ii < $scope.dcaSales.length; ii++) {
                            $scope.dcaSales[ii].April = parseFloat($scope.dcaSales[ii].April).toFixed(3);
                            $scope.dcaSales[ii].May = parseFloat($scope.dcaSales[ii].May).toFixed(3);
                            $scope.dcaSales[ii].Jun = parseFloat($scope.dcaSales[ii].Jun).toFixed(3);
                            $scope.dcaSales[ii].July = parseFloat($scope.dcaSales[ii].July).toFixed(3);
                            $scope.dcaSales[ii].August = parseFloat($scope.dcaSales[ii].August).toFixed(3);
                            $scope.dcaSales[ii].September = parseFloat($scope.dcaSales[ii].September).toFixed(3);
                            $scope.dcaSales[ii].October = parseFloat($scope.dcaSales[ii].October).toFixed(3);
                            $scope.dcaSales[ii].November = parseFloat($scope.dcaSales[ii].November).toFixed(3);
                            $scope.dcaSales[ii].December = parseFloat($scope.dcaSales[ii].December).toFixed(3);
                            $scope.dcaSales[ii].January = parseFloat($scope.dcaSales[ii].January).toFixed(3);
                            $scope.dcaSales[ii].February = parseFloat($scope.dcaSales[ii].February).toFixed(3);
                            $scope.dcaSales[ii].March = parseFloat($scope.dcaSales[ii].March).toFixed(3);
                            $scope.dcaSales[ii].Total = parseFloat($scope.dcaSales[ii].Total).toFixed(3);
                        }

                        
                        $scope.Code.showCode = $scope.Code.custCode;
                        $scope.Code.custCode = "";

                        $scope.salesView = true;
                        $scope.Code.selectedProduct = "";
                        $scope.Code.selectedPlant = "";
                        $scope.refreshData();
                        $scope.Code.custCode = "";
                        $ionicLoading.hide();

                        $ionicLoading.hide();
                    }).error(userService.serviceCallError);
            } catch (e) {
                alert("Server Error");
                $ionicLoading.hide();
            }

        }



        $scope.refreshData = function () {
            var product = $scope.Code.selectedProduct;
            $scope.dataToShow = [];

            if (product == "") {
                $scope.tempGrouping = _.groupBy($scope.dcaSales, "Fyer");

                var keys = Object.keys($scope.tempGrouping);
                for (var i = 0; i < keys.length; i++) {
                    var key = keys[i];
                    var tempObj = {
                        Fyer: key,
                        April: 0,
                        May: 0,
                        Jun: 0,
                        July: 0,
                        August: 0,
                        September: 0,
                        October: 0,
                        November: 0,
                        December: 0,
                        January: 0,
                        February: 0,
                        March: 0,
                        Total: 0
                    }

                    tempObj.Fyer = key;

                    for (var jj = 0; jj < $scope.tempGrouping[key].length; jj++) {
                        tempObj.April += parseFloat($scope.tempGrouping[key][jj].April);
                        tempObj.May += parseFloat($scope.tempGrouping[key][jj].May);
                        tempObj.Jun += parseFloat($scope.tempGrouping[key][jj].Jun);
                        tempObj.July += parseFloat($scope.tempGrouping[key][jj].July);
                        tempObj.August += parseFloat($scope.tempGrouping[key][jj].August);
                        tempObj.September += parseFloat($scope.tempGrouping[key][jj].September);
                        tempObj.October += parseFloat($scope.tempGrouping[key][jj].October);
                        tempObj.November += parseFloat($scope.tempGrouping[key][jj].November);
                        tempObj.December += parseFloat($scope.tempGrouping[key][jj].December);
                        tempObj.January += parseFloat($scope.tempGrouping[key][jj].January);
                        tempObj.February += parseFloat($scope.tempGrouping[key][jj].February);
                        tempObj.March += parseFloat($scope.tempGrouping[key][jj].March);
                        tempObj.Total += parseFloat($scope.tempGrouping[key][jj].Total);
                    }

                    tempObj.April = parseFloat(tempObj.April).toFixed(3);
                    tempObj.May = parseFloat(tempObj.May).toFixed(3);
                    tempObj.Jun = parseFloat(tempObj.Jun).toFixed(3);
                    tempObj.July = parseFloat(tempObj.July).toFixed(3);
                    tempObj.August = parseFloat(tempObj.August).toFixed(3);
                    tempObj.September = parseFloat(tempObj.September).toFixed(3);
                    tempObj.October = parseFloat(tempObj.October).toFixed(3);
                    tempObj.November = parseFloat(tempObj.November).toFixed(3);
                    tempObj.December = parseFloat(tempObj.December).toFixed(3);
                    tempObj.January = parseFloat(tempObj.January).toFixed(3);
                    tempObj.February = parseFloat(tempObj.February).toFixed(3);
                    tempObj.March = parseFloat(tempObj.March).toFixed(3);
                    tempObj.Total = parseFloat(tempObj.Total).toFixed(3);
                    
                    $scope.dataToShow.push(tempObj);
                }

            } else {
                $scope.tempGrouping = _.groupBy($scope.dcaSales, "Fyer");

                var keys = Object.keys($scope.tempGrouping);
                for (var i = 0; i < keys.length; i++) {
                    var key = keys[i];
                    var tempObj = {
                        Fyer: key,
                        April: 0,
                        May: 0,
                        Jun: 0,
                        July: 0,
                        August: 0,
                        September: 0,
                        October: 0,
                        November: 0,
                        December: 0,
                        January: 0,
                        February: 0,
                        March: 0,
                        Total: 0
                    }

                    tempObj.Fyer = key;

                    for (var jj = 0; jj < $scope.tempGrouping[key].length; jj++) {
                        if ($scope.tempGrouping[key][jj].Matkl == product) {
                            tempObj.April += parseFloat($scope.tempGrouping[key][jj].April);
                            tempObj.May += parseFloat($scope.tempGrouping[key][jj].May);
                            tempObj.Jun += parseFloat($scope.tempGrouping[key][jj].Jun);
                            tempObj.July += parseFloat($scope.tempGrouping[key][jj].July);
                            tempObj.August += parseFloat($scope.tempGrouping[key][jj].August);
                            tempObj.September += parseFloat($scope.tempGrouping[key][jj].September);
                            tempObj.October += parseFloat($scope.tempGrouping[key][jj].October);
                            tempObj.November += parseFloat($scope.tempGrouping[key][jj].November);
                            tempObj.December += parseFloat($scope.tempGrouping[key][jj].December);
                            tempObj.January += parseFloat($scope.tempGrouping[key][jj].January);
                            tempObj.February += parseFloat($scope.tempGrouping[key][jj].February);
                            tempObj.March += parseFloat($scope.tempGrouping[key][jj].March);
                            tempObj.Total += parseFloat($scope.tempGrouping[key][jj].Total);
                        }

                    }

                    tempObj.April = parseFloat(tempObj.April).toFixed(3);
                    tempObj.May = parseFloat(tempObj.May).toFixed(3);
                    tempObj.Jun = parseFloat(tempObj.Jun).toFixed(3);
                    tempObj.July = parseFloat(tempObj.July).toFixed(3);
                    tempObj.August = parseFloat(tempObj.August).toFixed(3);
                    tempObj.September = parseFloat(tempObj.September).toFixed(3);
                    tempObj.October = parseFloat(tempObj.October).toFixed(3);
                    tempObj.November = parseFloat(tempObj.November).toFixed(3);
                    tempObj.December = parseFloat(tempObj.December).toFixed(3);
                    tempObj.January = parseFloat(tempObj.January).toFixed(3);
                    tempObj.February = parseFloat(tempObj.February).toFixed(3);
                    tempObj.March = parseFloat(tempObj.March).toFixed(3);
                    tempObj.Total = parseFloat(tempObj.Total).toFixed(3);
                    
                    $scope.dataToShow.push(tempObj);
                }
            }

        }


        $scope.check = function (custCode) {
            var temp1 = "0";
            try {
                var cc = parseInt(custCode);
                temp1 = custCode.toString();
                if ((temp1.length > 10) || (temp1.length < 4)) {

                    return 'null';

                }
                var i;
                var str = '0';
                var count = 10 - temp1.length;
                while (count) {
                    temp1 = str + temp1;
                    count = count - 1;
                }

            } catch (e) {
                return 'null';
            }


            return temp1;
        }



        $scope.goBack = function () {
            $scope.Code.dcaFilter = "";
            $scope.salesView = false;
        }

        $scope.dcaFilter = function (val) {

            var codeStr = val.custName.toLowerCase().concat(" ", val.sapCode);

            if ($scope.Code.dcaFilter != "") {
                if (codeStr.toLowerCase().indexOf($scope.Code.dcaFilter.toLowerCase()) > -1) {
                    return true;
                } else {
                    return false;
                }

            } else {
                return false;
            }
        }


        $scope.goHome = function () {
            $state.go("PTHome");
        }
    }


    var PTDOPWController = function ($scope, userService, $ionicPopup, $http, $timeout, $ionicLoading, $state) {

        $ionicLoading.show({
            template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
        });
        $scope.$on('$ionicView.enter', function () {
            $scope.dopwSales = [];
            $scope.plantList = [];

            $scope.dataToShow = [];

            $scope.Code = {
                custCode: "",
                dopwFilter: "",
                selectedProduct: "",
                selectedPlant: ""
            };
            $scope.products = ["POL-PP", "POL-HDPE", "POL-LLDPE"];


            $scope.selectedProduct = "";
            $scope.selectedPlant = "";
            $scope.employee = userService.getUser();

            $scope.error = false;
            $scope.salesView = false;

            loadDOPW();

            //$ionicLoading.hide();

        });


        function loadDOPW() {
            $http.get("https://xsparsh.indianoil.in:8443/soa-infra/resources/default/PCM/Customers/?ctype=DOPW")
                .success(function (data) {
                    $scope.dopwList = data.PcmCustomers;
                    $scope.refreshData("0", "0");
                    $ionicLoading.hide();
                }).error(function () {
                    alert("Error in fetching data");
                    $ionicLoading.hide();
                });

        }

        $scope.showSales = function (dopw) {
            $scope.Code.custCode = dopw.sapCode;
            $scope.get_sales();
        }

        //298535 -- sample customer payer code
        $scope.get_sales = function () {

            if ($scope.Code.custCode.length != 10) {
                if ($scope.check($scope.Code.custCode) == 'null' || $scope.check($scope.Code.custCode) == '0') {
                    var myPopup = $ionicPopup.alert({
                        title: 'Alert',
                        template: "Enter a valid customer code !"
                    });
                    return;
                }
            }
            try {
                $ionicLoading.show({
                    template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Loading!'
                });
                var ccInt = parseInt($scope.Code.custCode);
                $http.get("https://m.indianoil.in:8443/sap/opu/odata/sap/Z_BD_CUST_STOCK_SALE_SRV/CumsalecustSet?$filter=Kunnr%20eq%20%270000" + ccInt + "%27&$format=json")
                    .success(function (data, status) {
                        $scope.dopwSales = data.d.results;

                      
                        $scope.plantList = _.groupBy($scope.dopwSales, "Werks");
                        $scope.salesView = true;
                        $scope.Code.selectedProduct = "";
                        $scope.Code.selectedPlant = "";
                        $scope.refreshData();
                        $scope.Code.custCode = "";
                        $ionicLoading.hide();
                    }).error(userService.serviceCallError);
            } catch (e) {
                alert("Server Error");
                $ionicLoading.hide();
            }

        }

        $scope.refreshData = function () {
            var product = $scope.Code.selectedProduct;
            var plant = $scope.Code.selectedPlant;
            $scope.dataToShow = [];

            if (product == "" && plant == "") {
                $scope.tempGrouping = _.groupBy($scope.dopwSales, "Fyer");

                var keys = Object.keys($scope.tempGrouping);
                for (var i = 0; i < keys.length; i++) {
                    var key = keys[i];
                    var tempObj = {
                        Fyer: key,
                        April: 0,
                        May: 0,
                        Jun: 0,
                        July: 0,
                        August: 0,
                        September: 0,
                        October: 0,
                        November: 0,
                        December: 0,
                        January: 0,
                        February: 0,
                        March: 0,
                        Total: 0
                    }

                    tempObj.Fyer = key;

                    for (var jj = 0; jj < $scope.tempGrouping[key].length; jj++) {
                        tempObj.April += parseFloat($scope.tempGrouping[key][jj].April);
                        tempObj.May += parseFloat($scope.tempGrouping[key][jj].May);
                        tempObj.Jun += parseFloat($scope.tempGrouping[key][jj].Jun);
                        tempObj.July += parseFloat($scope.tempGrouping[key][jj].July);
                        tempObj.August += parseFloat($scope.tempGrouping[key][jj].August);
                        tempObj.September += parseFloat($scope.tempGrouping[key][jj].September);
                        tempObj.October += parseFloat($scope.tempGrouping[key][jj].October);
                        tempObj.November += parseFloat($scope.tempGrouping[key][jj].November);
                        tempObj.December += parseFloat($scope.tempGrouping[key][jj].December);
                        tempObj.January += parseFloat($scope.tempGrouping[key][jj].January);
                        tempObj.February += parseFloat($scope.tempGrouping[key][jj].February);
                        tempObj.March += parseFloat($scope.tempGrouping[key][jj].March);
                        tempObj.Total += parseFloat($scope.tempGrouping[key][jj].Total);
                    }

                    
                        tempObj.April = parseFloat(tempObj.April).toFixed(3);
                        tempObj.May = parseFloat(tempObj.May).toFixed(3);
                        tempObj.Jun = parseFloat(tempObj.Jun).toFixed(3);
                        tempObj.July = parseFloat(tempObj.July).toFixed(3);
                        tempObj.August = parseFloat(tempObj.August).toFixed(3);
                        tempObj.September = parseFloat(tempObj.September).toFixed(3);
                        tempObj.October = parseFloat(tempObj.October).toFixed(3);
                        tempObj.November = parseFloat(tempObj.November).toFixed(3);
                        tempObj.December = parseFloat(tempObj.December).toFixed(3);
                        tempObj.January = parseFloat(tempObj.January).toFixed(3);
                        tempObj.February = parseFloat(tempObj.February).toFixed(3);
                        tempObj.March = parseFloat(tempObj.March).toFixed(3);
                        tempObj.Total = parseFloat(tempObj.Total).toFixed(3);

                    


                    $scope.dataToShow.push(tempObj);
                }

            } else if (product != "" && plant == "") {
                $scope.tempGrouping = _.groupBy($scope.dopwSales, "Fyer");

                var keys = Object.keys($scope.tempGrouping);
                for (var i = 0; i < keys.length; i++) {
                    var key = keys[i];
                    var tempObj = {
                        Fyer: key,
                        April: 0,
                        May: 0,
                        Jun: 0,
                        July: 0,
                        August: 0,
                        September: 0,
                        October: 0,
                        November: 0,
                        December: 0,
                        January: 0,
                        February: 0,
                        March: 0,
                        Total: 0
                    }

                    tempObj.Fyer = key;

                    for (var jj = 0; jj < $scope.tempGrouping[key].length; jj++) {
                        if ($scope.tempGrouping[key][jj].Matkl == product) {
                            tempObj.April += parseFloat($scope.tempGrouping[key][jj].April);
                            tempObj.May += parseFloat($scope.tempGrouping[key][jj].May);
                            tempObj.Jun += parseFloat($scope.tempGrouping[key][jj].Jun);
                            tempObj.July += parseFloat($scope.tempGrouping[key][jj].July);
                            tempObj.August += parseFloat($scope.tempGrouping[key][jj].August);
                            tempObj.September += parseFloat($scope.tempGrouping[key][jj].September);
                            tempObj.October += parseFloat($scope.tempGrouping[key][jj].October);
                            tempObj.November += parseFloat($scope.tempGrouping[key][jj].November);
                            tempObj.December += parseFloat($scope.tempGrouping[key][jj].December);
                            tempObj.January += parseFloat($scope.tempGrouping[key][jj].January);
                            tempObj.February += parseFloat($scope.tempGrouping[key][jj].February);
                            tempObj.March += parseFloat($scope.tempGrouping[key][jj].March);
                            tempObj.Total += parseFloat($scope.tempGrouping[key][jj].Total);
                        }

                    }

                    tempObj.April = parseFloat(tempObj.April).toFixed(3);
                    tempObj.May = parseFloat(tempObj.May).toFixed(3);
                    tempObj.Jun = parseFloat(tempObj.Jun).toFixed(3);
                    tempObj.July = parseFloat(tempObj.July).toFixed(3);
                    tempObj.August = parseFloat(tempObj.August).toFixed(3);
                    tempObj.September = parseFloat(tempObj.September).toFixed(3);
                    tempObj.October = parseFloat(tempObj.October).toFixed(3);
                    tempObj.November = parseFloat(tempObj.November).toFixed(3);
                    tempObj.December = parseFloat(tempObj.December).toFixed(3);
                    tempObj.January = parseFloat(tempObj.January).toFixed(3);
                    tempObj.February = parseFloat(tempObj.February).toFixed(3);
                    tempObj.March = parseFloat(tempObj.March).toFixed(3);
                    tempObj.Total = parseFloat(tempObj.Total).toFixed(3);

                    $scope.dataToShow.push(tempObj);
                }
            } else if (product == "" && plant != "") {
                $scope.tempGrouping = _.groupBy($scope.dopwSales, "Fyer");

                var keys = Object.keys($scope.tempGrouping);
                for (var i = 0; i < keys.length; i++) {
                    var key = keys[i];
                    var tempObj = {
                        Fyer: key,
                        April: 0,
                        May: 0,
                        Jun: 0,
                        July: 0,
                        August: 0,
                        September: 0,
                        October: 0,
                        November: 0,
                        December: 0,
                        January: 0,
                        February: 0,
                        March: 0,
                        Total: 0
                    }

                    tempObj.Fyer = key;

                    for (var jj = 0; jj < $scope.tempGrouping[key].length; jj++) {
                        if ($scope.tempGrouping[key][jj].Werks == plant) {
                            tempObj.April += parseFloat($scope.tempGrouping[key][jj].April);
                            tempObj.May += parseFloat($scope.tempGrouping[key][jj].May);
                            tempObj.Jun += parseFloat($scope.tempGrouping[key][jj].Jun);
                            tempObj.July += parseFloat($scope.tempGrouping[key][jj].July);
                            tempObj.August += parseFloat($scope.tempGrouping[key][jj].August);
                            tempObj.September += parseFloat($scope.tempGrouping[key][jj].September);
                            tempObj.October += parseFloat($scope.tempGrouping[key][jj].October);
                            tempObj.November += parseFloat($scope.tempGrouping[key][jj].November);
                            tempObj.December += parseFloat($scope.tempGrouping[key][jj].December);
                            tempObj.January += parseFloat($scope.tempGrouping[key][jj].January);
                            tempObj.February += parseFloat($scope.tempGrouping[key][jj].February);
                            tempObj.March += parseFloat($scope.tempGrouping[key][jj].March);
                            tempObj.Total += parseFloat($scope.tempGrouping[key][jj].Total);
                        }

                    }

                    tempObj.April = parseFloat(tempObj.April).toFixed(3);
                    tempObj.May = parseFloat(tempObj.May).toFixed(3);
                    tempObj.Jun = parseFloat(tempObj.Jun).toFixed(3);
                    tempObj.July = parseFloat(tempObj.July).toFixed(3);
                    tempObj.August = parseFloat(tempObj.August).toFixed(3);
                    tempObj.September = parseFloat(tempObj.September).toFixed(3);
                    tempObj.October = parseFloat(tempObj.October).toFixed(3);
                    tempObj.November = parseFloat(tempObj.November).toFixed(3);
                    tempObj.December = parseFloat(tempObj.December).toFixed(3);
                    tempObj.January = parseFloat(tempObj.January).toFixed(3);
                    tempObj.February = parseFloat(tempObj.February).toFixed(3);
                    tempObj.March = parseFloat(tempObj.March).toFixed(3);
                    tempObj.Total = parseFloat(tempObj.Total).toFixed(3);

                    $scope.dataToShow.push(tempObj);
                }
            } else {
                $scope.tempGrouping = _.groupBy($scope.dopwSales, "Fyer");

                var keys = Object.keys($scope.tempGrouping);
                for (var i = 0; i < keys.length; i++) {
                    var key = keys[i];
                    var tempObj = {
                        Fyer: key,
                        April: 0,
                        May: 0,
                        Jun: 0,
                        July: 0,
                        August: 0,
                        September: 0,
                        October: 0,
                        November: 0,
                        December: 0,
                        January: 0,
                        February: 0,
                        March: 0,
                        Total: 0
                    }

                    tempObj.Fyer = key;

                    for (var jj = 0; jj < $scope.tempGrouping[key].length; jj++) {
                        if ($scope.tempGrouping[key][jj].Werks == plant && $scope.tempGrouping[key][jj].Matkl == product) {
                            tempObj.April += parseFloat($scope.tempGrouping[key][jj].April);
                            tempObj.May += parseFloat($scope.tempGrouping[key][jj].May);
                            tempObj.Jun += parseFloat($scope.tempGrouping[key][jj].Jun);
                            tempObj.July += parseFloat($scope.tempGrouping[key][jj].July);
                            tempObj.August += parseFloat($scope.tempGrouping[key][jj].August);
                            tempObj.September += parseFloat($scope.tempGrouping[key][jj].September);
                            tempObj.October += parseFloat($scope.tempGrouping[key][jj].October);
                            tempObj.November += parseFloat($scope.tempGrouping[key][jj].November);
                            tempObj.December += parseFloat($scope.tempGrouping[key][jj].December);
                            tempObj.January += parseFloat($scope.tempGrouping[key][jj].January);
                            tempObj.February += parseFloat($scope.tempGrouping[key][jj].February);
                            tempObj.March += parseFloat($scope.tempGrouping[key][jj].March);
                            tempObj.Total += parseFloat($scope.tempGrouping[key][jj].Total);
                        }

                    }

                    tempObj.April = parseFloat(tempObj.April).toFixed(3);
                    tempObj.May = parseFloat(tempObj.May).toFixed(3);
                    tempObj.Jun = parseFloat(tempObj.Jun).toFixed(3);
                    tempObj.July = parseFloat(tempObj.July).toFixed(3);
                    tempObj.August = parseFloat(tempObj.August).toFixed(3);
                    tempObj.September = parseFloat(tempObj.September).toFixed(3);
                    tempObj.October = parseFloat(tempObj.October).toFixed(3);
                    tempObj.November = parseFloat(tempObj.November).toFixed(3);
                    tempObj.December = parseFloat(tempObj.December).toFixed(3);
                    tempObj.January = parseFloat(tempObj.January).toFixed(3);
                    tempObj.February = parseFloat(tempObj.February).toFixed(3);
                    tempObj.March = parseFloat(tempObj.March).toFixed(3);
                    tempObj.Total = parseFloat(tempObj.Total).toFixed(3);
                    
                    $scope.dataToShow.push(tempObj);
                }
            }

        }

        $scope.check = function (custCode) {
            var temp1 = "0";
            try {
                var cc = parseInt(custCode);
                temp1 = custCode.toString();
                if ((temp1.length > 10) || (temp1.length < 4)) {

                    return 'null';

                }
                var i;
                var str = '0';
                var count = 10 - temp1.length;
                while (count) {
                    temp1 = str + temp1;
                    count = count - 1;
                }

            } catch (e) {
                return 'null';
            }


            return temp1;
        }

        $scope.goBack = function () {
            $scope.Code.dopwFilter = "";
            $scope.salesView = false;
        }

        $scope.dopwFilter = function (val) {

            var codeStr = val.custName.toLowerCase().concat(" ", val.sapCode);

            if ($scope.Code.dopwFilter != "") {
                if (codeStr.toLowerCase().indexOf($scope.Code.dopwFilter.toLowerCase()) > -1) {
                    return true;
                } else {
                    return false;
                }

            } else {
                return false;
            }
        }


        $scope.goHome = function () {
            $state.go("PTHome");
        }
    }


    var PTPaymentsController = function ($scope, userService, $ionicPopup, $http, $timeout, $ionicLoading, $state) {

        $ionicLoading.show({
            template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
        });
        $scope.$on('$ionicView.enter', function () {
            $scope.Custpayments = [];
            $scope.employee = userService.getUser();
            $scope.Code = {
                custCode: ''
            };

            $scope.error = false;
            $scope.paymentView = false;
            $ionicLoading.hide();

        });

        $scope.get_payments = function (ro) {
            if (true) {
                if ($scope.Code.custCode.length != 10) {
                    //$scope.Code.custCode = ;
                    if ($scope.check($scope.Code.custCode) == 'null' || $scope.check($scope.Code.custCode) == '0') {
                        var myPopup = $ionicPopup.alert({
                            title: 'Alert',
                            template: "Enter a valid customer code !"
                        });

                        return;
                    }
                }
                try {
                    $ionicLoading.show({
                        template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Loading!'
                    });

                    var ccInt = parseInt($scope.Code.custCode);


                    $http.get("https://m.indianoil.in:8443/sap/opu/odata/sap/Z_MP_SERVICES_SRV/ZMPPAYMENTSSet?$filter=Kunnr%20eq%20%270000" + ccInt + "%27&$format=json")
                        .success(function (data, status) {
                            if (data && data.d && data.d.results && data.d.results.length > 0) {
                                $scope.Custpayments = data.d.results;
                                $scope.consumer_name = "";
                                for (i = 0; i < $scope.Custpayments.length; i++) {
                                    $scope.Custpayments[i].Cpudt = Format($scope.Custpayments[i].Cpudt);
                                }
                            } else {
                                alert("No Data Found. Check whether consumer number is correct or not.");
                            }
                            $scope.paymentView = true;
                            $scope.Code.custCode = "";
                            $ionicLoading.hide();
                        }).error(userService.serviceCallError);
                } catch (e) {
                    alert("Server Error");
                    $ionicLoading.hide();
                }

            } else {
                $scope.custPayment = [];
                $scope.paymentView = false;
            }
        }

        $scope.check = function (custCode) {
            var temp1 = "0";
            try {
                var cc = parseInt(custCode);
                temp1 = custCode.toString();
                if ((temp1.length > 10) || (temp1.length < 4)) {

                    return 'null';

                }
                var i;
                var str = '0';
                var count = 10 - temp1.length;
                while (count) {
                    temp1 = str + temp1;
                    count = count - 1;
                }

            } catch (e) {
                return 'null';
            }


            return temp1;
        }


        function Format(date) {


            var res = date.substring(6, date.length - 2);
            // alert(res);
            var theDate = new Date(Number(res));
            var dateString = theDate.toGMTString();
            return dateString.substring(4, dateString.length - 12);

        }

        $scope.goHome = function () {
            $state.go("PTHome");
        }
    }

    var PTSalesController = function ($scope, userService, $ionicPopup, $http, $ionicLoading, $state) {

        $ionicLoading.show({
            template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
        });
        $scope.$on('$ionicView.enter', function () {
            $scope.employee = userService.getUser();
            $scope.distWiseSales = [];
            $scope.prodWiseSales = [];
            $scope.cumSales = [];
            $scope.error = false;
            $scope.salesView = false;
            $scope.tabNumber = 'T';

            $scope.sales = {
                fromDate: "",
                toDate: "",
                finalFDate: "",
                finalTDate: "",
                sg: "",
                cumSalesExist: false,
                prodSalesExist: false,
                distSalesExist: false,
                selectedProduct: "",
                selectedDist: "",
                heirType: "",
                heirKey: "",
                heirValue: "",
                lySales: 0,
                cySales: 0
            };
            $ionicLoading.hide();
        });

        function onError(data) {
            $scope.error = true;
            $ionicLoading.hide();
        }

        $scope.goBack = function () {
            $scope.salesView = false;
            $scope.distWiseSales = [];
            $scope.prodWiseSales = [];
            $scope.cumSales = [];
            $scope.sales = {
                fromDate: "",
                toDate: "",
                finalFDate: "",
                finalTDate: "",
                sg: "",
                cumSalesExist: false,
                prodSalesExist: false,
                distSalesExist: false,
                selectedProduct: "",
                selectedDist: ""
            };
            $scope.tabNumber = 'T';
        }

        $scope.showSales = function (type) {
            if (type == "T") {
                if (!$scope.sales.cumSalesExist) {
                    fetchSales("T", function () {
                        $scope.tabNumber = type;
                    })
                } else {
                    $scope.tabNumber = type;
                }
            } else if (type == "P") {
                if (!$scope.sales.prodSalesExist) {
                    fetchSales("P", function () {
                        $scope.tabNumber = type;
                    })
                } else {
                    $scope.tabNumber = type;
                }
            } else if (type == "D") {
                if (!$scope.sales.distSalesExist) {
                    fetchSales("D", function () {
                        $scope.tabNumber = type;
                    })
                } else {
                    $scope.tabNumber = type;
                }
            }
        }

        function fetchSales(type, cb) {
            $ionicLoading.show({
                template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
            });

            var entitySet = "";
            var compareKey = "";
            var compareValue = "";

            if (type == "T") {
                entitySet = "CustDSSalesSet";
            } else if (type == "P") {
                entitySet = "CustMSSalesSet";
            } else if (type == "D") {
                entitySet = "CustCSSalesSet";
            }
            compareKey = "Vkgrp";
            compareValue = $scope.sales.sg.toUpperCase();
            $scope.sales.heirType = "Customer";
            $scope.sales.heirKey = "Pkunwe";
            $scope.sales.heirValue = "CustName";

            var url = "https://m.indianoil.in:8443/sap/opu/odata/sap/Z_MP_LPG_SERVICES_SRV/" + entitySet + "?$filter=" + compareKey + "%20eq%20%27" + compareValue + "%27%20and%20IDateFrom%20eq%20datetime%27" + $scope.sales.finalFDate + "T00:00:00%27%20and%20IDateTo%20eq%20datetime%27" + $scope.sales.finalTDate + "T00:00:00%27&$format=json"

            $http.get(url)
                .success(function (data, status) {
                    try {

                        if (type == "T") {
                            $scope.cumSales = data.d.results;
                            $scope.sales.cumSalesExist = true;
                        } else if (type == "P") {
                            $scope.prodWiseSales = data.d.results;
                            $scope.sales.prodSalesExist = true;
                            $scope.prodList = _.groupBy($scope.prodWiseSales, "Matnr");
                            $scope.sales.selectedProduct = $scope.prodList[Object.keys($scope.prodList)[0]][0].Matnr;
                        } else if (type == "D") {
                            $scope.distWiseSales = data.d.results;
                            $scope.sales.distSalesExist = true;
                            $scope.distList = _.groupBy($scope.distWiseSales, $scope.sales.heirKey);
                            $scope.sales.selectedDist = $scope.distList[Object.keys($scope.distList)[0]][0][$scope.sales.heirKey];
                        }

                        cb();
                        $scope.salesView = true;
                        $ionicLoading.hide();
                    } catch (e1) {
                        //alert(e1);
                        alert("Runtime Error occurred. Please try after sometime");
                        $scope.error = true;
                        $ionicLoading.hide();
                        cb();
                    }

                }).error(function () {
                    $scope.error = true;
                    $ionicLoading.hide();
                    cb();
                });




        }

        $scope.getSales = function () {
            if (validateValues()) {
                $ionicLoading.show({
                    template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Loading!'
                });

                try {
                    if ($scope.sales.fromDate == null || $scope.sales.fromDate == "" ||
                        $scope.sales.toDate == null || $scope.sales.toDate == "" || $scope.sales.sg.trim() == null || $scope.sales.sg.trim() == "") {
                        alert("All fields are mandatory");
                        $ionicLoading.hide();
                    } else {
                        var fromDate = new Date($scope.sales.fromDate);
                        var toDate = new Date($scope.sales.toDate);
                        $scope.sales.finalFDate = fromDate.getFullYear() + "-" + (fromDate.getMonth() + 1) + "-" + fromDate.getDate();
                        $scope.sales.finalTDate = toDate.getFullYear() + "-" + (toDate.getMonth() + 1) + "-" + toDate.getDate();
                        //$scope.sales.sg = $scope.employee.salesGroup;


                        var entitySet = "";
                        var compareKey = "";
                        var compareValue = "";
                        var compareString = "";
                        var url = "https://m.indianoil.in:8443/sap/opu/odata/sap/Z_MP_LPG_SERVICES_SRV/";

                        entitySet = "CustDSSalesSet";
                        compareKey = "Vkgrp";
                        compareValue = $scope.sales.sg.toUpperCase();
                        $scope.sales.heirType = "Customer";
                        $scope.sales.heirKey = "Pkunwe";
                        $scope.sales.heirValue = "CustName";
                        url = url + entitySet + "?$filter=" + compareKey + "%20eq%20%27" + compareValue + "%27%20and%20IDateFrom%20eq%20datetime%27" + $scope.sales.finalFDate + "T00:00:00%27%20and%20IDateTo%20eq%20datetime%27" + $scope.sales.finalTDate + "T00:00:00%27&$format=json"


                        //alert(url);

                        $http.get(url)
                            .success(function (data, status) {
                                try {
                                    $scope.cumSales = data.d.results;
                                    $scope.sales.heirType = "Customer";
                                    $scope.sales.heirKey = "Pkunwe";
                                    $scope.sales.heirValue = "CustName";

                                    $scope.sales.cumSalesExist = true;
                                    $scope.salesView = true;
                                    $ionicLoading.hide();
                                } catch (e1) {
                                    //alert(e1);
                                    alert("Runtime Error occurred. Please try after sometime");
                                    $scope.error = true;
                                    $ionicLoading.hide();
                                }

                            }).error(onError);
                    }


                } catch (ee) {
                    //alert(ee);
                    alert("Runtime Error occurred. Please try after sometime");
                    $scope.error = true;
                    $ionicLoading.hide();
                }



            }
        }




        $scope.getSalesSum = function (items, kk) {
            return items
                .map(function (x) { return parseFloat(x[kk]); })
                .reduce(function (a, b) { return a + b; });
        };

        $scope.goHome = function () {
            $state.go("PTHome");
        }



        function validateValues() {
            try {
                var fromDate = new Date($scope.sales.fromDate);
                var toDate = new Date($scope.sales.toDate);

                var todayDate = new Date();

                fromDate = new Date(fromDate.getFullYear(), fromDate.getMonth(), fromDate.getDate()); //Year, Month, Date
                toDate = new Date(toDate.getFullYear(), toDate.getMonth(), toDate.getDate()); //Year, Month, Date
                todayDate = new Date(todayDate.getFullYear(), todayDate.getMonth(), todayDate.getDate());

                if (fromDate > toDate) {
                    alert("From date cannot more than To date");
                    return false;
                } else if (fromDate > todayDate) {
                    alert("From date cannot more than Today date");
                    return false;
                } else if (toDate > todayDate) {
                    alert("To date cannot more than Today date");
                    return false;
                } else {
                    var a = (todayDate - fromDate) / (1000 * 3600 * 24);
                    if (a > 90) {
                        alert("From Date cannot be less the 90 days.");
                        return false;
                    }
                }
                return true;
            } catch (e) {
                alert("Internal Error");
                return false;
            }
        }

    }

    var PTEqvtController = function ($scope, userService, $ionicPopup, $http, $timeout, $ionicLoading, $state) {

        $ionicLoading.show({
            template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
        });
        $scope.$on('$ionicView.enter', function () {
            $scope.eqvtGrades = [];
            $scope.employee = userService.getUser();
            $scope.userInputs = {
                eqvtFlag: 'I',
                oem: "",
                grade: ""
            };

            loadEqvtGrades();

            $scope.error = false;
            $ionicLoading.hide();
        });

        function loadEqvtGrades() {
            $http.get("https://xsparsh.indianoil.in:8443/soa-infra/resources/default/PCM/EqvtGrade/")
                .success(function (data) {
                    $scope.eqvtGrades = data.dbEqvtGradeOutput;
                    $ionicLoading.hide();
                }).error(function () {
                    alert("Error in fetching data");
                    $ionicLoading.hide();
                });

        }


        $scope.goHome = function () {
            $state.go("PTHome");
        }
    }

    var PTCoPController = function ($scope, userService, $ionicPopup, $http, $timeout, $ionicLoading, $state) {

        $ionicLoading.show({
            template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
        });
        $scope.$on('$ionicView.enter', function () {
            $scope.coProducers = [];
            $scope.employee = userService.getUser();
            $scope.userInputs = {
                eqvtFlag: 'I',
                oem: "",
                grade: ""
            };

            loadEqvtGrades();

            $scope.error = false;
            $ionicLoading.hide();
        });

        function loadEqvtGrades() {
            $http.get("https://xsparsh.indianoil.in:8443/soa-infra/resources/default/PCM/CoProducers/")
                .success(function (data) {
                    $scope.coProducers = data.dbCoProducersOutput;
                    $ionicLoading.hide();
                }).error(function () {
                    alert("Error in fetching data");
                    $ionicLoading.hide();
                });

        }


        $scope.goHome = function () {
            $state.go("PTHome");
        }
    }


    var PTOrderController = function ($scope, userService, $ionicPopup, $http, $ionicLoading, $state) {

        $ionicLoading.show({
            template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
        });
        $scope.$on('$ionicView.enter', function () {
            $scope.employee = userService.getUser();
            $scope.allOrders = [];
            $scope.custList = [];

            $scope.ordersDispatched = [];
            $scope.ordersLoading = [];
            $scope.ordersPending = [];
            $scope.error = false;
            $scope.inputView = true;
            $scope.orderView = false;
            $scope.tabNumber = "";
            $scope.currentOrder = {};


            $scope.order = {
                fromDate: "",
                toDate: "",
                finalFDate: "",
                finalTDate: "",
                sg: ""
            };
            $ionicLoading.hide();

        });


        function onError(data) {
            $scope.error = true;
            $ionicLoading.hide();
        }

        $scope.goBack = function () {
            $scope.inputView = true;
            $scope.allOrders = [];
            $scope.custList = [];
            $scope.tabNumber = "";

            $scope.ordersDispatched = [];
            $scope.ordersLoading = [];
            $scope.ordersPending = [];
        }

        $scope.selectDistributor = function (dist) {
            if (dist) {
                $scope.currentOrder = dist;
                $scope.orderView = true;
            } else {
                $scope.currentOrder = {};
                $scope.orderView = false;
            }
        }


        $scope.showOrderInfo = function (index) {
            for (var ii = 0; ii < $scope.currentOrder.length; ii++) {
                $scope.currentOrder[ii].show = false;
            }
            $scope.currentOrder[index].show = true;

        }

        $scope.getOrder = function () {
            if ($scope.order.sg.trim() != "" && validateValues()) {
                $ionicLoading.show({
                    template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Loading!'
                });

                try {
                    var fromDate = new Date($scope.order.fromDate);
                    var toDate = new Date($scope.order.toDate);
                    $scope.order.finalFDate = fromDate.getFullYear() + "-" + (fromDate.getMonth() + 1) + "-" + fromDate.getDate();
                    $scope.order.finalTDate = toDate.getFullYear() + "-" + (toDate.getMonth() + 1) + "-" + toDate.getDate();
                    //$scope.order.sg = $scope.employee.salesGroup;

                    var url = "https://m.indianoil.in:8443/sap/opu/odata/sap/Z_MP_SERVICES_SRV/ZMPORDERFLOWSet?$filter=Vkgrp%20eq%20%27" + $scope.order.sg.toUpperCase() + "%27%20and%20DateFrom%20eq%20datetime%27" + $scope.order.finalFDate + "T00:00:00%27%20and%20DateTo%20eq%20datetime%27" + $scope.order.finalTDate + "T00:00:00%27&$format=json"

                    $http.get(url)
                        .success(function (data, status) {
                            try {
                                $scope.allOrders = data.d.results;

                                for (var ii = 0; ii < $scope.allOrders.length; ii++) {
                                    $scope.allOrders[ii].show = false;
                                    if ($scope.allOrders[ii].Ordrdt) {
                                        var tt = $scope.allOrders[ii].Ordrdt.substring(6, $scope.allOrders[ii].Ordrdt.length - 2);
                                        console.log(tt);
                                        var dd = new Date(parseInt(tt));
                                        var tempDD = dd.getDate().toString() + "-" + (dd.getMonth() + 1).toString() + "-" + dd.getFullYear();
                                        $scope.allOrders[ii].Ordrdt = dd.toString().substring(0, 15);
                                        $scope.allOrders[ii].Ordrdt = tempDD;
                                    }
                                    if ($scope.allOrders[ii].DelDate) {
                                        var tt = $scope.allOrders[ii].DelDate.substring(6, $scope.allOrders[ii].DelDate.length - 2);
                                        var dd = new Date(parseInt(tt));
                                        var tempDD = dd.getDate().toString() + "-" + (dd.getMonth() + 1).toString() + "-" + dd.getFullYear();
                                        $scope.allOrders[ii].DelDate = dd.toString().substring(0, 15);
                                        $scope.allOrders[ii].DelDate = tempDD;
                                    }
                                    if ($scope.allOrders[ii].ShpmntDt) {
                                        var tt = $scope.allOrders[ii].ShpmntDt.substring(6, $scope.allOrders[ii].ShpmntDt.length - 2);
                                        var dd = new Date(parseInt(tt));
                                        var tempDD = dd.getDate().toString() + "-" + (dd.getMonth() + 1).toString() + "-" + dd.getFullYear();
                                        $scope.allOrders[ii].ShpmntDt = dd.toString().substring(0, 15);
                                        $scope.allOrders[ii].ShpmntDt = tempDD;
                                    }
                                    if ($scope.allOrders[ii].LoadDate) {
                                        var tt = $scope.allOrders[ii].LoadDate.substring(6, $scope.allOrders[ii].LoadDate.length - 2);
                                        var dd = new Date(parseInt(tt));
                                        var tempDD = dd.getDate().toString() + "-" + (dd.getMonth() + 1).toString() + "-" + dd.getFullYear();
                                        $scope.allOrders[ii].LoadDate = dd.toString().substring(0, 15);
                                        $scope.allOrders[ii].LoadDate = tempDD;
                                    }
                                    if ($scope.allOrders[ii].Reqdeldt) {
                                        var tt = $scope.allOrders[ii].Reqdeldt.substring(6, $scope.allOrders[ii].Reqdeldt.length - 2);
                                        var dd = new Date(parseInt(tt));
                                        var tempDD = dd.getDate().toString() + "-" + (dd.getMonth() + 1).toString() + "-" + dd.getFullYear();
                                        $scope.allOrders[ii].Reqdeldt = dd.toString().substring(0, 15);
                                        $scope.allOrders[ii].Reqdeldt = tempDD;
                                    }

                                    $scope.allOrders[ii].ShpmntTime = $scope.allOrders[ii].ShpmntTime.substring(2, 4) + ":" + $scope.allOrders[ii].ShpmntTime.substring(5, 7) + ":" + $scope.allOrders[ii].ShpmntTime.substring(8, 10);
                                    $scope.allOrders[ii].DelTime = $scope.allOrders[ii].DelTime.substring(2, 4) + ":" + $scope.allOrders[ii].DelTime.substring(5, 7) + ":" + $scope.allOrders[ii].DelTime.substring(8, 10);
                                    $scope.allOrders[ii].LoadTime = $scope.allOrders[ii].LoadTime.substring(2, 4) + ":" + $scope.allOrders[ii].LoadTime.substring(5, 7) + ":" + $scope.allOrders[ii].LoadTime.substring(8, 10);
                                    $scope.allOrders[ii].Erzet = $scope.allOrders[ii].Erzet.substring(2, 4) + ":" + $scope.allOrders[ii].Erzet.substring(5, 7) + ":" + $scope.allOrders[ii].Erzet.substring(8, 10);

                                    if (($scope.allOrders[ii].Comment).toLowerCase() == 'load dispatched') {
                                        $scope.ordersDispatched.push($scope.allOrders[ii]);
                                    } else if (($scope.allOrders[ii].Comment).toLowerCase() == 'delivery created' || ($scope.allOrders[ii].Comment).toLowerCase() == 'shipment created') {
                                        $scope.ordersLoading.push($scope.allOrders[ii]);
                                    } else {
                                        if (!(($scope.allOrders[ii].Comment).toLowerCase().indexOf('rejected') > -1)) {
                                            $scope.ordersPending.push($scope.allOrders[ii]);
                                        }
                                    }
                                }
                                if ($scope.allOrders.length > 0) {

                                    var prodOrderStatus = _.groupBy($scope.allOrders, "Matcode");

                                    $scope.prodOrderSummary = [];
                                    for (var pos in prodOrderStatus) {
                                        var tempArr = prodOrderStatus[pos];
                                        var tempObj = {
                                            product: "",
                                            productName: "",
                                            quantityDispatched: 0,
                                            quantityLoading: 0,
                                            quantityPending: 0
                                        }
                                        tempObj.product = prodOrderStatus[pos][0].Matcode;
                                        tempObj.productName = prodOrderStatus[pos][0].Matdesc;

                                        for (var jj = 0; jj < tempArr.length; jj++) {
                                            if (tempArr[jj].Comment == "Load Dispatched") {
                                                tempObj.quantityDispatched += parseFloat(tempArr[jj].Qunatity);
                                            } else if (tempArr[jj].Comment == "Delivery Created" || tempArr[jj].Comment == "Shipment Created") {
                                                tempObj.quantityLoading += parseFloat(tempArr[jj].Qunatity);
                                            } else {
                                                if (!((tempArr[jj].Comment).toLowerCase().indexOf('rejected') > -1)) {
                                                    tempObj.quantityPending += parseFloat(tempArr[jj].Qunatity);
                                                }
                                            }
                                        }
                                        tempObj.quantityDispatched = (tempObj.quantityDispatched);
                                        tempObj.quantityLoading = (tempObj.quantityLoading);
                                        tempObj.quantityPending = (tempObj.quantityPending);
                                        $scope.prodOrderSummary.push(tempObj);
                                    }


                                    //$scope.custList = _.groupBy($scope.allOrders, "Kunnr");
                                    $scope.inputView = false;
                                    $scope.tabNumber = "S";
                                    $ionicLoading.hide();
                                } else {
                                    alert("No orders to show");
                                    $ionicLoading.hide();
                                }
                            } catch (e1) {
                                console.log(e1);
                                //alert(e1);
                                alert("Runtime Error occurred. Please try after sometime");
                                $scope.error = true;
                                $ionicLoading.hide();
                            }

                        }).error(onError);


                } catch (ee) {
                    alert(ee);
                    $scope.error = true;
                    $ionicLoading.hide();
                }



            } else {
                alert("All fields are mandatory");
            }
        }

        $scope.showOrder = function (val) {
            if (val == "P") {
                $scope.orders = $scope.ordersPending;
            } else if (val == "L") {
                $scope.orders = $scope.ordersLoading;
            } else if (val == "D") {
                $scope.orders = $scope.ordersDispatched;
            } else if (val == "S") {
                $scope.orders = [];
            }
            $scope.tabNumber = val;

        }

        $scope.goHome = function () {
            $state.go("PTHome");
        }


        $scope.showOrderSummary = function (txt) {
            for (var ii = 0; ii < $scope.allOrders.length; ii++) {
                var tt = $scope.allOrders[ii].Ordrno.toString() + $scope.allOrders[ii].Matcode.toString();
                if (tt == txt) {
                    $scope.allOrders[ii].show = !$scope.allOrders[ii].show;
                } else {
                    $scope.allOrders[ii].show = false;
                }
            }
        }


        function validateValues() {
            try {
                if ($scope.order.fromDate == null || $scope.order.fromDate == "" ||
                    $scope.order.toDate == null || $scope.order.toDate == "") {
                    alert("Dates cannot be empty");
                    return false;
                } else {
                    var fromDate = new Date($scope.order.fromDate);
                    var toDate = new Date($scope.order.toDate);

                    var todayDate = new Date();

                    fromDate = new Date(fromDate.getFullYear(), fromDate.getMonth(), fromDate.getDate()); //Year, Month, Date
                    toDate = new Date(toDate.getFullYear(), toDate.getMonth(), toDate.getDate()); //Year, Month, Date
                    todayDate = new Date(todayDate.getFullYear(), todayDate.getMonth(), todayDate.getDate());

                    if (fromDate > toDate) {
                        alert("From date cannot more than To date");
                        return false;
                    } else if (fromDate > todayDate) {
                        alert("From date cannot more than Today date");
                        return false;
                    } else {
                        var a = (todayDate - fromDate) / (1000 * 3600 * 24);
                        if (a > 30) {
                            alert("From Date cannot be less the 30 days.");
                            return false;
                        }

                        var b = (toDate - fromDate) / (1000 * 3600 * 24);
                        if (b > 7) {
                            alert("Cannot fetch data for more than 7 days.");
                            return false;
                        }
                    }
                    return true;
                }
            } catch (e) {
                alert("Internal Error");
                return false;
            }
        }


    }



    app.controller("PTcontrollers", PTcontrollers);
    app.controller("PTProfileController", PTProfileController);
    app.controller("PTPriceController", PTPriceController);
    app.controller("PTBalanceController", PTBalanceController);
    app.controller("PTStockController", PTStockController);
    app.controller("PTDCAController", PTDCAController);
    app.controller("PTDCASalesController", PTDCASalesController);
    app.controller("PTDOPWController", PTDOPWController);
    app.controller("PTPaymentsController", PTPaymentsController);
    app.controller("PTSalesController", PTSalesController);
    app.controller("PTOrderController", PTOrderController);
    app.controller("PTEqvtController", PTEqvtController);
    app.controller("PTCoPController", PTCoPController);
    app.filter("INR", inrFilter);


}());

