(function () {

    var app = angular.module('mPOWER');

    var RSHomeController = function ($scope, userService, $ionicPopup, $http, $timeout, $ionicLoading, $state) {

        $scope.appList = [{
            appId: "My Profile",
            viewName: "RSProfile",
            icon: "ion-person",
            showAll: true
        },
        {
            appId: "Balance",
            viewName: "RSBalance",
            icon: "ion-cash",
            showAll: false
        },
        {
            appId: "Payments",
            viewName: "RSPayments",
            icon: "ion-cash",
            showAll: false
        },
        {
            appId: "Order Status",
            viewName: "RSOrder",
            icon: "ion-android-cart",
            showAll: false
        },
        {
            appId: "RSP",
            viewName: "RSRSP",
            icon: "ion-pricetags",
            showAll: false
        },
        {
            appId: "Rating",
            viewName: "RSRating",
            icon: "ion-android-star",
            showAll: true
        },
        {
            appId: "Daily Sales",
            viewName: "RSDailySales",
            icon: "ion-android-calendar",
            showAll: true
        },
        {
            appId: "Periodic Sales",
            viewName: "RSPeriodSales",
            icon: "ion-android-calendar",
            showAll: false
        },
        {
            appId: "Historic Sales",
            viewName: "RSHistSales",
            icon: "ion-stats-bars",
            showAll: true
        },
        {
            appId: "Cashless Report",
            viewName: "RSCashless",
            icon: "ion-card",
            showAll: true
        },
        {
            appId: "Stock Info",
            viewName: "RSStockData",
            icon: "ion-soup-can",
            showAll: true
        },
        {
            appId: "Market Intelligence",
            viewName: "RSMI",
            icon: "ion-arrow-graph-up-left",
            showAll: true
        },
        {
            appId: "Customer Centric Data",
            viewName: "RSCustomerCentric",
            icon: "ion-person",
            showAll: true
        },
        {
            appId: " Reset Xsparsh App IPIN ",
            viewName: "RSPinReset",
            icon: "ion-unlocked",
            showAll: false
        },
        {
            appId: " RDB Web Links ",
            viewName: "RSRDB",
            icon: "ion-link",
            showAll: false
        }];

        $scope.$on('$ionicView.enter', function () {
            $scope.employee = userService.getUser();
            console.log($scope.appList);
            console.log($scope.employee.salesGroup);
            if ($scope.employee.salesGroup != "") {
                userService.setSalesGroupRO($scope.employee.salesGroup, function () {
                    console.log("do nothing");
                });
            } else {
                userService.setSalesGroupList(function () {
                    console.log("do nothing");
                });
            }
        });

        $scope.startApp = function (viewName) {
            console.log(viewName);
            userService.setpreviousView('RSHome');
            $state.go(viewName);
        }

        $scope.logOut = function () {
            $ionicLoading.show({
                template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
            });
            window.localStorage.setItem('empCode', "");
            window.localStorage.setItem('empPassword', "");
            $state.go('login');
            $timeout(function () {
                $ionicLoading.hide();
            }, 2000);
        }
    }

    var RSRDBController = function ($scope, userService, $ionicPopup, $http, $timeout, $ionicLoading, $state) {

        $scope.appList = [];



        $scope.$on('$ionicView.enter', function () {
            $ionicLoading.show({
                template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
            });
            $scope.employee = userService.getUser();
            console.log($scope.appList);
            console.log($scope.employee.salesGroup);

            var urlS = "https://xsparsh.indianoil.in:8443/soa-infra/resources/default/CAEvaluation/WebLinks?appname=mPower";
            $http.get(urlS)
                .success(function (data, status) {
                    if (data) {
                        console.log(JSON.stringify(data.MobileAppLinks));
                        $scope.appList = data.MobileAppLinks;

                    }
                    $ionicLoading.hide();
                }).error(userService.serviceCallError);

        });

        $scope.startApp = function (url) {
            window.open(url, "_self");
        }

        $scope.goHome = function () {
            $state.go("RSHome");
        }
    }

    var RSProfileController = function ($scope, userService, $ionicPopup, $http, $timeout, $ionicLoading, $state) {

        $scope.$on('$ionicView.enter', function () {
            $scope.employee = userService.getUser();
        });

        $scope.goHome = function () {
            $state.go("RSHome");
        }
    }

    var RSBalanceController = function ($scope, userService, $ionicPopup, $http, $timeout, $ionicLoading, $state) {

        $ionicLoading.show({
            template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
        });
        $scope.$on('$ionicView.enter', function () {
            $scope.custBalance = [];
            $scope.employee = userService.getUser();

            $scope.searchRO = {
                input_text: ""
            };
            $scope.ROList = [];
            $scope.error = false;
            $scope.balanceView = false;
            try {
                if (userService.getSalesGroupRO().length > 0) {
                    $scope.ROList = userService.getSalesGroupRO();
                    $ionicLoading.hide();
                } else {
                    userService.setSalesGroupRO($scope.employee.salesGroup, function () {
                        $scope.ROList = userService.getSalesGroupRO();
                    });
                    $ionicLoading.hide();
                }
            } catch (e) {
                alert("Server Error");
                $scope.error = true;
            }



        });

        $scope.selectRO = function (ro) {
            if (ro) {
                try {
                    $ionicLoading.show({
                        template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Loading!'
                    });
                    var ro_code = "0000" + ro.ro_code;
                    $http.get("https://m.indianoil.in:8443/sap/opu/odata/sap/Z_XS_CUST_BAL_SRV/CcaBal1Set?$skip=0&$top=100&$inlinecount=allpages&$filter=Customer%20eq%20%27" + ro_code + "%27&$format=json")
                        .success(function (data, status) {
                            $scope.custBalance = data.d.results;
                            for (var i = 0; i < $scope.custBalance.length; i++) {
                                if ($scope.custBalance[i].Balance > 0) {
                                    $scope.custBalance[i].Balance = "(D) ₹ " + (Math.abs($scope.custBalance[i].Balance)).toString();
                                } else if ($scope.custBalance[i].Balance < 0) {
                                    $scope.custBalance[i].Balance = "(C) ₹ " + (Math.abs($scope.custBalance[i].Balance)).toString();
                                } else {
                                    $scope.custBalance[i].Balance = "(D) ₹ " + $scope.custBalance[i].Balance;
                                }
                            }
                            $scope.balanceView = true;
                            $ionicLoading.hide();
                        }).error(userService.serviceCallError);
                } catch (e) {
                    alert("Server Error");
                    $ionicLoading.hide();
                }
            } else {
                $scope.custBalance = [];
                $scope.balanceView = false;
            }
        }


        $scope.goHome = function () {
            $state.go("RSHome");
        }
    }

    var RSPaymentsController = function ($scope, userService, $ionicPopup, $http, $timeout, $ionicLoading, $state) {

        $ionicLoading.show({
            template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
        });
        $scope.$on('$ionicView.enter', function () {
            $scope.custPayment = [];
            $scope.employee = userService.getUser();

            $scope.searchRO = {
                input_text: "",
                name: ""
            };
            $scope.ROList = [];
            $scope.error = false;
            $scope.paymentView = false;
            try {
                if (userService.getSalesGroupRO().length > 0) {
                    $scope.ROList = userService.getSalesGroupRO();
                    $ionicLoading.hide();
                } else {
                    userService.setSalesGroupRO($scope.employee.salesGroup, function () {
                        $scope.ROList = userService.getSalesGroupRO();
                    });
                    $ionicLoading.hide();
                }
            } catch (e) {
                alert("Server Error");
                $scope.error = true;
            }



        });

        $scope.selectRO = function (ro) {
            if (ro) {
                $scope.searchRO.name = ro.ro_name;
                try {
                    $ionicLoading.show({
                        template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Loading!'
                    });
                    var ro_code = "0000" + ro.ro_code;
                    $http.get("https://m.indianoil.in:8443/sap/opu/odata/sap/Z_XS_CUST_PAYMENTS_SRV/ZMACUSTPAYSet?$skip=0&$top=100&$inlinecount=allpages&$filter=Kunnr%20eq%20%27" + ro_code + "%27&$format=json")
                        .success(function (data, status) {
                            if (data) {
                                $scope.custPayment = data.d.results;
                                for (i = 0; i < $scope.custPayment.length; i++) {
                                    var tt = $scope.custPayment[i].Cpudt.substring(6, $scope.custPayment[i].Cpudt.length - 2);
                                    var dd = new Date(parseInt(tt));
                                    $scope.custPayment[i].Cpudt = dd.toString().substring(0, 15);
                                }
                            }
                            $scope.paymentView = true;
                            $ionicLoading.hide();
                        }).error(userService.serviceCallError);
                } catch (e) {
                    alert("Server Error");
                    $ionicLoading.hide();
                }

            } else {
                $scope.custPayment = [];
                $scope.paymentView = false;
            }
        }


        $scope.goHome = function () {
            $state.go("RSHome");
        }
    }

    var RSRSPController = function ($scope, userService, $ionicPopup, $http, $timeout, $ionicLoading, $state) {

        $ionicLoading.show({
            template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
        });
        $scope.$on('$ionicView.enter', function () {
            $scope.custRsp = [];
            $scope.employee = userService.getUser();

            $scope.searchRO = {
                input_text: "",
                name: ""
            };
            $scope.ROList = [];
            $scope.error = false;
            $scope.rspView = false;
            try {
                if (userService.getSalesGroupRO().length > 0) {
                    $scope.ROList = userService.getSalesGroupRO();
                    $ionicLoading.hide();
                } else {
                    userService.setSalesGroupRO($scope.employee.salesGroup, function () {
                        $scope.ROList = userService.getSalesGroupRO();
                    });
                    $ionicLoading.hide();
                }
            } catch (e) {
                alert("Server Error");
                $scope.error = true;
            }



        });

        $scope.selectRO = function (ro) {
            if (ro) {
                $scope.searchRO.name = ro.ro_name;
                try {
                    $ionicLoading.show({
                        template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Loading!'
                    });
                    var ro_code = "0000" + ro.ro_code;
                    var url = "https://m.indianoil.in:8443/sap/opu/odata/sap/Z_XS_CUST_SP_new_SRV/ZMACUSTRSPSet?$filter=Soldto%20eq%20%27" + ro_code + "%27%20&$format=json";
                    $http.get(url)
                        .success(function (data, status) {
                            $scope.custRsp = data.d.results;
                            for (var i = 0; i < $scope.custRsp.length; i++) {
                                if ($scope.custRsp[i] && $scope.custRsp[i].Rsp) {
                                    $scope.custRsp[i].Rsp = parseFloat($scope.custRsp[i].Rsp).toFixed(2);
                                } else {
                                    $scope.custRsp[i].Rsp = "Not Available";
                                }

                                if ($scope.custRsp[i] && $scope.custRsp[i].Invamt) {
                                    $scope.custRsp[i].Invamt = parseFloat($scope.custRsp[i].Invamt).toFixed(2);
                                } else {
                                    $scope.custRsp[i].Invamt = "Not Available";
                                }

                            }
                            $scope.rspView = true;
                            $ionicLoading.hide();
                        }).error(userService.serviceCallError);
                } catch (e) {
                    alert("Server Error");
                    $ionicLoading.hide();
                }

            } else {
                $scope.custRsp = [];
                $scope.rspView = false;
            }
        }


        $scope.goHome = function () {
            $state.go("RSHome");
        }
    }


    var RSOrderController = function ($scope, userService, $ionicPopup, $http, $ionicLoading, $state) {

        $ionicLoading.show({
            template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
        });
        $scope.$on('$ionicView.enter', function () {
            $scope.employee = userService.getUser();
            $scope.allOrders = [];
            $scope.custList = [];

            $scope.ordersDispatched = [];
            $scope.ordersLoading = [];
            $scope.ordersPending = [];
            $scope.error = false;
            $scope.inputView = true;
            $scope.orderView = false;
            $scope.tabNumber = "";
            $scope.currentOrder = {};


            $scope.order = {
                fromDate: "",
                toDate: "",
                finalFDate: "",
                finalTDate: "",
                sg: ""
            };
            $ionicLoading.hide();

        });


        function onError(data) {
            $scope.error = true;
            $ionicLoading.hide();
        }

        $scope.goBack = function () {
            $scope.inputView = true;
            $scope.allOrders = [];
            $scope.custList = [];
            $scope.tabNumber = "";

            $scope.ordersDispatched = [];
            $scope.ordersLoading = [];
            $scope.ordersPending = [];
        }

        $scope.selectDistributor = function (dist) {
            if (dist) {
                $scope.currentOrder = dist;
                $scope.orderView = true;
            } else {
                $scope.currentOrder = {};
                $scope.orderView = false;
            }
        }


        $scope.showOrderInfo = function (index) {
            for (var ii = 0; ii < $scope.currentOrder.length; ii++) {
                $scope.currentOrder[ii].show = false;
            }
            $scope.currentOrder[index].show = true;

        }

        $scope.getOrder = function () {
            if (validateValues()) {
                $ionicLoading.show({
                    template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Loading!'
                });

                try {
                    var fromDate = new Date($scope.order.fromDate);
                    //var toDate = new Date($scope.order.toDate);
                    var mm = (fromDate.getMonth() + 1).toString();
                    if (mm.length == 1) {
                        mm = "0" + mm;
                    }

                    var dd = fromDate.getDate().toString();
                    if (dd.length == 1) {
                        dd = "0" + dd;
                    }
                    $scope.order.finalFDate = fromDate.getFullYear().toString() + "-" + mm + "-" + dd;
                    $scope.order.finalTDate = $scope.order.finalFDate;
                    $scope.order.sg = $scope.employee.salesGroup;

                    var url = "https://m.indianoil.in:8443/sap/opu/odata/sap/Z_MP_SERVICES_SRV/ZMPORDERFLOWSet?$filter=Vkgrp%20eq%20%27" + $scope.employee.salesGroup + "%27%20and%20DateFrom%20eq%20datetime%27" + $scope.order.finalFDate + "T00:00:00%27%20and%20DateTo%20eq%20datetime%27" + $scope.order.finalTDate + "T00:00:00%27&$format=json"

                    $http.get(url)
                        .success(function (data, status) {
                            try {
                                $scope.allOrders = data.d.results;

                                for (var ii = 0; ii < $scope.allOrders.length; ii++) {
                                    $scope.allOrders[ii].show = false;
                                    if ($scope.allOrders[ii].Ordrdt) {
                                        var tt = $scope.allOrders[ii].Ordrdt.substring(6, $scope.allOrders[ii].Ordrdt.length - 2);
                                        var dd = new Date(parseInt(tt));
                                        $scope.allOrders[ii].Ordrdt = dd.toString().substring(0, 15);
                                    }
                                    if ($scope.allOrders[ii].DelDate) {
                                        var tt = $scope.allOrders[ii].DelDate.substring(6, $scope.allOrders[ii].DelDate.length - 2);
                                        var dd = new Date(parseInt(tt));
                                        $scope.allOrders[ii].DelDate = dd.toString().substring(0, 15);
                                    }
                                    if ($scope.allOrders[ii].ShpmntDt) {
                                        var tt = $scope.allOrders[ii].ShpmntDt.substring(6, $scope.allOrders[ii].ShpmntDt.length - 2);
                                        var dd = new Date(parseInt(tt));
                                        $scope.allOrders[ii].ShpmntDt = dd.toString().substring(0, 15);
                                    }
                                    if ($scope.allOrders[ii].LoadDate) {
                                        var tt = $scope.allOrders[ii].LoadDate.substring(6, $scope.allOrders[ii].LoadDate.length - 2);
                                        var dd = new Date(parseInt(tt));
                                        $scope.allOrders[ii].LoadDate = dd.toString().substring(0, 15);
                                    }
                                    if ($scope.allOrders[ii].Reqdeldt) {
                                        var tt = $scope.allOrders[ii].Reqdeldt.substring(6, $scope.allOrders[ii].Reqdeldt.length - 2);
                                        var dd = new Date(parseInt(tt));
                                        $scope.allOrders[ii].Reqdeldt = dd.toString().substring(0, 15);
                                    }

                                    $scope.allOrders[ii].ShpmntTime = $scope.allOrders[ii].ShpmntTime.substring(2, 4) + ":" + $scope.allOrders[ii].ShpmntTime.substring(5, 7) + ":" + $scope.allOrders[ii].ShpmntTime.substring(8, 10);
                                    $scope.allOrders[ii].DelTime = $scope.allOrders[ii].DelTime.substring(2, 4) + ":" + $scope.allOrders[ii].DelTime.substring(5, 7) + ":" + $scope.allOrders[ii].DelTime.substring(8, 10);
                                    $scope.allOrders[ii].LoadTime = $scope.allOrders[ii].LoadTime.substring(2, 4) + ":" + $scope.allOrders[ii].LoadTime.substring(5, 7) + ":" + $scope.allOrders[ii].LoadTime.substring(8, 10);
                                    $scope.allOrders[ii].Erzet = $scope.allOrders[ii].Erzet.substring(2, 4) + ":" + $scope.allOrders[ii].Erzet.substring(5, 7) + ":" + $scope.allOrders[ii].Erzet.substring(8, 10);

                                    if (($scope.allOrders[ii].Comment).toLowerCase() == 'load dispatched') {
                                        $scope.ordersDispatched.push($scope.allOrders[ii]);
                                    } else if (($scope.allOrders[ii].Comment).toLowerCase() == 'delivery created' || ($scope.allOrders[ii].Comment).toLowerCase() == 'shipment created') {
                                        $scope.ordersLoading.push($scope.allOrders[ii]);
                                    } else {
                                        if (!(($scope.allOrders[ii].Comment).toLowerCase().indexOf('rejected') > -1)) {
                                            $scope.ordersPending.push($scope.allOrders[ii]);
                                        }
                                    }
                                }
                                if ($scope.allOrders.length > 0) {

                                    var prodOrderStatus = _.groupBy($scope.allOrders, "Matcode");

                                    $scope.prodOrderSummary = [];
                                    for (var pos in prodOrderStatus) {
                                        var tempArr = prodOrderStatus[pos];
                                        var tempObj = {
                                            product: "",
                                            productName: "",
                                            quantityDispatched: 0,
                                            quantityLoading: 0,
                                            quantityPending: 0
                                        }
                                        tempObj.product = prodOrderStatus[pos][0].Matcode;
                                        tempObj.productName = prodOrderStatus[pos][0].Matdesc;

                                        for (var jj = 0; jj < tempArr.length; jj++) {
                                            if (tempArr[jj].Comment == "Load Dispatched") {
                                                tempObj.quantityDispatched += parseFloat(tempArr[jj].Qunatity);
                                            } else if (tempArr[jj].Comment == "Delivery Created" || tempArr[jj].Comment == "Shipment Created") {
                                                tempObj.quantityLoading += parseFloat(tempArr[jj].Qunatity);
                                            } else {
                                                if (!((tempArr[jj].Comment).toLowerCase().indexOf('rejected') > -1)) {
                                                    tempObj.quantityPending += parseFloat(tempArr[jj].Qunatity);
                                                }
                                            }
                                        }
                                        tempObj.quantityDispatched = (tempObj.quantityDispatched);
                                        tempObj.quantityLoading = (tempObj.quantityLoading);
                                        tempObj.quantityPending = (tempObj.quantityPending);
                                        $scope.prodOrderSummary.push(tempObj);
                                    }


                                    //$scope.custList = _.groupBy($scope.allOrders, "Kunnr");
                                    $scope.inputView = false;
                                    $scope.tabNumber = "S";
                                    $ionicLoading.hide();
                                } else {
                                    alert("No orders to show");
                                    $ionicLoading.hide();
                                }
                            } catch (e1) {
                                console.log(e1);
                                alert(e1);
                                $scope.error = true;
                                $ionicLoading.hide();
                            }

                        }).error(userService.serviceCallError);


                } catch (ee) {
                    alert(ee);
                    $scope.error = true;
                    $ionicLoading.hide();
                }



            }
        }

        $scope.showOrder = function (val) {
            if (val == "P") {
                $scope.orders = $scope.ordersPending;
            } else if (val == "L") {
                $scope.orders = $scope.ordersLoading;
            } else if (val == "D") {
                $scope.orders = $scope.ordersDispatched;
            } else if (val == "S") {
                $scope.orders = [];
            }
            $scope.tabNumber = val;

        }

        $scope.goHome = function () {
            $state.go("RSHome");
        }


        $scope.showOrderSummary = function (txt) {
            for (var ii = 0; ii < $scope.allOrders.length; ii++) {
                var tt = $scope.allOrders[ii].Ordrno.toString() + $scope.allOrders[ii].Matcode.toString();
                if (tt == txt) {
                    $scope.allOrders[ii].show = !$scope.allOrders[ii].show;
                } else {
                    $scope.allOrders[ii].show = false;
                }
            }
        }


        function validateValues() {
            try {
                if ($scope.order.fromDate == null || $scope.order.fromDate == "") {
                    alert("Dates cannot be empty");
                    return false;
                } else {
                    var fromDate = new Date($scope.order.fromDate);
                    //var toDate = new Date($scope.order.toDate);

                    var todayDate = new Date();

                    fromDate = new Date(fromDate.getFullYear(), fromDate.getMonth(), fromDate.getDate()); //Year, Month, Date
                    //toDate = new Date(toDate.getFullYear(), toDate.getMonth(), toDate.getDate()); //Year, Month, Date
                    todayDate = new Date(todayDate.getFullYear(), todayDate.getMonth(), todayDate.getDate());

                    //            if (fromDate > todayDate) {
                    //                  alert("From date cannot more than Today date");
                    //                    return false;
                    //                  } else {
                    var a = (todayDate - fromDate) / (1000 * 3600 * 24);
                    if (a > 30) {
                        alert("From Date cannot be less the 30 days.");
                        return false;
                    }
                    //                    }
                    return true;
                }
            } catch (e) {
                console.log(e);
                alert("Internal Error");
                return false;
            }
        }


    }

    var RSRatingController = function ($scope, userService, $ionicPopup, $http, $timeout, $ionicLoading, $state) {

        $ionicLoading.show({
            template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
        });
        $scope.$on('$ionicView.enter', function () {
            $scope.tabNumber = "S";
            $scope.custRsp = [];
            $scope.employee = userService.getUser();
            $scope.HierList = [];
            $scope.ROList = [];

            $scope.search = {
                showRating: false,
                selectedSO: "",
                selectedDO: "",
                selectedSA: "",
                selectedRO: ""
            };




            try {

                var serviceDetails = {};
                var empRole = $scope.employee.empRole;
                if (empRole == "FO-RS") {
                    serviceDetails.url = "https://xsparsh.indianoil.in:8443/soa-infra/resources/default/MPower/RSSgRating";
                    serviceDetails.paramKey = "sales_group";
                    serviceDetails.empHier = "SG";
                    serviceDetails.paramName = $scope.employee.salesArea;
                    serviceDetails.paramValue = $scope.employee.salesGroup;
                    serviceDetails.arrayName = "SGRatingOutput";
                } else if (empRole == "DO-RS") {
                    $scope.search.selectedDO = $scope.employee.locCode;
                    serviceDetails.url = "https://xsparsh.indianoil.in:8443/soa-infra/resources/default/MPower/RSDoRating";
                    serviceDetails.paramKey = "do_code";
                    serviceDetails.empHier = "DO";
                    serviceDetails.paramName = $scope.employee.locName;
                    serviceDetails.paramValue = $scope.employee.locCode;
                    serviceDetails.arrayName = "DORatingOutput";
                } else if (empRole == "SO-RS") {
                    $scope.search.selectedSO = $scope.employee.locCode;
                    serviceDetails.url = "https://xsparsh.indianoil.in:8443/soa-infra/resources/default/MPower/RSSoRating";
                    serviceDetails.paramKey = "so_code";
                    serviceDetails.empHier = "SO";
                    serviceDetails.paramName = $scope.employee.locName;
                    serviceDetails.paramValue = $scope.employee.locCode;
                    serviceDetails.arrayName = "SORatingOutput";
                } else if (empRole == "HO-RS" || empRole == "IS") {
                    serviceDetails.url = "https://xsparsh.indianoil.in:8443/soa-infra/resources/default/MPower/RSHoRating";
                    serviceDetails.paramKey = "";
                    serviceDetails.empHier = "HO";
                    serviceDetails.paramName = "All India";
                    serviceDetails.paramValue = "";
                    serviceDetails.arrayName = "HORatingOutput";
                }


                userService.setServiceDetails(serviceDetails);
                $http.get(serviceDetails.url + "?" + serviceDetails.paramKey + "=" + serviceDetails.paramValue)
                    .success(function (data, status) {
                        if (data) {
                            $scope.sD = userService.getServiceDetails();
                            $scope.ratings = data[serviceDetails.arrayName][0];
                            if (JSON.stringify($scope.ratings.AVGRATING).indexOf("@nil") > -1) {
                                $scope.ratings.AVGRATING = "0";
                            }
                            if (JSON.stringify($scope.ratings.PRODUCT_QUALITY).indexOf("@nil") > -1) {
                                $scope.ratings.PRODUCT_QUALITY = "0";
                            }
                            if (JSON.stringify($scope.ratings.QUANTITY_DELIVERED).indexOf("@nil") > -1) {
                                $scope.ratings.QUANTITY_DELIVERED = "0";
                            }
                            if (JSON.stringify($scope.ratings.SERVICE).indexOf("@nil") > -1) {
                                $scope.ratings.SERVICE = "0";
                            }
                            if (JSON.stringify($scope.ratings.CLEANINESS).indexOf("@nil") > -1) {
                                $scope.ratings.CLEANINESS = "0";
                            }
                            if (JSON.stringify($scope.ratings.FACILITIES).indexOf("@nil") > -1) {
                                $scope.ratings.FACILITIES = "0";
                            }
                            if (JSON.stringify($scope.ratings.CLEANTOILET).indexOf("@nil") > -1) {
                                $scope.ratings.CLEANTOILET = "0";
                            }
                        }
                        $ionicLoading.hide();
                    }).error(userService.serviceCallError);

                loadRO_Hier();
            } catch (e) {
                console.log(e);
                alert("Runtime Exception");
                $ionicLoading.hide();
            }





        });

        function loadRO_Hier() {
            try {
                if ($scope.employee.salesGroup == "") {
                    if (userService.getSalesGroupList().length > 0) {
                        $scope.HierList = userService.getSalesGroupList();
                        $scope.search.selectedRO = "";
                    } else {
                        userService.setSalesGroupList(function () {
                            $scope.HierList = userService.getSalesGroupList();
                        });
                    }

                } else {
                    if (userService.getSalesGroupRO().length > 0) {
                        $scope.ROList = userService.getSalesGroupRO();
                        $scope.search.selectedRO = "";
                    } else {
                        userService.setSalesGroupRO($scope.employee.salesGroup, function () {
                            $scope.ROList = userService.getSalesGroupRO();
                            $scope.search.selectedRO = "";
                        });
                    }
                }


            } catch (e) {
                alert("Server Error");
                $scope.error = true;
            }

        }

        $scope.showTab = function (tt) {
            $scope.tabNumber = tt;
        }

        $scope.loadRating = function () {
            var empRole = $scope.employee.empRole;

            if ($scope.search.selectedRO == "" && $scope.search.selectedSA == ""
                && $scope.search.selectedDO == "" && $scope.search.selectedSO == "") {
                alert("No values selected");
            } else {
                $ionicLoading.show({
                    template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
                });
                try {
                    var serviceDetails = {};
                    if ($scope.search.selectedRO != "") {
                        serviceDetails.url = "https://xsparsh.indianoil.in:8443/soa-infra/resources/default/RDBXS/RSRatSum";
                        serviceDetails.paramKey = "roCode";
                        serviceDetails.paramValue = $scope.search.selectedRO;
                        serviceDetails.arrayName = "dbRatingSummaryOutput";
                    } else if ($scope.search.selectedSA != "") {
                        serviceDetails.url = "https://xsparsh.indianoil.in:8443/soa-infra/resources/default/MPower/RSSgRating";
                        serviceDetails.paramKey = "sales_group";
                        serviceDetails.paramValue = $scope.search.selectedSA;
                        serviceDetails.arrayName = "SGRatingOutput";
                    } else if ($scope.search.selectedDO != "") {
                        serviceDetails.url = "https://xsparsh.indianoil.in:8443/soa-infra/resources/default/MPower/RSDoRating";
                        serviceDetails.paramKey = "do_code";
                        serviceDetails.paramValue = $scope.search.selectedDO;
                        serviceDetails.arrayName = "DORatingOutput";
                    } else if ($scope.search.selectedSO != "") {
                        serviceDetails.url = "https://xsparsh.indianoil.in:8443/soa-infra/resources/default/MPower/RSSoRating";
                        serviceDetails.paramKey = "so_code";
                        serviceDetails.paramValue = $scope.search.selectedSO;
                        serviceDetails.arrayName = "SORatingOutput";
                    }

                    $http.get(serviceDetails.url + "?" + serviceDetails.paramKey + "=" + serviceDetails.paramValue)
                        .success(function (data, status) {
                            if (data) {
                                $scope.selratings = data[serviceDetails.arrayName][0];
                                if (JSON.stringify($scope.selratings.AVGRATING).indexOf("@nil") > -1) {
                                    $scope.selratings.AVGRATING = "0";
                                }
                                if (JSON.stringify($scope.selratings.PRODUCT_QUALITY).indexOf("@nil") > -1) {
                                    $scope.selratings.PRODUCT_QUALITY = "0";
                                }
                                if (JSON.stringify($scope.selratings.QUANTITY_DELIVERED).indexOf("@nil") > -1) {
                                    $scope.selratings.QUANTITY_DELIVERED = "0";
                                }
                                if (JSON.stringify($scope.selratings.SERVICE).indexOf("@nil") > -1) {
                                    $scope.selratings.SERVICE = "0";
                                }
                                if (JSON.stringify($scope.selratings.CLEANINESS).indexOf("@nil") > -1) {
                                    $scope.selratings.CLEANINESS = "0";
                                }
                                if (JSON.stringify($scope.selratings.FACILITIES).indexOf("@nil") > -1) {
                                    $scope.selratings.FACILITIES = "0";
                                }
                                if (JSON.stringify($scope.selratings.CLEANTOILET).indexOf("@nil") > -1) {
                                    $scope.selratings.CLEANTOILET = "0";
                                }
                                $scope.search.showRating = true;
                            }
                            $ionicLoading.hide();
                        }).error(userService.serviceCallError);
                } catch (e) {
                    console.log(e);
                    alert("Runtime Exception");
                    $ionicLoading.hide();
                }

            }

        }

        $scope.getNumber = function (num) {
            num = Math.floor(num);
            var x = new Array();
            for (var i = 0; i < num; i++) {
                x.push(i + 1);
            }
            return x;
        }

        $scope.goHome = function () {
            $state.go("RSHome");
        }


    }

    var RSDailySalesController = function ($scope, userService, $ionicPopup, $http, $timeout, $ionicLoading, $state, $ionicModal) {

        $ionicLoading.show({
            template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
        });
        $scope.$on('$ionicView.enter', function () {
            $scope.tabNumber = "S";
            $scope.poptabNumber = "1";
            $scope.custRsp = [];
            $scope.employee = userService.getUser();
            $scope.HierList = [];
            $scope.ROList = [];

            $scope.search = {
                showDailySales: false,
                selectedSO: "",
                selectedDO: "",
                selectedSA: "",
                selectedRO: ""
            };

            $scope.dsr = {
                LY_MS: 0,
                MS_TARGET: 0,
                PRORATA_LY_MS: 0,
                PRORATA_TARGET_MS: 0,
                CURRENT_MS: 0,
                CURRENT_MS_PERC: 0,
                TARGET_MS_PERC: 0,
                BALANCE_MS: 0,
                LY_HSD: 0,
                HSD_TARGET: 0,
                PRORATA_LY_HSD: 0,
                PRORATA_TARGET_HSD: 0,
                CURRENT_HSD: 0,
                CURRENT_HSD_PERC: 0,
                TARGET_HSD_PERC: 0,
                BALANCE_HSD: 0
            };

            $scope.seldsr = {
                LY_MS: 0,
                MS_TARGET: 0,
                PRORATA_LY_MS: 0,
                PRORATA_TARGET_MS: 0,
                CURRENT_MS: 0,
                CURRENT_MS_PERC: 0,
                TARGET_MS_PERC: 0,
                BALANCE_MS: 0,
                LY_HSD: 0,
                HSD_TARGET: 0,
                PRORATA_LY_HSD: 0,
                PRORATA_TARGET_HSD: 0,
                CURRENT_HSD: 0,
                CURRENT_HSD_PERC: 0,
                TARGET_HSD_PERC: 0,
                BALANCE_HSD: 0
            };




            try {
                var serviceDetails = {};
                var empRole = $scope.employee.empRole;
                if (empRole == "FO-RS") {
                    serviceDetails.paramKey = "FO";
                    serviceDetails.paramName = $scope.employee.salesArea;
                    serviceDetails.paramValue = $scope.employee.salesGroup;
                } else if (empRole == "DO-RS") {
                    serviceDetails.paramKey = "DO";
                    serviceDetails.paramName = $scope.employee.locName;
                    serviceDetails.paramValue = $scope.employee.locCode;
                } else if (empRole == "SO-RS") {
                    serviceDetails.paramKey = "SO";
                    serviceDetails.paramName = $scope.employee.locName;
                    serviceDetails.paramValue = $scope.employee.locCode;
                } else if (empRole == "HO-RS" || empRole == "IS") {
                    serviceDetails.paramKey = "HO";
                    serviceDetails.paramName = "All India";
                    serviceDetails.paramValue = "";
                }
                serviceDetails.url = "https://xsparsh.indianoil.in:8443/soa-infra/resources/default/MPower/DailySales?node_name=" + serviceDetails.paramKey + "&node_value=" + serviceDetails.paramValue + "&summary_list=S";

                userService.setServiceDetails(serviceDetails);
                $http.get(serviceDetails.url)
                    .success(function (data, status) {
                        if (data) {
                            var tempData = data.DSR_DATA.DSR_DATA_Row[0];
                            $scope.dsr.LY_MS = tempData.LY_MS;
                            $scope.dsr.MS_TARGET = tempData.MS_Target;
                            $scope.dsr.PRORATA_LY_MS = tempData.Prorata_LY_MS;
                            $scope.dsr.PRORATA_TARGET_MS = tempData.Prorota_Target;
                            $scope.dsr.CURRENT_MS = tempData.Current_MS;
                            $scope.dsr.CURRENT_MS_PERC = tempData.Current_MS_PERC;
                            $scope.dsr.BALANCE_MS = tempData.Balance_MS;
                            $scope.dsr.LY_HSD = tempData.LY_HSD;
                            $scope.dsr.HSD_TARGET = tempData.HSD_Target;
                            $scope.dsr.PRORATA_LY_HSD = tempData.Prorata_LY_HSD;
                            $scope.dsr.PRORATA_TARGET_HSD = tempData.Prorota_Target_HSD;
                            $scope.dsr.CURRENT_HSD = tempData.Current_HSD;
                            $scope.dsr.CURRENT_HSD_PERC = tempData.Current_HSD_PERC;
                            $scope.dsr.BALANCE_HSD = tempData.Balance_HSD;

                            $scope.dsr.CURRENT_MS = $scope.dsr.CURRENT_MS.toFixed(0);
                            $scope.dsr.CURRENT_HSD = $scope.dsr.CURRENT_HSD.toFixed(0);
                        }
                        $ionicLoading.hide();
                    }).error(userService.serviceCallError);

                loadRO_Hier();
            } catch (e) {
                console.log(e);
                alert("Runtime Exception");
                $ionicLoading.hide();
            }





        });

        $ionicModal.fromTemplateUrl('dsrSummary.html', function (modal) {
            $scope.dsrModal = modal;
        },
            {
                scope: $scope,
                // The animation we want to use for the modal entrance
                animation: 'slide-in-up'
            });


        $scope.showDSRPop = function () {
            if ($scope.tabNumber == "S") {
                $scope.current_dsr = $scope.dsr;
            } else {
                $scope.current_dsr = $scope.seldsr;
            }

            $scope.dsrModal.show();
        }

        $scope.hideDSR = function () {
            $scope.dsrModal.hide();
        }

        function loadRO_Hier() {
            try {
                if ($scope.employee.salesGroup == "") {
                    if (userService.getSalesGroupList().length > 0) {
                        $scope.HierList = userService.getSalesGroupList();
                        $scope.search.selectedRO = "";
                    } else {
                        userService.setSalesGroupList(function () {
                            $scope.HierList = userService.getSalesGroupList();
                        });
                    }

                } else {
                    if (userService.getSalesGroupRO().length > 0) {
                        $scope.ROList = userService.getSalesGroupRO();
                        $scope.search.selectedRO = "";
                    } else {
                        userService.setSalesGroupRO($scope.employee.salesGroup, function () {
                            $scope.ROList = userService.getSalesGroupRO();
                            $scope.search.selectedRO = "";
                        });
                    }
                }


            } catch (e) {
                alert("Server Error");
                $scope.error = true;
            }

        }

        $scope.showTab = function (tt) {
            $scope.tabNumber = tt;
        }

        $scope.loadDSR = function () {
            var empRole = $scope.employee.empRole;

            if ($scope.search.selectedRO == "" && $scope.search.selectedSA == ""
                && $scope.search.selectedDO == "" && $scope.search.selectedSO == "") {
                alert("No values selected");
            } else {
                $ionicLoading.show({
                    template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
                });
                try {

                    var serviceDetails = {};
                    if ($scope.search.selectedRO != "") {
                        serviceDetails.paramKey = "RO";
                        serviceDetails.paramValue = $scope.search.selectedRO;
                    } else if ($scope.search.selectedSA != "") {
                        serviceDetails.paramKey = "FO";
                        serviceDetails.paramValue = $scope.search.selectedSA;
                    } else if ($scope.search.selectedDO != "") {
                        serviceDetails.paramKey = "DO";
                        serviceDetails.paramValue = $scope.search.selectedDO;
                    } else if ($scope.search.selectedSO != "") {
                        serviceDetails.paramKey = "SO";
                        serviceDetails.paramValue = $scope.search.selectedSO;
                    }
                    serviceDetails.url = "https://xsparsh.indianoil.in:8443/soa-infra/resources/default/MPower/DailySales?node_name=" + serviceDetails.paramKey + "&node_value=" + serviceDetails.paramValue + "&summary_list=S";
                    $http.get(serviceDetails.url)
                        .success(function (data, status) {
                            if (data) {
                                var tempData = data.DSR_DATA.DSR_DATA_Row[0];
                                $scope.seldsr.LY_MS = tempData.LY_MS;
                                $scope.seldsr.MS_TARGET = tempData.MS_Target;
                                $scope.seldsr.PRORATA_LY_MS = tempData.Prorata_LY_MS;
                                $scope.seldsr.PRORATA_TARGET_MS = tempData.Prorota_Target;
                                $scope.seldsr.CURRENT_MS = tempData.Current_MS;
                                $scope.seldsr.CURRENT_MS_PERC = tempData.Current_MS_PERC;
                                $scope.seldsr.BALANCE_MS = tempData.Balance_MS;
                                $scope.seldsr.LY_HSD = tempData.LY_HSD;
                                $scope.seldsr.HSD_TARGET = tempData.HSD_Target;
                                $scope.seldsr.PRORATA_LY_HSD = tempData.Prorata_LY_HSD;
                                $scope.seldsr.PRORATA_TARGET_HSD = tempData.Prorota_Target_HSD;
                                $scope.seldsr.CURRENT_HSD = tempData.Current_HSD;
                                $scope.seldsr.CURRENT_HSD_PERC = tempData.Current_HSD_PERC;
                                $scope.seldsr.BALANCE_HSD = tempData.Balance_HSD;

                                $scope.seldsr.CURRENT_MS = $scope.seldsr.CURRENT_MS.toFixed(0);
                                $scope.seldsr.CURRENT_HSD = $scope.seldsr.CURRENT_HSD.toFixed(0);

                                $scope.search.showDailySales = true;
                            }
                            $ionicLoading.hide();
                        }).error(userService.serviceCallError);
                } catch (e) {
                    console.log(e);
                    alert("Runtime Exception");
                    $ionicLoading.hide();
                }

            }

        }

        $scope.getNumber = function (num) {
            num = Math.floor(num);
            var x = new Array();
            for (var i = 0; i < num; i++) {
                x.push(i + 1);
            }
            return x;
        }

        $scope.goHome = function () {
            $state.go("RSHome");
        }


    }

    var RSHistSalesController = function ($scope, userService, $ionicPopup, $http, $timeout, $ionicLoading, $state, $ionicModal) {

        $ionicLoading.show({
            template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
        });
        $scope.$on('$ionicView.enter', function () {
            $scope.tabNumber = "S";
            $scope.poptabNumber = "1";
            $scope.custRsp = [];
            $scope.employee = userService.getUser();
            $scope.HierList = [];
            $scope.ROList = [];

            $scope.search = {
                showHistSales: false,
                selectedSO: "",
                selectedDO: "",
                selectedSA: "",
                selectedRO: "",
                selectedProduct: "MS"
            };

            $scope.hS = [];
            $scope.selhs = [];

            try {
                var serviceDetails = {};
                var empRole = $scope.employee.empRole;
                if (empRole == "FO-RS") {
                    serviceDetails.paramKey = "FO";
                    serviceDetails.paramName = $scope.employee.salesArea;
                    serviceDetails.paramValue = $scope.employee.salesGroup;
                } else if (empRole == "DO-RS") {
                    serviceDetails.paramKey = "DO";
                    serviceDetails.paramName = $scope.employee.locName;
                    serviceDetails.paramValue = $scope.employee.locCode;
                } else if (empRole == "SO-RS") {
                    serviceDetails.paramKey = "SO";
                    serviceDetails.paramName = $scope.employee.locName;
                    serviceDetails.paramValue = $scope.employee.locCode;
                } else if (empRole == "HO-RS" || empRole == "IS") {
                    serviceDetails.paramKey = "HO";
                    serviceDetails.paramName = "All India";
                    serviceDetails.paramValue = "";
                }
                serviceDetails.url = "https://xsparsh.indianoil.in:8443/soa-infra/resources/default/MPower/RSHistSales?nodename=" + serviceDetails.paramKey + "&nodevalue=" + serviceDetails.paramValue;

                userService.setServiceDetails(serviceDetails);
                $http.get(serviceDetails.url)
                    .success(function (data, status) {
                        if (data.SALES_OUTPUT && data.SALES_OUTPUT != "null") {
                            $scope.hS = data.SALES_OUTPUT.SALES_OUTPUT_Row;
                        }
                        $ionicLoading.hide();
                    }).error(userService.serviceCallError);

                loadRO_Hier();
            } catch (e) {
                console.log(e);
                alert("Runtime Exception");
                $ionicLoading.hide();
            }





        });

        function loadRO_Hier() {
            try {
                if ($scope.employee.salesGroup == "") {
                    if (userService.getSalesGroupList().length > 0) {
                        $scope.HierList = userService.getSalesGroupList();
                        $scope.search.selectedRO = "";
                    } else {
                        userService.setSalesGroupList(function () {
                            $scope.HierList = userService.getSalesGroupList();
                        });
                    }

                } else {
                    if (userService.getSalesGroupRO().length > 0) {
                        $scope.ROList = userService.getSalesGroupRO();
                        $scope.search.selectedRO = "";
                    } else {
                        userService.setSalesGroupRO($scope.employee.salesGroup, function () {
                            $scope.ROList = userService.getSalesGroupRO();
                            $scope.search.selectedRO = "";
                        });
                    }
                }


            } catch (e) {
                alert("Server Error");
                $scope.error = true;
            }

        }

        $scope.showTab = function (tt) {
            $scope.tabNumber = tt;
        }

        $scope.loadHS = function () {
            var empRole = $scope.employee.empRole;

            if ($scope.search.selectedRO == "" && $scope.search.selectedSA == ""
                && $scope.search.selectedDO == "" && $scope.search.selectedSO == "") {
                alert("No values selected");
            } else {
                $ionicLoading.show({
                    template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
                });
                try {

                    var serviceDetails = {};
                    if ($scope.search.selectedRO != "") {
                        serviceDetails.paramKey = "RO";
                        serviceDetails.paramValue = $scope.search.selectedRO;
                    } else if ($scope.search.selectedSA != "") {
                        serviceDetails.paramKey = "FO";
                        serviceDetails.paramValue = $scope.search.selectedSA;
                    } else if ($scope.search.selectedDO != "") {
                        serviceDetails.paramKey = "DO";
                        serviceDetails.paramValue = $scope.search.selectedDO;
                    } else if ($scope.search.selectedSO != "") {
                        serviceDetails.paramKey = "SO";
                        serviceDetails.paramValue = $scope.search.selectedSO;
                    }
                    serviceDetails.url = "https://xsparsh.indianoil.in:8443/soa-infra/resources/default/MPower/RSHistSales?nodename=" + serviceDetails.paramKey + "&nodevalue=" + serviceDetails.paramValue;

                    userService.setServiceDetails(serviceDetails);
                    $http.get(serviceDetails.url)
                        .success(function (data, status) {
                            if (data.SALES_OUTPUT && data.SALES_OUTPUT != "null") {
                                $scope.selhs = data.SALES_OUTPUT.SALES_OUTPUT_Row;
                            }
                            $scope.search.showHistSales = true;
                            $ionicLoading.hide();
                        }).error(userService.serviceCallError);
                } catch (e) {
                    console.log(e);
                    alert("Runtime Exception");
                    $ionicLoading.hide();
                }

            }

        }

        $scope.getNumber = function (num) {
            num = Math.floor(num);
            var x = new Array();
            for (var i = 0; i < num; i++) {
                x.push(i + 1);
            }
            return x;
        }

        $scope.goHome = function () {
            $state.go("RSHome");
        }


    }


    var RSPeriodSalesController = function ($scope, userService, $ionicPopup, $http, $ionicLoading, $state) {

        $ionicLoading.show({
            template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
        });
        $scope.$on('$ionicView.enter', function () {
            $scope.employee = userService.getUser();
            $scope.distWiseSales = [];
            $scope.prodWiseSales = [];
            $scope.cumSales = [];
            $scope.error = false;
            $scope.salesView = false;
            $scope.tabNumber = 'T';

            $scope.sales = {
                fromDate: "",
                toDate: "",
                finalFDate: "",
                finalTDate: "",
                sg: "",
                cumSalesExist: false,
                prodSalesExist: false,
                distSalesExist: false,
                selectedProduct: "",
                selectedDist: "",
                heirType: "",
                heirKey: "",
                heirValue: ""
            };
            $ionicLoading.hide();
        });

        function onError(data) {
            $scope.error = true;
            $ionicLoading.hide();
        }

        $scope.goBack = function () {
            $scope.salesView = false;
            $scope.distWiseSales = [];
            $scope.prodWiseSales = [];
            $scope.cumSales = [];
            $scope.sales = {
                fromDate: "",
                toDate: "",
                finalFDate: "",
                finalTDate: "",
                sg: "",
                cumSalesExist: false,
                prodSalesExist: false,
                distSalesExist: false,
                selectedProduct: "",
                selectedDist: ""
            };
            $scope.tabNumber = 'T';
        }

        $scope.showSales = function (type) {
            if (type == "T") {
                if (!$scope.sales.cumSalesExist) {
                    fetchSales("T", function () {
                        $scope.tabNumber = type;
                    })
                } else {
                    $scope.tabNumber = type;
                }
            } else if (type == "P") {
                if (!$scope.sales.prodSalesExist) {
                    fetchSales("P", function () {
                        $scope.tabNumber = type;
                    })
                } else {
                    $scope.tabNumber = type;
                }
            } else if (type == "D") {
                if (!$scope.sales.distSalesExist) {
                    fetchSales("D", function () {
                        $scope.tabNumber = type;
                    })
                } else {
                    $scope.tabNumber = type;
                }
            }
        }

        function fetchSales(type, cb) {
            $ionicLoading.show({
                template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
            });

            var entitySet = "";
            var compareKey = "";
            var compareValue = "";

            if ($scope.employee.empRole == "FO-RS") {
                if (type == "T") {
                    entitySet = "CustDSSalesSet";
                } else if (type == "P") {
                    entitySet = "CustMSSalesSet";
                } else if (type == "D") {
                    entitySet = "CustCSSalesSet";
                }
                compareKey = "Vkgrp";
                compareValue = $scope.sales.sg;
                $scope.sales.heirType = "Dealer";
                $scope.sales.heirKey = "Pkunwe";
                $scope.sales.heirValue = "CustName";

                var url = "https://m.indianoil.in:8443/sap/opu/odata/sap/Z_MP_LPG_SERVICES_SRV/" + entitySet + "?$filter=" + compareKey + "%20eq%20%27" + compareValue + "%27%20and%20IDateFrom%20eq%20datetime%27" + $scope.sales.finalFDate + "T00:00:00%27%20and%20IDateTo%20eq%20datetime%27" + $scope.sales.finalTDate + "T00:00:00%27&$format=json"

                $http.get(url)
                    .success(function (data, status) {
                        try {
                            if ($scope.employee.empRole == "FO-RS") {
                                if (type == "T") {
                                    $scope.cumSales = data.d.results;
                                    $scope.sales.cumSalesExist = true;
                                } else if (type == "P") {
                                    $scope.prodWiseSales = data.d.results;
                                    $scope.sales.prodSalesExist = true;
                                    $scope.prodList = _.groupBy($scope.prodWiseSales, "Matnr");
                                    $scope.sales.selectedProduct = $scope.prodList[Object.keys($scope.prodList)[0]][0].Matnr;
                                } else if (type == "D") {
                                    $scope.distWiseSales = data.d.results;
                                    $scope.sales.distSalesExist = true;
                                    $scope.distList = _.groupBy($scope.distWiseSales, $scope.sales.heirKey);
                                    $scope.sales.selectedDist = $scope.distList[Object.keys($scope.distList)[0]][0][$scope.sales.heirKey];
                                }
                            }
                            cb();
                            $scope.salesView = true;
                            $ionicLoading.hide();
                        } catch (e1) {
                            //alert(e1);
                            alert("Runtime Error occurred. Please try after sometime " + e1);
                            $scope.error = true;
                            $ionicLoading.hide();
                            cb();
                        }

                    }).error(function () {
                        $scope.error = true;
                        $ionicLoading.hide();
                        cb();
                    });



            }
        }

        $scope.getSales = function () {
            if (validateValues()) {
                $ionicLoading.show({
                    template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Loading!'
                });

                try {
                    if ($scope.sales.fromDate == null || $scope.sales.fromDate == "" ||
                        $scope.sales.toDate == null || $scope.sales.toDate == "") {
                        alert("Dates cannot be empty");
                        $ionicLoading.hide();
                    } else {
                        var fromDate = new Date($scope.sales.fromDate);
                        var toDate = new Date($scope.sales.toDate);
                        $scope.sales.finalFDate = fromDate.getFullYear() + "-" + (fromDate.getMonth() + 1) + "-" + fromDate.getDate();
                        $scope.sales.finalTDate = toDate.getFullYear() + "-" + (toDate.getMonth() + 1) + "-" + toDate.getDate();
                        $scope.sales.sg = $scope.employee.salesGroup;


                        var entitySet = "";
                        var compareKey = "";
                        var compareValue = "";
                        var compareString = "";
                        var url = "https://m.indianoil.in:8443/sap/opu/odata/sap/Z_MP_LPG_SERVICES_SRV/";

                        if ($scope.employee.empRole == "FO-RS") {
                            entitySet = "CustDSSalesSet";
                            compareKey = "Vkgrp";
                            compareValue = $scope.employee.salesGroup;
                            $scope.sales.heirType = "Dealer";
                            $scope.sales.heirKey = "Pkunwe";
                            $scope.sales.heirValue = "CustName";
                            url = url + entitySet + "?$filter=" + compareKey + "%20eq%20%27" + compareValue + "%27%20and%20IDateFrom%20eq%20datetime%27" + $scope.sales.finalFDate + "T00:00:00%27%20and%20IDateTo%20eq%20datetime%27" + $scope.sales.finalTDate + "T00:00:00%27&$format=json"
                        } else if ($scope.employee.empRole == "DO-RS") {
                            entitySet = "AOSalesSet";
                            compareKey = "Vkbur";
                            compareValue = $scope.employee.locCode;
                            $scope.sales.heirType = "Sales Group";
                            $scope.sales.heirKey = "Vkgrp";
                            $scope.sales.heirValue = "VkgrpText";
                            url = url + entitySet + "?$filter=" + compareKey + "%20eq%20%27" + compareValue + "%27%20and%20IDateFrom%20eq%20datetime%27" + $scope.sales.finalFDate + "T00:00:00%27%20and%20IDateTo%20eq%20datetime%27" + $scope.sales.finalTDate + "T00:00:00%27&$format=json"
                        } else if ($scope.employee.empRole == "SO-RS") {
                            entitySet = "SOSalesSet";
                            compareKey = "Vkorg";
                            compareValue = $scope.employee.locCode;
                            $scope.sales.heirType = "Area Office";
                            $scope.sales.heirKey = "Vkbur";
                            $scope.sales.heirValue = "VkburText";
                            url = url + entitySet + "?$filter=" + compareKey + "%20eq%20%27" + compareValue + "%27%20and%20IDateFrom%20eq%20datetime%27" + $scope.sales.finalFDate + "T00:00:00%27%20and%20IDateTo%20eq%20datetime%27" + $scope.sales.finalTDate + "T00:00:00%27&$format=json"
                        } else if ($scope.employee.empRole == "HO-RS") {
                            entitySet = "HOSalesSet";
                            compareKey = "";
                            compareValue = "";
                            $scope.sales.heirType = "State Office";
                            $scope.sales.heirKey = "Vkorg";
                            $scope.sales.heirValue = "VkorgText";
                            url = url + entitySet + "?$filter=IDateFrom%20eq%20datetime%27" + $scope.sales.finalFDate + "T00:00:00%27%20and%20IDateTo%20eq%20datetime%27" + $scope.sales.finalTDate + "T00:00:00%27&$format=json"
                        }

                        //alert(url);



                        $http.get(url)
                            .success(function (data, status) {
                                try {
                                    if ($scope.employee.empRole == "FO-RS") {
                                        $scope.cumSales = data.d.results;
                                        $scope.sales.heirType = "Dealer";
                                        $scope.sales.heirKey = "Pkunwe";
                                        $scope.sales.heirValue = "CustName";
                                    } else {
                                        $scope.cumSales = data.d.results;
                                        $scope.prodWiseSales = data.d.results;
                                        $scope.prodList = _.groupBy($scope.prodWiseSales, "Matnr");
                                        $scope.sales.selectedProduct = $scope.prodList[Object.keys($scope.prodList)[0]][0].Matnr;
                                        $scope.sales.prodSalesExist = true;

                                        $scope.distWiseSales = data.d.results;
                                        $scope.distList = _.groupBy($scope.distWiseSales, $scope.sales.heirKey);
                                        $scope.sales.selectedDist = $scope.distWiseSales[0][$scope.sales.heirValue];
                                        console.log($scope.distList);
                                        $scope.sales.distSalesExist = true;

                                    }

                                    $scope.sales.cumSalesExist = true;
                                    $scope.salesView = true;
                                    $ionicLoading.hide();
                                } catch (e1) {
                                    //alert(e1);
                                    alert("Runtime Error occurred. Please try after sometime " + e1);
                                    $scope.error = true;
                                    $ionicLoading.hide();
                                }

                            }).error(onError);
                    }


                } catch (ee) {
                    //alert(ee);
                    alert("Runtime Error occurred. Please try after sometime");
                    $scope.error = true;
                    $ionicLoading.hide();
                }



            }
        }


        $scope.getSalesSum = function (items, kk) {
            return items
                .map(function (x) { return parseFloat(x[kk]); })
                .reduce(function (a, b) { return a + b; });
        };

        $scope.goHome = function () {
            $state.go("RSHome");
        }



        function validateValues() {
            try {
                var fromDate = new Date($scope.sales.fromDate);
                var toDate = new Date($scope.sales.toDate);

                var todayDate = new Date();

                fromDate = new Date(fromDate.getFullYear(), fromDate.getMonth(), fromDate.getDate()); //Year, Month, Date
                toDate = new Date(toDate.getFullYear(), toDate.getMonth(), toDate.getDate()); //Year, Month, Date
                todayDate = new Date(todayDate.getFullYear(), todayDate.getMonth(), todayDate.getDate());

                if (fromDate > toDate) {
                    alert("From date cannot more than To date");
                    return false;
                } else if (fromDate > todayDate) {
                    alert("From date cannot more than Today date");
                    return false;
                } else if (toDate > todayDate) {
                    alert("To date cannot more than Today date");
                    return false;
                } else {
                    var a = (todayDate - fromDate) / (1000 * 3600 * 24);
                    if (a > 90) {
                        alert("From Date cannot be less the 90 days.");
                        return false;
                    }
                }
                return true;
            } catch (e) {
                alert("Internal Error");
                return false;
            }
        }

    }


    var RSMIController = function ($scope, $state, $rootScope, $ionicPlatform, $ionicLoading, $http, $timeout, $ionicModal, userService, $ionicHistory) {

        $scope.selectedProduct = "SELECT";
        $ionicLoading.show({
            template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Loading!'
        });

        try {
            var dd = new Date();
            var month = (dd.getMonth() + 1).toString();

            if (month.length === 1) {
                month = "0" + month;
            }
            var dtString = dd.getFullYear() + "" + month;

            dtString = "201704";
            var urlS = "https://xsparsh.indianoil.in:8443/soa-infra/resources/default/MPower/RSMarketIntel?midate=" + dtString;
            $http.get(urlS)
                .success(function (data, status) {
                    if (data) {
                        if (data.PRICING && data.PRICING != "null") {
                            $scope.mtknInteligencePricing = data.PRICING.PRICING_Row;
                        }
                        if (data.LOYALTY && data.LOYALTY != "null") {
                            $scope.mtknInteligenceLoyalty = data.LOYALTY.LOYALTY_Row;
                        }

                        if (data.SALES_PROMO && data.SALES_PROMO != "null") {
                            $scope.mtknInteligenceSalespromo = data.SALES_PROMO.SALES_PROMO_Row;
                        }



                    }
                    $ionicLoading.hide();
                }).error(userService.serviceCallError);
        } catch (e) {
            console.log(e);
            alert("Runtime exception");
        }

        function onError(data) {
            $scope.error = true;
            $ionicLoading.hide();
        }

        $scope.goHome = function () {
            $state.go("RSHome");
        }

    }

    var RSCustomerCentricController = function ($scope, userService, $ionicPopup, $http, $timeout, $ionicLoading, $state, $ionicModal) {


        $scope.$on('$ionicView.enter', function () {
            $scope.tabNumber = "S";
            $scope.custRsp = [];
            $scope.employee = userService.getUser();
            $scope.HierList = [];
            $scope.ROList = [];

            $scope.search = {
                showCC: false,
                selectedSO: "",
                selectedDO: "",
                selectedSA: "",
                selectedRO: ""
            };


            $scope.dates = [];

            try {

                var dateobj = new Date();
                var month = dateobj.getMonth() + 1;
                var year = dateobj.getFullYear();

                if (month < 10) {
                    $scope.data = {
                        val: year.toString() + "-0" + month.toString()
                    }
                } else {
                    $scope.data = {
                        val: year.toString() + "-" + month.toString()
                    }
                }
                for (var i = 0; i < 12; i++) {
                    if (month == 0) {
                        month = 12;
                        year = year - 1;
                    }
                    if (month < 10) {
                        $scope.dates[i] = year.toString() + "-0" + month.toString();
                    } else {
                        $scope.dates[i] = year.toString() + "-" + month.toString()
                    }

                    month = month - 1;
                }
            } catch (ee) {

            }
            loadRO_Hier();
            $scope.loadCCdata();
        });

        $scope.loadCCdata = function () {
            $ionicLoading.show({
                template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
            });
            try {
                var dy = $scope.data.val.split("-");
                var datVal = dy[0] + "" + dy[1];
                var serviceDetails = {};
                var empRole = $scope.employee.empRole;
                if (empRole == "FO-RS") {
                    serviceDetails.paramKey = "FO";
                    serviceDetails.paramName = $scope.employee.salesArea;
                    serviceDetails.paramValue = $scope.employee.salesGroup;
                } else if (empRole == "DO-RS") {
                    serviceDetails.paramKey = "DO";
                    serviceDetails.paramName = $scope.employee.locName;
                    serviceDetails.paramValue = $scope.employee.locCode;
                } else if (empRole == "SO-RS") {
                    serviceDetails.paramKey = "SO";
                    serviceDetails.paramName = $scope.employee.locName;
                    serviceDetails.paramValue = $scope.employee.locCode;
                } else if (empRole == "HO-RS" || empRole == "IS") {
                    serviceDetails.paramKey = "HO";
                    serviceDetails.paramName = "All India";
                    serviceDetails.paramValue = "";
                }
                serviceDetails.url = "https://xsparsh.indianoil.in:8443/soa-infra/resources/default/MPower/RSCustCentric?nodename=" + serviceDetails.paramKey + "&nodevalue=" + serviceDetails.paramValue + "&ccdate=" + datVal;

                userService.setServiceDetails(serviceDetails);
                $http.get(serviceDetails.url)
                    .success(function (data, status) {
                        if (data) {
                            $scope.ccData = data.OUTPUT_REF.OUTPUT_REF_Row[0];
                            for (var key in $scope.ccData) {
                                if (JSON.stringify($scope.ccData[key]).indexOf("@nil") > -1) {
                                    $scope.ccData[key] = "";
                                }
                            }
                        }
                        $ionicLoading.hide();
                    }).error(userService.serviceCallError);


            } catch (e) {
                console.log(e);
                alert("Runtime Exception");
                $ionicLoading.hide();
            }
        }


        $scope.loadCCdataList = function () {
            $ionicLoading.show({
                template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
            });
            try {
                var dy = $scope.data.val.split("-");
                var datVal = dy[0] + "" + dy[1];
                var serviceDetails = {};
                var empRole = $scope.employee.empRole;
                if (empRole == "FO-RS") {
                    serviceDetails.paramKey = "FO";
                    serviceDetails.paramName = $scope.employee.salesArea;
                    serviceDetails.paramValue = $scope.employee.salesGroup;
                } else if (empRole == "DO-RS") {
                    serviceDetails.paramKey = "DO";
                    serviceDetails.paramName = $scope.employee.locName;
                    serviceDetails.paramValue = $scope.employee.locCode;
                } else if (empRole == "SO-RS") {
                    serviceDetails.paramKey = "SO";
                    serviceDetails.paramName = $scope.employee.locName;
                    serviceDetails.paramValue = $scope.employee.locCode;
                } else if (empRole == "HO-RS" || empRole == "IS") {
                    serviceDetails.paramKey = "HO";
                    serviceDetails.paramName = "All India";
                    serviceDetails.paramValue = "";
                }
                serviceDetails.url = "https://xsparsh.indianoil.in:8443/soa-infra/resources/default/MPower/RSCustCentric?nodename=" + serviceDetails.paramKey + "&nodevalue=" + serviceDetails.paramValue + "&ccdate=" + datVal;

                userService.setServiceDetails(serviceDetails);
                $http.get(serviceDetails.url)
                    .success(function (data, status) {
                        if (data) {
                            $scope.selccdata = data.OUTPUT_REF.OUTPUT_REF_Row[0];
                            for (var key in $scope.selccdata) {
                                if (JSON.stringify($scope.selccdata[key]).indexOf("@nil") > -1) {
                                    $scope.selccdata[key] = "";
                                }
                            }
                        }
                        $ionicLoading.hide();
                    }).error(userService.serviceCallError);


            } catch (e) {
                console.log(e);
                alert("Runtime Exception");
                $ionicLoading.hide();
            }
        }



        function loadRO_Hier() {
            try {
                if ($scope.employee.salesGroup == "") {
                    if (userService.getSalesGroupList().length > 0) {
                        $scope.HierList = userService.getSalesGroupList();
                        $scope.search.selectedRO = "";
                    } else {
                        userService.setSalesGroupList(function () {
                            $scope.HierList = userService.getSalesGroupList();
                        });
                    }

                } else {
                    if (userService.getSalesGroupRO().length > 0) {
                        $scope.ROList = userService.getSalesGroupRO();
                        $scope.search.selectedRO = "";
                    } else {
                        userService.setSalesGroupRO($scope.employee.salesGroup, function () {
                            $scope.ROList = userService.getSalesGroupRO();
                            $scope.search.selectedRO = "";
                        });
                    }
                }


            } catch (e) {
                alert("Server Error");
                $scope.error = true;
            }

        }

        $scope.showTab = function (tt) {
            $scope.tabNumber = tt;
        }

        $scope.loadCCList = function () {
            var empRole = $scope.employee.empRole;

            if ($scope.search.selectedRO == "" && $scope.search.selectedSA == ""
                && $scope.search.selectedDO == "" && $scope.search.selectedSO == "") {
                alert("No values selected");
            } else {
                $ionicLoading.show({
                    template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
                });
                try {
                    var dy = $scope.data.val.split("-");
                    var datVal = dy[0] + "" + dy[1];
                    var serviceDetails = {};
                    if ($scope.search.selectedRO != "") {
                        serviceDetails.paramKey = "RO";
                        serviceDetails.paramValue = $scope.search.selectedRO;
                    } else if ($scope.search.selectedSA != "") {
                        serviceDetails.paramKey = "FO";
                        serviceDetails.paramValue = $scope.search.selectedSA;
                    } else if ($scope.search.selectedDO != "") {
                        serviceDetails.paramKey = "DO";
                        serviceDetails.paramValue = $scope.search.selectedDO;
                    } else if ($scope.search.selectedSO != "") {
                        serviceDetails.paramKey = "SO";
                        serviceDetails.paramValue = $scope.search.selectedSO;
                    }
                    serviceDetails.url = "https://xsparsh.indianoil.in:8443/soa-infra/resources/default/MPower/RSCustCentric?nodename=" + serviceDetails.paramKey + "&nodevalue=" + serviceDetails.paramValue + "&ccdate=" + datVal;

                    userService.setServiceDetails(serviceDetails);
                    $http.get(serviceDetails.url)
                        .success(function (data, status) {
                            if (data) {
                                $scope.selccData = data.OUTPUT_REF.OUTPUT_REF_Row[0];
                            }
                            $scope.search.showCC = true;
                            $ionicLoading.hide();
                        }).error(userService.serviceCallError);

                } catch (e) {
                    console.log(e);
                    alert("Runtime Exception");
                    $ionicLoading.hide();
                }

            }

        }

        $scope.getNumber = function (num) {
            num = Math.floor(num);
            var x = new Array();
            for (var i = 0; i < num; i++) {
                x.push(i + 1);
            }
            return x;
        }

        $scope.goHome = function () {
            $state.go("RSHome");
        }


    }

    var RSStockDataController = function ($scope, userService, $ionicPopup, $http, $timeout, $ionicLoading, $state) {

        $ionicLoading.show({
            template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
        });
        $scope.$on('$ionicView.enter', function () {
            $scope.stockInfo = [];
            $scope.employee = userService.getUser();

            $scope.searchLoc = {
                input_text: ""
            };

            $scope.dateString = "";

            $scope.stockDate = {
                val: ""
            };

            $scope.error = false;
            $ionicLoading.hide();
        });


        function LoadStockData() {
            try {
                var urlS = "https://xsparsh.indianoil.in:8443/soa-infra/resources/default/MPower/RSLocStock" + "?stock_date=" + $scope.dateString;
                $http.get(urlS)
                    .success(function (data, status) {
                        if (data && data.OUTPUT_REF && data.OUTPUT_REF.OUTPUT_REF_Row) {
                            $scope.lcnStcData = data.OUTPUT_REF.OUTPUT_REF_Row;
                            for (var i = 0; i < $scope.lcnStcData.length; i++) {
                                if ($scope.lcnStcData[i].STATUS.toLowerCase().indexOf("adequate") >= 0) {
                                    $scope.lcnStcData[i].color = "green";
                                } else {
                                    $scope.lcnStcData[i].color = "red";
                                }
                            }
                            var aa = "";

                        } else {
                            alert("No Data Found");
                            $scope.lcnStcData = [];
                        }
                        $ionicLoading.hide();
                    }).error(userService.serviceCallError);
            } catch (e) {
                alert("Server Error");
                $scope.error = true;
                $ionicLoading.hide();
            }
        }


        function onError(data) {
            $scope.error = true;
            $ionicLoading.hide();
        }

        $scope.getStock = function () {

            if ($scope.stockDate.val == "") {
                alert("Date cannot be null");
            } else {
                $ionicLoading.show({
                    template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
                });

                try {
                    var dd = new Date($scope.stockDate.val);
                    var month = (dd.getMonth() + 1).toString();
                    if (month.length === 1) {
                        month = "0" + month;
                    }
                    var day = dd.getDate().toString();
                    if (day.length === 1) {
                        day = "0" + day;
                    }

                    $scope.dateString = day + "-" + month + "-" + dd.getFullYear();
                    LoadStockData();
                } catch (ee) {
                    $ionicLoading.hide();
                    alert("Runtime exception");
                }

            }



        }

        $scope.goHome = function () {
            $state.go("RSHome");
        }
    }

    var RSPinResetController = function ($scope, userService, $ionicPopup, $http, $timeout, $ionicLoading, $state) {

        $ionicLoading.show({
            template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
        });
        $scope.$on('$ionicView.enter', function () {
            $scope.custBalance = [];
            $scope.employee = userService.getUser();

            $scope.searchRO = {
                input_text: ""
            };
            $scope.ROList = [];
            $scope.error = false;
            $scope.balanceView = false;
            try {
                if (userService.getSalesGroupRO().length > 0) {
                    $scope.ROList = userService.getSalesGroupRO();
                    $ionicLoading.hide();
                } else {
                    userService.setSalesGroupRO($scope.employee.salesGroup, function () {
                        $scope.ROList = userService.getSalesGroupRO();
                    });
                    $ionicLoading.hide();
                }
            } catch (e) {
                alert("Server Error");
                $scope.error = true;
            }



        });

        $scope.resetPIN = function (ro) {
            if (ro) {

                var cc = confirm("Are you sure you to reset IPIN of selected RO?");

                if (cc) {
                    try {
                        $ionicLoading.show({
                            template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Loading!'
                        });
                        var ro_code = "0000" + ro.ro_code;
                        $http.get("https://m.indianoil.in:8443/sap/opu/odata/sap/Z_XS_CUST_IPIN_SRV/ZMAORDEROTPSet(Customer='" + ro_code + "',OldOtp='',Otp='')?$format=json")
                            .success(function (data, status) {
                                alert("IPIN reset to 0000");
                                $ionicLoading.hide();
                            }).error(userService.serviceCallError);
                    } catch (e) {
                        alert("Server Exception");
                        $ionicLoading.hide();
                    }
                }


            } else {
                $scope.custBalance = [];
                $scope.balanceView = false;
            }
        }


        $scope.goHome = function () {
            $state.go("RSHome");
        }
    }





    app.controller("RSHomeController", RSHomeController);
    app.controller("RSRDBController", RSRDBController);
    app.controller("RSProfileController", RSProfileController);
    app.controller("RSBalanceController", RSBalanceController);
    app.controller("RSPaymentsController", RSPaymentsController);
    app.controller("RSRSPController", RSRSPController);
    app.controller("RSOrderController", RSOrderController);
    app.controller("RSRatingController", RSRatingController);
    app.controller("RSDailySalesController", RSDailySalesController);
    app.controller("RSHistSalesController", RSHistSalesController);
    app.controller("RSPeriodSalesController", RSPeriodSalesController);
    //app.controller("RSCashlessController", RSCashlessController);
    app.controller("RSMIController", RSMIController);
    app.controller("RSCustomerCentricController", RSCustomerCentricController);
    app.controller("RSStockDataController", RSStockDataController);
    app.controller("RSPinResetController", RSPinResetController);



}());

