// Ionic Starter App
// angular.module is a global place for creating, registering and retrieving Angular modules
// 'FuelIoc' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'FuelIoc.controllers' is found in controllers.js

var Mpower = angular.module('mPOWER', ['ionic', 'mPOWER.controllers', 'ngSanitize', 'ion-autocomplete']);


Mpower.factory('LoginUser', function () {
  var User = {
    userId: "",
    name: "",
    email: "",
    mobile: "",
    address: "",
    city: "",
    pincode: "",
    xtraReward: 0,
    gender: ""
  };
  return User;
});

/*
Xsparsh.config(function ($translateProvider) {
    $translateProvider.useStaticFilesLoader({
        'prefix': 'locals/locale-',
        'suffix': '.json'
    });
    $translateProvider.preferredLanguage('English');
});
*/

Mpower.run(function ($ionicPlatform, $ionicPopup, $rootScope, $cordovaSplashscreen, $state, userService) {

})


Mpower.config(function ($stateProvider, $urlRouterProvider) {
  $stateProvider

    .state('app', {
      url: '/app',
      abstract: true,
      templateUrl: 'templates/menu.html',
      controller: 'MainMenuController'
    })
    
    .state('mpower', {
      url: '/mpower',
      abstract: true,
      templateUrl: 'templates/lpg/menu.html',
      controller: 'LPGMenuController'
    })

    .state('xsparsh', {
      url: '/xsparsh',
      abstract: true,
      templateUrl: 'templates/xSparsh/menu.html',
      controller: 'xSparshMainController'
    })

    .state('login', { url: '/login', templateUrl: 'templates/login.html', controller: 'LoginController' })
    .state('ioclContact', { url: "/ioclContact", templateUrl: "templates/ioclContact.html", controller: 'ContactController' })
    .state('ratingHier', { url: "/ratingHier", templateUrl: "templates/ratingHier.html", controller: 'RatingHierController' })
    .state('dsrHier', { url: "/dsrHier", templateUrl: "templates/dsrHier.html", controller: 'DSRHierController' })
    .state('sgOrder', { url: "/sgOrder", templateUrl: "templates/sgOrder.html", controller: 'SGOrderController' })
    .state('resetPIN', { url: "/resetPIN", templateUrl: "templates/resetPIN.html", controller: 'ResetPINController' })
    .state('custInfo', { url: "/custInfo", templateUrl: "templates/custInfo.html", controller: 'CustInfoController' })
    .state('custDetails', { url: "/custDetails", templateUrl: "templates/custDetails.html", controller: 'CustDetController' })
    .state('SalesAnalytics', { url: "/SalesAnalytics", templateUrl: "templates/SalesAnalytics.html", controller: 'SalesAnalyticsController' })
    .state('CustomerCentric', { url: "/CustomerCentric", templateUrl: "templates/CustomerCentric.html", controller: 'CustomerCentricController' })
    .state('xSparsh_roCriticality', { url: "/roCriticality", templateUrl: "templates/xSparsh/RoCriticality.html", controller: 'RoCriticalityVersionController' })
    .state('mrktIntlgence', { url: "/mrktIntlgence", templateUrl: "templates/MrktIntlgence.html", controller: 'MrktIntlgenceVersionController' })
    .state('LocationStock', { url: "/LocationStock", templateUrl: "templates/LocationStock.html", controller: 'LocationStockController' })
    .state('cashlesssummary', { url: "/LocationStock", templateUrl: "templates/CashlessSummary.html", controller: 'CashlessSummaryController' })
    .state('FOView', { url: "/FOView", templateUrl: "templates/FOView.html", controller: 'FOViewController' })
    .state('ConsumerIndentTracker', { url: "/ConsumerIndentTracker", templateUrl: "templates/ConsumerIndentTracker.html", controller: 'ConsumerIndentTrackerController',
    params: {
        salesGroup: ""
    } })
    .state('ConsumerSalesTracker', { url: "/ConsumerSalesTracker", templateUrl: "templates/ConsumerSalesTracker.html", controller: 'ConsumerSalesTrackerController' }) 
    .state('versionMgmt', { url: "/VersionMgmt", templateUrl: "templates/VersionMgmt.html", controller: 'VersionController' })
    
    .state('xSparsh_balance', { url: "/balance", templateUrl: "templates/xSparsh/balance.html", controller: 'xSparshBalanceController' })
    .state('xSparsh_payments', { url: "/payments", templateUrl: "templates/xSparsh/payments.html", controller: 'xSparshPaymentController' })
    .state('xSparsh_current_dispatch', { url: "/current_dispatch", templateUrl: "templates/xSparsh/current_dispatch.html", controller: 'xSparshCDController' })
    .state('xSparsh_rsp', { url: "/rsp", templateUrl: "templates/xSparsh/rsp.html", controller: 'xSparshRSPController' })
    .state('xSparsh_oldrsp', { url: "/oldrsp", templateUrl: "templates/xSparsh/oldrsp.html", controller: 'xSparshRSPController' })
    .state('xSparsh_omcrsp', { url: "/omcrsp", templateUrl: "templates/xSparsh/omcrsp.html", controller: 'xSparshRSPController' })
    .state('xSparsh_tradingsales', { url: "/tradingsales", templateUrl: "templates/xSparsh/tradingsales.html", controller: 'xSparshTASalesController' })
    .state('xSparsh_sales', { url: "/sales", templateUrl: "templates/xSparsh/sales.html", controller: 'xSparshSalesController' })
    
    .state('Customer_Data', { url: "/CData", templateUrl: "templates/CustomerData.html", controller: 'CustomerDataController' })
        
    .state('app.home', {
      url: '/Home',
      views: {
        'menuContent': {
          templateUrl: 'templates/Home.html',
          controller: 'MainController'
        }
      }
    })

    .state('app.consumer', {
      url: '/Consumer',
      views: {
        'menuContent': {
          templateUrl: 'templates/Consumer.html',
          controller: 'ConsumerController'
        }
      }
    })
    
    
    .state('RSHome', { url: "/rs/home", templateUrl: "templates/rs/home.html", controller: 'RSHomeController' })
    .state('RSProfile', { url: "/rs/profile", templateUrl: "templates/rs/profile.html", controller: 'RSProfileController' })
    .state('RSBalance', { url: "/rs/balance", templateUrl: "templates/rs/balance.html", controller: 'RSBalanceController' })
    .state('RSPayments', { url: "/rs/payments", templateUrl: "templates/rs/payments.html", controller: 'RSPaymentsController' })
    .state('RSRSP', { url: "/rs/rsp", templateUrl: "templates/rs/rsp.html", controller: 'RSRSPController' })
    .state('RSOrder', { url: "/rs/order", templateUrl: "templates/rs/order.html", controller: 'RSOrderController' })
    .state('RSRating', { url: "/rs/rating", templateUrl: "templates/rs/rating.html", controller: 'RSRatingController' })
    .state('RSDailySales', { url: "/rs/dailysales", templateUrl: "templates/rs/dailysales.html", controller: 'RSDailySalesController' })
    .state('RSHistSales', { url: "/rs/histsales", templateUrl: "templates/rs/histsales.html", controller: 'RSHistSalesController' })
    .state('RSPeriodSales', { url: "/rs/periodsales", templateUrl: "templates/rs/periodsales.html", controller: 'RSPeriodSalesController' })
    .state('RSCashless', { url: "/rs/cashless", templateUrl: "templates/rs/cashless.html", controller: 'RSCashlessController' })
    .state('RSMI', { url: "/rs/mi", templateUrl: "templates/rs/mi.html", controller: 'RSMIController' })
    .state('RSCustomerCentric', { url: "/rs/cc", templateUrl: "templates/rs/cc.html", controller: 'RSCustomerCentricController' })
    .state('RSStockData', { url: "/rs/stock", templateUrl: "templates/rs/stock.html", controller: 'RSStockDataController' })
    .state('RSPinReset', { url: "/rs/pinreset", templateUrl: "templates/rs/pinreset.html", controller: 'RSPinResetController' })
    .state('RSRDB', { url: "/rs/rdb", templateUrl: "templates/rs/rdb.html", controller: 'RSRDBController' })
    
    .state('LPGHome', { url: "/lpg/home", templateUrl: "templates/lpg/home.html", controller: 'LPGHomeController' })
    .state('LPGProfile', { url: "/lpg/profile", templateUrl: "templates/lpg/profile.html", controller: 'LPGProfileController' })
    .state('LPGDist', { url: "/lpg/dprofile", templateUrl: "templates/lpg/dprofile.html", controller: 'LPGDistController' })
    .state('LPGProfileSumary', { url: "/lpg/nfoprofile", templateUrl: "templates/lpg/nfoprofile.html", controller: 'LPGProfileSumaryController' })
    .state('LPGDistDB', { url: "/lpg/distdb", templateUrl: "templates/lpg/distdb.html", controller: 'LPGDistDBController' })
    .state('LPGBalance', { url: "/lpg/balance", templateUrl: "templates/lpg/balance.html", controller: 'LPGBalanceController' })
    .state('LPGSales', { url: "/lpg/sales", templateUrl: "templates/lpg/sales.html", controller: 'LPGSalesTrackerController' })
    .state('LPGOrder', { url: "/lpg/order", templateUrl: "templates/lpg/order.html", controller: 'LPGOrderController' })
    .state('LPGRTD', { url: "/lpg/rtd", templateUrl: "templates/lpg/rtd.html", controller: 'LPGRTDController' })
    .state('LPGEodStatus', { url: "/lpg/eod_status", templateUrl: "templates/lpg/eod_status.html", controller: 'LPGEodStatusController' })
    .state('LPGEodSummary', { url: "/lpg/eod_summary", templateUrl: "templates/lpg/eod_summary.html", controller: 'LPGEodSummaryController' })
    .state('LPGStock', { url: "/lpg/stock", templateUrl: "templates/lpg/stock.html", controller: 'LPGStockController' })
    .state('LPGNFRReport', { url: "/lpg/nfr", templateUrl: "templates/lpg/nfr.html", controller: 'LPGNFRController' })
    .state('LPGIndane', { url: "/lpg/indane", templateUrl: "templates/lpg/indane.html", controller: 'LPGIndaneController' })
    .state('LPGSocial', { url: "/lpg/social", templateUrl: "templates/lpg/social.html", controller: 'LPGSocialController' })

    .state('PTHome', { url: "/PT/home", templateUrl: "templates/PT/home.html", controller: 'PTcontrollers' })
    .state('PTPrice', { url: "/PT/price", templateUrl: "templates/PT/price.html", controller: 'PTPriceController' })
    .state('PTProfile', { url: "/PT/profile", templateUrl: "templates/PT/profile.html", controller: 'PTProfileController' })
    .state('PTBalance', { url: "/PT/balance", templateUrl: "templates/PT/balance.html", controller: 'PTBalanceController' })
    .state('PTStockData', { url: "/PT/stock", templateUrl: "templates/PT/stock.html", controller: 'PTStockController' })
    .state('PTdca', { url: "/PT/dcacreditlimit", templateUrl: "templates/PT/dcacreditlimit.html", controller: 'PTDCAController' })
    .state('PTdcaSales', { url: "/PT/dcasales", templateUrl: "templates/PT/dcasales.html", controller: 'PTDCASalesController' })
    .state('PTdopw', { url: "/PT/dopwsales", templateUrl: "templates/PT/dopwsales.html", controller: 'PTDOPWController' })
    .state('PTSales', { url: "/PT/sales", templateUrl: "templates/PT/sales.html", controller: 'PTSalesController' })
    .state('PTPayments', { url: "/PT/payments", templateUrl: "templates/PT/payments.html", controller: 'PTPaymentsController' })
    .state('PTOrder', { url: "/PT/order", templateUrl: "templates/PT/order.html", controller: 'PTOrderController' })
    .state('PTEqvt', { url: "/PT/eqvt", templateUrl: "templates/PT/eqvt.html", controller: 'PTEqvtController' })
    .state('PTCoP', { url: "/PT/cop", templateUrl: "templates/PT/cop.html", controller: 'PTCoPController' })
    
    /*
    .state('RSDailySales', { url: "/rs/dailysales", templateUrl: "templates/rs/dailysales.html", controller: 'RSDailySalesController' })
    .state('RSHistSales', { url: "/rs/histsales", templateUrl: "templates/rs/histsales.html", controller: 'RSHistSalesController' })
    .state('RSCashless', { url: "/rs/cashless", templateUrl: "templates/rs/cashless.html", controller: 'RSCashlessController' })
    .state('RSMI', { url: "/rs/mi", templateUrl: "templates/rs/mi.html", controller: 'RSMIController' })
    .state('RSCustomerCentric', { url: "/rs/cc", templateUrl: "templates/rs/cc.html", controller: 'RSCustomerCentricController' })
    .state('RSStockData', { url: "/rs/stock", templateUrl: "templates/rs/stock.html", controller: 'RSStockDataController' })
    .state('RSPinReset', { url: "/rs/pinreset", templateUrl: "templates/rs/pinreset.html", controller: 'RSPinResetController' })
    */
    
    
    .state('xsparsh.xSparsh_home', {
      url: '/Home',
      views: {
        'menuContent': {
          templateUrl: 'templates/xSparsh/Home.html',
          controller: 'xSparshMainController'
        }
      }
    });
  // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/login');
});
